var Feed = {
	upgrade: function(version) {

		var token = Validate.token();
		
		if (!token)
		{
			//Error.token();
		}
		else
		{
			var device = "Android";

			var args = "device="+device+"&version="+version+"&device_version="+$.os.version;
		
		 	$.ajax({
				url: host + "/helpers/upgrade?access_token="+token,
				type: "POST",
				data: args,
				timeout: 0,
				dataType: "json",
			    error: function(xhr,ajaxOptions, thrownError)
				{	
					//console.log("Error in checking Upgrade");
				},
				success: function(data)
				{
					if (data.meta.code == 200) {

						if (!data.response.up_to_date) {
							$("#notice-error").html('');

							var obj = {};
							obj["message"] = "There is a new version of Neuros for " + device + "! Touch the button below to upgrade.";
							//console.log(obj);

							/*var source   = $("#warning-template").html();
							var template = Handlebars.compile(source);*/

							var template = Handlebars.templates['upgrade-template.tmpl'];
							var html = template(obj);

							$("#notice-error").html(html);

							Util.openPop();
						}
					}
				}
			});
		}
	},
	recommend_after: function(a) {

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			ajaxStatement = $.ajax({
				url: host + "/beer/recommend?access_token="+token+"&limit=3&type_id="+a,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{	
					$("#recommend-bar").hide();
					$("#recommend-bar-area").html('');
					//Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						Template.recommend_after(data.response);
					}
					else
					{
						$("#recommend-bar").hide();
						$("#recommend-bar-area").html('');
						//Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	},
	check_in: function() {
		
		if (checkinProc && checkinProc.readyState != 4) {
			//console.log("already running");
			return false;
		}	

		if (phonegap) {
			progressHud.show("Checking In....")
		}
		

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var args = $("#confirm_form").serialize();
		
		 	checkinProc = $.ajax({
				url: host + "/checkin/add?access_token="+token,
				type: "POST",
				data: args,
				timeout: 0,
				dataType: "json",
			    error: function(xhr,ajaxOptions, thrownError)
				{	
					if (phonegap) {
						progressHud.hide();
					}
					
					
					if (xhr.responseText == "") {
						
						$("#notice-error").html('');

						var object = {};

						object["message"] = "Oh no! Something appeared to go wrong. Please try again or contact support.";

						/*var source   = $("#error-template").html();
						var template = Handlebars.compile(source);*/

						var template = Handlebars.templates['error-template.tmpl'];
						var html = template(object);

						$("#notice-error").html(html);

						Util.openPop();

						Util.closePopTimeout(3000);
						
					}
					else {
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					}
				},
				success: function(data)
				{
					if (phonegap) {
						progressHud.hide();
					}
					
					if (data.meta.code == 200)
					{
						$("#isRecommend").val("false");
						
						if (phonegap) {
							
							if (data.response.media.is_photo) {
								
								var fileURI = data.response.media.photo_data;
								
								var options = new FileUploadOptions();
								options.mimeType="image/jpeg";
								options.fileKey="file";
								//options.fileName=fileURI.substr(fileURI.lastIndexOf('/')+1);
								
							
								var params = new Object();
								params.checkin_id = data.response.checkin_id;
								params.photo_key = data.response.media.photo_key;
								params.user_id = data.response.user.uid;

								options.params = params;
								
								var photo_file = data.response.media.photo_data;
								
								var url_to = host + "/photo/add/"+data.response.checkin_id+"?access_token="+token;
								
								uploadProgress = setInterval("pBar.increase();",1000);

								var ft = new FileTransfer();

								/*ft.onprogress = function(progressEvent) {
								    if (progressEvent.lengthComputable) {
								      loadingStatus.setPercentage(progressEvent.loaded / progressEvent.total);
								    } else {
								      loadingStatus.increment();
								    }
								};*/
								
								ft.upload(photo_file, url_to, Photo.uploadGood, Photo.uploadBad, options);
							}
						}
						
						$("#cheersArea").html('');
						
						Page.change("#!/cheersArea", "push");
						//location.href = "#!/cheersArea";
						
						Template.cheers("cheersArea", data.response);
						
						if (!data.response.badge_valid) {
							Error.handle("It looks like you're device isn't near the location you chose. You're check-in will go through but no badges will be awarded.", "", "");
						}

						var bid = data.response.beer.bid;
						
						var id = $(".beer_recent:first").attr("id");
						
						var match = "recent_"+bid;
					
						var counter = 0;

						if ($("#recent_"+bid).length != 0) {
							$("div.beer_recent").each(function() {
								if ($(this).attr("id") == "recent_"+bid) {
									counter++;
								}
							});

							if (parseInt(counter) >= 2) {
								init.Recent();
							}
							else {

								$("div.beer_recent").each(function() {
									if ($(this).attr("id") == "recent_"+bid) {
										$(this).remove();
									}
								});

								var template = Handlebars.templates['single-beer-template.tmpl'];
								var html = template(data.response);

								html = '<div class="list_box beer_recent" id="recent_'+bid+'">'+html+'</div>';

								$("#drinkAreaContentArea").prepend(html);
							}
						}
						else {

							var template = Handlebars.templates['single-beer-template.tmpl'];
							var html = template(data.response);

							html = '<div class="list_box beer_recent" id="recent_'+bid+'">'+html+'</div>';

							$(".beer_recent:last").remove();

							$("#drinkAreaContentArea").prepend(html);

						}	
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
			
		}
	},
	notifications: function(a, b, c) {
		
		clearAjax();
		
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			if (a) {
	
			}
			else {
				var yourNotes = myStorage.view("yourNotes");

				if (!yourNotes) {

				}
				else {
					Template.notifications("notificationsAreaContent", yourNotes);
				}
			}

			$("#pendingNoticesIcon").remove();

			ajaxStatement = $.ajax({
				url: host + "/notifications?access_token="+token+"&limit=12",
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					Spinner.off();
					
					if (data.meta.code == 200)
					{
						var version = $.os.version;
						
						if (parseFloat(version) >= 4.0 && parseFloat(version) < 4.1) {
							$("#notify-popup").hide();
						}

						myStorage.save("yourNotes", data.response);
						Template.notifications("notificationsAreaContent", data.response, b);

					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
	},
	distinct_beer: function(a,b,c,d) {

		if (b || c) {

		}
		else {
			window.scroll(0,0);
		}
		
		var offset = 0;

		clearAjax();

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			if ($("#distinctAreaContent div.loading_inner").length != 0) {
				$("#currentFilter").val('');
			}

			if (a) {
				$("#badgeUserName").val(a);
			}
			else {
				a = $("#badgeUserName").val();
			}

			if (b) {
				$("#see_more_distinct").hide();
				$("#distinct_loader").show();
				a = $("#badgeUserName").val();
				offset = $(".distinct-beer-list").length;
			}
			else {

				$("#see_more_distinct").hide();

				$("#distinctAreaContent").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');

				offset = 0;
			}

			var txt = "";

			var sort = $("#currentFilter").val();

			if (sort != "") {
				txt = "&sort="+sort;
			}
			else {
				if (c) {
					txt = "&sort="+c;
				}
			}

			var search = "";

			if (d) {
				search = "&"+$("#distinctFormSearch").serialize();
			}


			ajaxStatement = $.ajax({
				url: host + "/user/beers/"+a+"?access_token="+token+"&limit=15&offset="+offset+txt+search,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (b) {
						$("#see_more_distinct").show();
						$("#distinct_loader").hide();
					}

					if (data.meta.code == 200)
					{
						if (data.response.count == 0) {
							$("#see_more_distinct").hide();
						}

						//console.log(myHistory);

						try {
							if (myHistory.slice(-1)[0] == "yourArea") {
								$("#prefixBeers").html("Your ");
							}
							else {
								$("#prefixBeers").html('');
							}
						}
						catch (err) {
							$("#prefixBeers").html('');
						}

						Template.distinct_beer("distinctAreaContent", data.response, b);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	},
	badge_single: function(a,b) {

		var j = $("#badgeDetails_"+b).html();

		//console.log($("#badgeDetails_"+b).length);

		if ($("#badgeDetails_"+b).length != 0)
		{
			var fix = JSON.parse(j);

			if (parseInt(a) == 0)
			{
				Template.badge_single("badgeSingle", fix, "unearned");

				clearAjax();

				var token = Validate.token();

				if (!token)
				{
					Error.token();
				}
				else
				{
					ajaxStatement = $.ajax({
						url: host + "/badges/status/"+b+"?access_token="+token,
						type: "GET",
						dataType: "json",
						error: function(xhr,ajaxOptions, thrownError)
						{
							Error.ajax_error(xhr, ajaxOptions, thrownError);
						},
						success: function(data)
						{
							if (data.meta.code == 200)
							{
								Template.badge_single("badgeSingle", data.response.badge, "unearned");
							}
							else
							{
								Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
							}
						}
					});
				}
			}
			else
			{
				Template.badge_single("badgeSingle", fix, "earned");

				clearAjax();

				var token = Validate.token();

				if (!token)
				{
					Error.token();
				}
				else
				{
					ajaxStatement = $.ajax({
						url: host + "/badges/view/"+a+"?access_token="+token,
						type: "GET",
						dataType: "json",
						error: function(xhr,ajaxOptions, thrownError)
						{
							Error.ajax_error(xhr, ajaxOptions, thrownError);
						},
						success: function(data)
						{
							if (data.meta.code == 200)
							{
								Template.badge_single("badgeSingle", data.response.badge, "earned");
							}
							else
							{
								Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
							}
						}
					});
				}
			}
		}
		else {

			Loading.on();

			clearAjax();

			var token = Validate.token();

			if (!token)
			{
				Error.token();
			}
			else
			{
				ajaxStatement = $.ajax({
					url: host + "/badges/view/"+a+"?access_token="+token,
					type: "GET",
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{
						Loading.off();

						if (data.meta.code == 200)
						{
							Template.badge_single("badgeSingle", data.response.badge, "earned");
						}
						else
						{
							Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
						}
					}
				});
			}
		}
	},
	user_badges: function(a,b,c,d) {
		
		clearAjax();
		
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#userBadgeAreaContent").html('');

			if (c == "tab") {
				a = $("#badgeUserName").val();
			
				$("#userBadges li a").removeClass("active");
				$(d).addClass('active');
				
				$("#userBadgeAreaContent").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');
			}
			else {
				$("#badgeUserName").val(a);
				$("#user_badge_area_loader").show();
			}
		
			
			ajaxStatement = $.ajax({
				url: host + "/user/badges/"+a+"?access_token="+token+"&type=all&sort="+b,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#user_badge_area_loader").hide();
					
					if (data.meta.code == 200)
					{	
						Template.user_badge("userBadgeAreaContent", data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
	},
	social_scanning: function(a, b) {
		
		$("#user_search_results_notice").hide();
		$("#social-scanning").hide();
		$("#invite-friends").hide();
	
		if (Social.scan_check(a)) {
			
			$("#friendSearchSocialContent").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');
			
			var token = Validate.token();

			if (!token)
			{
				Error.token();
			}
			else
			{
				if (!token)
				{
					Error.token();
				}
				else
				{
					ajaxStatement = $.ajax({
						url: host + "/search/social/"+a+"?access_token="+token,
						type: "GET",
						dataType: "json",
						error: function(xhr,ajaxOptions, thrownError)
						{
							Error.ajax_error(xhr, ajaxOptions, thrownError);
						},
						success: function(data)
						{
							if (data.meta.code == 200)
							{		
								if (data.response.friends.count == 0) {

									Page.change("#!/friendSearchArea", "push")
									//location.href = "#!/friendSearchArea";

									Error.handle("No friends were found social scan on "+a+". Perhaps you want to invite them, or try another social network to scan?", "", "");

									$("#user_search_results_notice").show();
									$("#friendSearchAreaResultsContent").html('');
									$("#social-scanning").show();
									$("#invite-friends").show();
								}
								else {
									Template.user_search("friendSearchSocialContent", data.response.friends);
								}
							}
							else
							{
								Page.change("#!/friendSearchArea", "push");
								Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
							}
						}
					});
				}
			}
		}
		else {
			Social.start_connect(a);
		}
	},
	user_search: function(a) {
	
		$("#user_search_results_notice").hide();
		$("#social-scanning").hide();
		$("#invite-friends").hide();
		
		Page.change("#!/friendSearchAreaResults", "push")

		//location.href = "#!/friendSearchAreaResults";
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var d = $(a).serialize();

			ajaxStatement = $.ajax({
				url: host + "/search/friends?access_token="+token,
				type: "GET",
				data: d,
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						
						$(".userSearchTerm").val('');
						
						$("#friendSearchAreaResultsContent").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>')
						
					
						if (data.response.users.count == 0) {
							$("#user_search_results_notice").html("<strong>No friends were found.</strong>Try again and remember to search by full name and user name. You can also scan your social networks below.");
							$("#user_search_results_notice").show();
							$("#friendSearchAreaResultsContent").html('');
							$("#social-scanning").show();
							$("#invite-friends").show();
							
						}
						else {
							Template.user_search("friendSearchAreaResultsContent", data.response.users);
						}
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
		return false;
	},
	brewery_search_more: function() {

		var offset = $(".brewery-search").length;

		$("#brewery_search_loader").show();
		$("#see_more_brewery_search").hide();

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var d = $("#searchMoreForm").serialize();
			
			var u = host + "/search/brewery?access_token="+token+"&"+d+"&offset="+offset;

			ajaxStatement = $.ajax({
				url: u,
				type: "GET",
				data: d,
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#brewery_search_loader").hide();
					$("#see_more_brewery_search").show();

					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#brewery_search_loader").hide();
					$("#see_more_brewery_search").show();

					if (data.meta.code == 200)
					{
						if (data.response.brewery.count == 0 && data.response.brewery.count == 0) {
							$("#see_more_brewery_search").hide();
						}

						Template.brewery_search_append("brewery-search-content", data.response);
						
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
		return false;

	},
	beer_search_more: function() {

		var offset = $(".beer-search").length;

		$("#beer_search_loader").show();
		$("#see_more_search").hide();

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var d = "q="+$("#hidden_q").val();
			
			var u = host + "/search/beer?access_token="+token+"&limit=15&offset="+offset;

			ajaxStatement = $.ajax({
				url: u,
				type: "GET",
				data: d,
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#beer_search_loader").hide();
					$("#see_more_search").show();

					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#beer_search_loader").hide();
					$("#see_more_search").show();

					if (data.meta.code == 200)
					{
						if (data.response.beers.count == 0 && data.response.beers.count == 0) {
							$("#see_more_search").hide();
						}

						Template.beer_search_append("searchAreaContent", data.response);
						
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
		return false;

	},
	beer_search: function(a) {
		
		Toggle.tabs($("#beer-search-tab-first"), 'search-tab-toggle', 'beer-search', 'beer-search-results-tab');
		
		$("#beer-search").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');
		
		var fromPage = $("#container div.active_page");

		var fromID = $(fromPage).attr("id");

		if (fromID == "drinkArea") {
			var v = $("#drinkArea .beerSearchTermSearch").val();
			$("#searchArea .beerSearchTermSearch").val(v);
		}

		Page.change("#!/searchArea", "push");
		//location.href = "#!/searchArea";

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var d = $(a).serialize();

			var actual_query = d.replace("q=", "");

			ajaxStatement = $.ajax({
				url: host + "/search/beer?access_token="+token+"&limit=15",
				type: "GET",
				data: d,
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						$("#hidden_q").val(actual_query);
						Template.beer_search("searchAreaContent", data.response, a);

					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
		return false;
		
		
	},
		wishlist: function(a,b,you) {

		//console.log(a + " " + b + " " + you);

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#activeUser").val(a);
			$("#activeUserYou").val(you);

			var endURL = "";

			if (b == "append") {

				var o = $("#wishListAreaContentArea div.user_wishlist_item").length;

				endURL = host + "/user/wishlist/"+a+"?access_token="+token+"&offset="+o+"&limit=15";

				$("#see_more_wish_list").hide();
				$("#see_more_wish_list_loader").show();

			}
			else {

				$("#wishListButtons").html('');

				$("#wishListAreaContentArea").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');

				endURL = host + "/user/wishlist/"+a+"?access_token="+token+"&limit=15";
			}

			ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#see_more_wish_list").hide();
					$("#see_more_wish_list_loader").show();

					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#see_more_wish_list_loader").hide();

					if (data.meta.code == 200)
					{
						if (data.response.beers.count == 0) {
							$("#see_more_wish_list").hide();
						}
						else {
							$("#see_more_wish_list").show();
						}

						var path = "wishListAreaContentArea";

						//console.log(data.response.beers);

						if (b == "append") {
							Template.user_wishlist(path, data.response.beers, a, "append", you);
						}	
						else {
							//console.log("full");
							Template.user_wishlist(path, data.response.beers, a, "full", you);
						}
						
					}
					else
					{
						$("#wishlist_stream_profile").hide();
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}

	},
	toastList: function(a, b) {

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#more_toastlist").hide();
			
			if (a) {
				$("#more_toastlist_loader").show();
				$("#more_toastlist").hide();
			}

			if ($("#toastListAreaContent div.loading_inner").length == 0) {
				$("#toastListAreaContent").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');
			}

			var offset = $("#toastListAreaContent .user_toast_item").length;

			if (offset == 0) {
				var urlR = host + "/checkin/viewtoasts/"+a+"?access_token="+token;
			}
			else {
				var urlR = host + "/checkin/viewtoasts/"+a+"?access_token="+token+"&offset="+offset;
			}
				
			ajaxStatement = $.ajax({
				url:  urlR,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#more_toastlist_loader").hide();
					$("#more_toastlist").show();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#more_toastlist_loader").hide();
					$("#more_toastlist").show();
					
					if (data.meta.code == 200)
					{
						console.log(data.response);

						if (a && data.response.toasts.count == 0) {
							$("#more_toastlist").hide();
						}

						Template.toasts("toastListAreaContent", data.response.toasts, a, b);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});

		}
	},
	recommend: function(a) {
		
		//window.scroll(0,0);
		//myScroll.scrollTo(0,0,0);

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{	
			$("#more_suggestions").hide();
			
			if (a) {
				$("#more_suggestions_loader").show();
				$("#more_suggestions").hide();

				var offset = $("#suggestAreaContent .user_wishlist_item").length;

				if (offset == 0) {
					var urlR = host + "/beer/recommend/?access_token="+token;
				}
				else {
					var urlR = host + "/beer/recommend/?access_token="+token+"&offset="+offset;
				}
			}	
			else {
				var urlR = host + "/beer/recommend/?access_token="+token;
			}
				
			ajaxStatement = $.ajax({
				url:  urlR,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#more_suggestions_loader").hide();
					$("#more_suggestions").show();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#more_suggestions_loader").hide();
					$("#more_suggestions").show();
					
					if (data.meta.code == 200)
					{
						if (a && data.response.beers.count == 0) {
							$("#more_suggestions").hide();
						}

						Template.recommend("suggestAreaContent", data.response.beers, a);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
			
		}
	},
	user_friends: function(a,b) {

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var endURL = "";

			if (b == "append") {

				$("#see_more_user_friends").hide();
				$("#see_more_user_friends_loader").show();

				var o = $("#userFriendListContentArea div.list_box").length;


				endURL = host + "/user/friends/"+a+"?access_token="+token+"&limit=12&offset="+o;
			}
			else {

				$("#userFriendsButtons").html('');

				$("#userFriendListContentArea").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');

				endURL = host + "/user/friends/"+a+"?access_token="+token+"&limit=12";
			}

			
			ajaxStatement = $.ajax({
				url: 'http://neuros.org/index.php?option=com_stories&view=stories&filter=leaders&format=json',
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#see_more_user_friends").show();
					$("#see_more_user_friends_loader").hide();

					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
					$("#see_more_user_friends_loader").hide();

					if (data)
					{
						//Notifications.set(data.notifications);

						friends = data;
console.log(friends);
						if (friends.data.length == 0) {
							$("#see_more_user_friends").show();
						}

						var path = "userFriendListContentArea";

						Template.user_friends(path, friends, a, b);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		
		}
	},
	//added by vissu
	get_stories: function(a,b) {

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var endURL = "";
			
				var owner = myStorage.view("currentUser");
				var id=owner.id;
			if (b == "append") {

				$("#see_more_user_friends").hide();
				$("#see_more_user_friends_loader").show();

				var o = $("#dashboardAreaContent_content div.list_box").length;

				console.log(o);
				endURL = host+"/index.php?option=com_stories&view=stories&filter=leaders&format=json&start="+o;
			}
			else {

				$("#userFriendsButtons").html('');

				$("#userFriendListContentArea").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');

				endURL = host+"/index.php?option=com_stories&view=stories&filter=leaders&format=json";
			}

			
			ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#see_more_user_friends").show();
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					if (data)
					{
						//Notifications.set(data.notifications);

						friends = data;

						if (friends.data.length == 0) {
							$("#see_more_user_friends").show();
						}

						var path = "userFriendListContentArea";

						Template.get_stories(path, friends, a, b);
						//Feed.get_addJson("#dashboardAreaContent_content","list_box");
						Ads.get_dashboard_ads();
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		
		
		if(id){
			ajaxStatement = $.ajax({
				url: host+"/index.php?option=com_groups&view=groups&format=json&oid="+id,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
					
					Spinner.off();
					if (data)
					{
						//Notifications.set(data.notifications);
						groups = data;
						var groupIds=[];
						for(var i=0;i<groups.data.length;i++){
							groupIds.push(groups.data[i].id);
						}
						myStorage.save("myGroups",  groupIds);
						
					}
					else
					{
						
					}
				}
			});
		}
		}
	},
	get_topics: function(a,b) {

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var endURL = "";
			if(a=="search"){
				$("#topicArea").addClass('show');
				a="";
			}
			if (b == "append") {

				$("#see_more_user_friends").hide();
				$("#see_more_user_friends_loader").show();

				var o = $("#topicAreaContent_content div.container").length;

				console.log(o);
				endURL = host+"/index.php?option=com_topics&view=topics&layout=gadget&format=json&start="+o;
			}
			else {

				$("#topicAreaSeeMore").html('');

				$("#topicAreaContent_content").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');

				endURL = host+"/index.php?option=com_topics&view=topics&layout=gadget&format=json";
			}

			if(!a){
				$('#topicArea .profile_top').remove();
				endURL+='&filter=leaders';
			}else{
				endURL+='&oid='+a;
			}
			ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#see_more_user_friends").show();
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					if (data)
					{
						//Notifications.set(data.notifications);

						friends = data;

						if (friends.data.length == 0) {
							$("#see_more_user_friends").show();
						}

						var path = "userFriendListContentArea";

						Template.get_topics(path, friends, a, b);
						//Feed.get_addJson("#topicAreaContent_content","container");
						Ads.get_topic_ads();
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	},
	get_actor: function(a,b) {
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			if(a && b){
				
				if ($('.active_page .profile_top').length > 0) {
					$('.active_page .profile_top').remove();
				}
				
				if ($('.profile_folow').length > 0) {
					$('.profile_folow').remove();
				}
			if(b=="group"){
				endURL=host+"/index.php?option=com_groups&view=group&id="+a;
			}else if(b=="person"){
				endURL=host+"/index.php?option=com_people&view=person&id="+a;
			}
			ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
					Spinner.off();
					if (data)
					{
						var html='<div class="profile_top"><span class="avatar_wrapper large">';
						html+='<a href="#!/actorArea/'+b+'/'+data.id+'">';
						if(data.imageURL.small){
							html+='<img width="100%" src="'+data.imageURL.small.url+'">';
						}else{
							html+='<img width="100%" src="assets/images/icon-profile.png">';
						}
						html+='</a></span>';
						html+='<div class="profile_details"><h1>'+data.name+'</h1>';
						
						if(data.body!=null){
							html+='<h2>'+data.body+'</h2>';
						}
						
						html+='</div></div>';
						var button='';
						if(data.commands.indexOf("follow")!=-1){
							button+='<div class="follow_loader follow_loader_'+data.id+' hide profile_folow" style="text-align: center;"><img src="assets/images/spinner.gif" width="24" height="24"></div>';
							button+='<div id="follow_action_'+data.id+'" class="profile_folow"><a onclick="Wish.follow('+data.id+', this,\''+data.objectType+'\');" data-analytics="wishList_follow" rel="action-btn" href="javascript:void(0);" class="yellow_btn small button"><span><strong>Follow</strong></span></a></div>';
							button+='<div id="unfollow_action_'+data.id+'" style="display:none" class="profile_folow"><a onclick="Wish.unfollow('+data.id+', this,\''+data.objectType+'\');" data-analytics="wishList_unfollow" rel="action-btn" href="javascript:void(0);" class="grey_btn small button"><span><strong>Unfollow</strong></span></a></div>';
						}else if(b=="person" && data.commands.indexOf("unfollow")!=-1){
							button+='<div class="follow_loader follow_loader_'+data.id+' hide profile_folow" style="text-align: center;"><img src="assets/images/spinner.gif" width="24" height="24"></div>';
							button+='<div id="follow_action_'+data.id+'" style="display:none" class="profile_folow"><a onclick="Wish.follow('+data.id+', this,\''+data.objectType+'\');" data-analytics="wishList_follow" rel="action-btn" href="javascript:void(0);" class="yellow_btn small button"><span><strong>Follow</strong></span></a></div>';
							button+='<div id="unfollow_action_'+data.id+'" class="profile_folow"><a onclick="Wish.unfollow('+data.id+', this,\''+data.objectType+'\');" data-analytics="wishList_unfollow" rel="action-btn" href="javascript:void(0);" class="grey_btn small button"><span><strong>Unfollow</strong></span></a></div>';
						}
						$('.active_page').prepend(html+button);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
			}
		}
	},
	get_photos: function(a,b) {

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var endURL = "";

			if (b == "append") {

				$("#see_more_user_friends").hide();
				$("#see_more_user_friends_loader").show();

				var o = $("#photoAreaContent_content div.container").length;

				console.log(o);
				endURL = host+"/index.php?option=com_photos&view=photos&layout=gadget&format=json&start="+o;
			}
			else {

				$("#photoAreaSeeMore").html('');

				$("#photoAreaContent_content").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');

				endURL = host+"/index.php?option=com_photos&view=photos&layout=gadget&format=json";
			}

			if(!a){
				$('#photoArea .profile_top').remove();
				endURL+='&filter=leaders';
			}else{
				endURL+='&oid='+a;
			}
			ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#see_more_user_friends").show();
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					if (data)
					{
						//Notifications.set(data.notifications);

						friends = data;

						if (friends.data.length == 0) {
							$("#see_more_user_friends").show();
						}

						var path = "userFriendListContentArea";

						Template.get_photos(path, friends, a, b);
						//Feed.get_addJson("#photoAreaContent_content","container");
						Ads.get_photo_ads();
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		
		}
	},
	get_pages: function(a,b) {

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var endURL = "";

			if (b == "append") {

				$("#see_more_user_friends").hide();
				$("#see_more_user_friends_loader").show();

				var o = $("#pageAreaContent_content div.container").length;

				console.log(o);
				endURL = host+"/index.php?option=com_pages&view=pages&layout=gadget&format=json&start="+o;
			}
			else {

				$("#pageAreaSeeMore").html('');

				$("#pageAreaContent_content").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');

				endURL = host+"/index.php?option=com_pages&view=pages&layout=gadget&format=json";
			}

			if(!a){
				$('#pageArea .profile_top').remove();
				endURL+='&filter=leaders';
			}else{
				endURL+='&oid='+a;
			}
			ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#see_more_user_friends").show();
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					if (data)
					{
						//Notifications.set(data.notifications);

						friends = data;

						if (friends.data.length == 0) {
							$("#see_more_user_friends").show();
						}

						var path = "userFriendListContentArea";

						Template.get_pages(path, friends, a, b);
						//Feed.get_addJson("#pageAreaContent_content","container");
						Ads.get_page_ads();
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		
		}
	},
	single_story: function(component,id) {
		if ($("#search").hasClass("show")) {
			$("#search").removeClass("show").addClass('hide');
		}
		$("#storyArea").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var endURL = "";
			if(component=="note"){
				endURL=host+"/index.php?option=com_notes&view=note&id="+id+"&format=json";
			}else if(component=="topic"){
				endURL=host+"/index.php?option=com_topics&view=topic&id="+id+"&format=json";
			}else if(component=="photo"){
				endURL=host+"/index.php?option=com_photos&view=photo&id="+id+"&format=json";
			}else if(component=="page"){
				endURL=host+"/index.php?option=com_pages&view=page&id="+id+"&format=json";
			}
			
			ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#see_more_user_friends").show();
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
					Page.change("#!/"+component+"Area","start");
				},
				success: function(data)
				{
					console.log(data);
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					if (data)
					{
						//Notifications.set(data.notifications);

						friends = data;

						if (friends.length == 0) {
							$("#see_more_user_friends").show();
						}

						var path = "userFriendListContentArea";
						
						Template.single_story(path, friends,component,id);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
			ajaxStatement = $.ajax({
				url: endURL+'&get=voters',
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#see_more_user_friends").show();
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
				}
			});
		}
	},
	get_comments: function(component,id) {

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var endURL = "";
			if(component=="note"){
				endURL=host+"/index.php?option=com_notes&view=note&id="+id+"&format=json&get=comments";
			}else if(component=="topic"){
				endURL=host+"/index.php?option=com_topics&view=topic&id="+id+"&format=json&get=comments";
			}else if(component=="photo"){
				endURL=host+"/index.php?option=com_photos&view=photo&id="+id+"&format=json&get=comments";
			}else if(component=="page"){
				endURL=host+"/index.php?option=com_pages&view=page&id="+id+"&format=json&get=comments";
			}
			ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#see_more_user_friends").show();
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					if (data)
					{
						//Notifications.set(data.notifications);

						comments = data;

						if (comments.length == 0) {
							$("#see_more_user_friends").show();
						}

						var path = "userFriendListContentArea";

						Template.story_comments(path, comments,component,id);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		
		}
	},
	story_comment: function(a) {
		
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var d = $(".comment-form").serializeArray();
			
			var postArray = {};

		    $.map(d, function(n, i){
		        postArray[n['name']] = n['value'];
		    });
		    console.log(postArray);
			if(postArray.comment!=''){
				$("#comment_inner_spinner").removeClass("hide");
				$(a).hide();
				//Page.change(d[0].value, "push");
				var pageUrl=postArray.storyUrl;
				var splitUrl=pageUrl.split('/');
				var component=splitUrl[2];
				var id=splitUrl[3];
				var cid=postArray.cid;
				
				var endURL = "";
				var args={_action:'addcomment',body:postArray.comment};
				if(component=="note"){
					endURL=host+"/index.php?option=com_notes&view=note&id="+id;
				}else if(component=="topic"){
					endURL=host+"/index.php?option=com_topics&view=topic&id="+id;
				}else if(component=="photo"){
					endURL=host+"/index.php?option=com_photos&view=photo&id="+id;
				}else if(component=="page"){
					endURL=host+"/index.php?option=com_pages&view=page&id="+id;
				}
				
				if(cid!=''){
					endURL+="&cid="+cid;
					var args={_action:'editcomment',body:postArray.comment};
				}
				ajaxStatement = $.ajax({
					url: endURL,
					type: "POST",
					data:args,
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						$("#comment_inner_spinner").addClass("hide");
						$(a).show();
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{
						$(".comment-form textarea").val('');
						$(".comment-form input#cid").val('');
						console.log(data);
						$("#comment_inner_spinner").addClass("hide");
						$(a).show();
						var comment_json = JSON.stringify(data);
						var comment='<div class="comment" id="comment_'+data.id+'">';
						if(data.body!=''){
							comment+='<a href="#!/actorArea/people/'+data.editor.id+'" class="avatar">';
							if(data.editor.imageURL.small){
								comment+='<img width="24" height="24" src="'+data.editor.imageURL.small.url+'">';
							}else{
								comment+='<img width="24" height="24" src="assets/images/icon-profile.png">';
							}
								comment+='</a><div class="text">';
								if(data.commands){
									comment+='<a onclick="Wish.action_commands('+data.id+')" rel="action-btn" href="javascript:void(0);" data-analytics="action_commands_btn" class="action_commands"></a>';
								}
								comment+='<strong>'+data.editor.name+': </strong>'+Replace.urlWithLink(data.body);
								comment+='<span class="time"><abbr class="timeago">few second ago</abbr></span>';
								comment+='</div><div id="commentprofile_'+data.id+'" style="display:none">'+comment_json+'</div></div>';
							$("#storyArea .storyArea_comments .comment_list").append(comment);  
						}
						//$("#storyArea").append('<div class="list_box">'+data.body+'</div>');
					}
				});
			}else{
				Feed.show_alert('Please enter text');
			}
		}
	},
	story_post: function(a,b) {
		
		
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#webintent_val").html('');
			var d = $(a).serializeArray();
			
			var postArray = {};

		    $.map(d, function(n, i){
		        postArray[n['name']] = n['value'];
		    });
		    console.log(postArray);
		    
			if(postArray.body!=''){
				
				$("#story_inner_spinner").removeClass("hide");
				Page.change(postArray.page, "push");
				if(b){
					var id=b;
				}else{
					var owner = myStorage.view("currentUser");
					var id=owner.id;
				}
				var endURL = host+"/index.php?option=com_notes&view=note&oid="+id;
				ajaxStatement = $.ajax({
					url: endURL,
					type: "POST",
					data:{body:postArray.body},
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						$("#story_inner_spinner").addClass("hide");
						console.log(xhr);
						$("#see_more_user_friends").show();
						$("#see_more_user_friends_loader").hide();
						Spinner.off();
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{
						$("#story_body").val('');
						$("#story_inner_spinner").addClass("hide");
						
						console.log(data);
						var htmlData='<div class="list_box"><div class="user-block">';
						htmlData+='<a href="#!/actorArea/people/'+data.author.id+'">';
						if(data.author.imageURL.small){
							htmlData+='<img width="42" height="42" src="'+data.author.imageURL.small.url+'" class="lazy avatar">';
						}else{
							htmlData+='<img width="42" height="42" src="assets/images/icon-profile.png" class="lazy avatar">';
						}
						htmlData+='</a></div><a href="#!/storyArea/note/'+data.id+'">'+data.author.name+'</a>';
						htmlData+='<a href="#!/storyArea/note/'+data.id+'"><div class="details"><div class="body">'+data.body+'</div></div></a><div class="when timeago">few seconds ago</div></div>';
						if(b)
						$("#actorArea_content .recent_activity").prepend(htmlData);
						else
						$("#dashboardAreaContent_content .comment_box").after(htmlData);
					}
				});
			}
		}
	},
	add_item: function(component,id){
		
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			$('#addAction').html('<div id="addActionLoader" class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');
			var info={};
						info['id']=id;
						info['component']=component;
			if(!id){
				var currentUser = myStorage.view("currentUser");
				var oid=currentUser.id;
				info['id']=oid;
			}
			var path="addItemArea";
			if(oid && component=="topic"){
			var endURL = host+"/index.php?option=com_groups&view=groups&format=json&oid="+oid;
			ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#see_more_user_friends").show();
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					if (data)
					{
						//Notifications.set(data.notifications);
						groups = data;
						console.log(groups.data.length);
						if (groups.data.length == 0) {
							//alert("you need to follow groups to post topics");
							$("#addAction").html('<div class="list"><div class="list_box"><a href="javsascript:void(0);" rel="action-btn" class="item"><img src="assets/images/no_results_icon.jpg"><div><h2>You need to follow groups to post questions</h2><h4></h4></div></a></div></div>');
						}else{

						var path = "userFriendListContentArea";
						
						info['groups']=groups.data;
						console.log(info);
						Template.add_item(path, info);
						}
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
			}else{
				Template.add_item(path, info);
			}
		}
	},
	add_item_post: function(id){
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#post_inner_spinner").removeClass("hide");
			var d = $(id).serializeArray();
			var post_array = {};

		    $.map(d, function(n, i){
		        post_array[n['name']] = n['value'];
		    });
			console.log(post_array);
			var addPost=false;

			if(id=='#topicForm'){
				
				var endURL=host+'/index.php?option=com_topics&view=topic&oid='+post_array.user_id;
				
				var args={oid:post_array.user_id,title:post_array.topic_title,body:post_array.topic_body,access:'public'};
				
				if(post_array.user_id!='' && post_array.topic_title!='' && post_array.topic_body!=''){
					var addPost=true;					
				}
				
				var redirectTo='#!/topicArea/'+post_array.user_id+'/group';
				
			}else if(id=='#pageForm'){
				
				var endURL=host+'/index.php?option=com_pages&view=page&oid='+post_array.user_id;
				
				var args={title:post_array.page_title,body:post_array.page_body,excerpt:post_array.page_excerpt,enabled:1,access:'public'};
				
				if(post_array.page_title!='' && post_array.page_body!=''){
					var addPost=true;					
				}
				
				var redirectTo='#!/pageArea';
				
			}
			if(addPost){
			ajaxStatement = $.ajax({
				url: endURL,
				type: "POST",
				data:args,
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#post_inner_spinner").addClass("hide");
					
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					
					$("#post_inner_spinner").addClass("hide");
					
					console.log(data);
					$(id)[0].reset();
					$('#addAction').html('');
					Page.change(redirectTo, "start");
				}
			});
			}else{
				Feed.show_alert('Fill all fields');
				$("#post_inner_spinner").addClass("hide");
			}
		}
	},
	actor_list: function(a){
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			if (a == "append") {
				$("#see_more_user_groups_loader").show();
				var o = $("#actorListContent_content div.list div.list_box").length;

				console.log(o);
				endURL = host+"/index.php?option=com_groups&view=groups&format=json&start="+o;
			}
			else {
				var endURL = host+"/index.php?option=com_groups&view=groups&format=json";
			}
			ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#actorListSeeMore").show();
					$("#see_more_user_groups_loader").hide();
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
					$("#see_more_user_groups_loader").hide();
					Spinner.off();
					if (data)
					{
						//Notifications.set(data.notifications);
						groups = data;
						console.log(groups.data.length);
						if (groups.data.length == 0) {
							//alert("No groups");
							$("#actorListSeeMore").hide();
						}else{

						var path = "groupListContentArea";
						Template.actor_list(path, groups,a);
						//Feed.get_addJson("#actorListContent_content div.list","list_box");
						Ads.get_actorList_ads();
						}
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	},
	actor_profile: function(component,id){
		if ($("#search").hasClass("show")) {
			$("#search").removeClass("show").addClass('hide');
		}
		$("#actorArea_content").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');
			
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			if(!id){
			var owner = myStorage.view("currentUser");
			id=owner.id;
			}
			if(component=="group"){
				endURL=host+"/index.php?option=com_groups&view=group&id="+id;
			}else if(component=="people"){
				endURL=host+"/index.php?option=com_people&view=person&id="+id;
			}
			ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
					Spinner.off();
					if (data)
					{
						var path = "groupListContentArea";
						Template.actor_profile(path, data,component,id);
						
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	},
	actor_profile_content: function(component,id,a){
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			$('#profileInfoArea').html('');
			if(!id){
				var owner = myStorage.view("currentUser");
				id=owner.id;
			}
			if(a=="append"){

				$("#see_more_user_feed").hide();
				$("#see_more_feed_loader").show();

				var o = $("#actorArea_content .recent_activity div.list_box").length;

				console.log(o);
				endURL = host+"/index.php?option=com_stories&view=stories&oid="+id+"&format=json&start="+o;
			}
			else{
			var endURL=host+"/index.php?option=com_stories&view=stories&format=json&oid="+id;
			}
			ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#see_more_user_feed").show();
					$("#see_more_feed_loader").hide();
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(object)
				{
					
					$("#see_more_feed_loader").hide();
					console.log(object);
					Spinner.off();
					if (object)
					{
						//Notifications.set(data.notifications);

						$("#see_more_user_feed").show();
						if (object.data.length == 0) {
						}

						var path = "userFriendListContentArea";

						Template.actor_profile_content(path, object,component,id);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
	},
	actor_profile_avatar: function(id){
		
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			
				endURL=host+"/index.php?option=com_people&view=person&edit=avatar&get=settings&id="+id;
				ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
					Page.change("#!/actorArea/people/"+id, "start");
				}
			});
		}
	},
	setupUser: function(){
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			
				endURL=host+"/index.php?option=com_people&view=person&format=json";
				ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
					myStorage.save("currentUser",  data);
				}
			});
		}
	},
	/*get_search: function(a){
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
		$('#search_loader').show();
		if(a!="append"){
			$('#searchAreaContent_content').html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><p>Loading...</p></div>');
		}
			var term=$("#search input").val();
			if(term!=''){
				$("#searchArea").addClass('show');
				
					var scope='topics.topic';
				var endURL=host+"/index.php?option=com_search&term="+term+"&scope="+scope+"&search_comments=1&format=json";
				
				if(a){
					$("#searchAreaSeeMore").hide();
					$("#see_more_search_loader").show();
					var o = $("#searchAreaContent_content div.container").length;
					endURL+="&start="+o
				}
				ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					//$("#searchAreaSeeMore").show();
					$("#see_more_search_loader").hide();
					$('#search_loader').hide();
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#searchAreaSeeMore").show();
					$("#see_more_search_loader").hide();
					console.log(data);
					$('#search_loader').hide();
					Spinner.off();
					if (data)
					{
						var path = "searchArea";
						scope=scope.split(".");
						Template.get_search(path, data,scope[0],a);
						
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
			}else{
				
			}
			
		}
	},*/
	get_search: function(a,b){
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var c='';
		$('#search_loader').show();
		if(a && a!="append"){
			$('#searchAreaContent_content').html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><p>Loading...</p></div>');
		}
			var term=$("#search input").val();
			if(term!=''){
				$("#searchArea").addClass('show');
				
					//var scope='topics.topic';
				var endURL=host+"/index.php?option=com_search&term="+term+"&search_comments=1&format=json";
				if(b=='scope'){
					
					c=$("#scope").val();
					endURL+="&scope="+c;
					$('#searchAreaContent_content .container').remove();
				}
				if(a=="append"){
					c=$("#scope").val();
					$("#searchAreaSeeMore").hide();
					$("#see_more_search_loader").show();
					var o = $("#searchAreaContent_content div.container").length;
					endURL+="&scope="+c+"&start="+o
				}
				ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					//$("#searchAreaSeeMore").show();
					$("#see_more_search_loader").hide();
					$('#search_loader').hide();
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#searchAreaSeeMore").show();
					$("#see_more_search_loader").hide();
					console.log(data);
					$('#search_loader').hide();
					Spinner.off();
					if (data)
					{
						var path = "searchArea";
						//scope=scope.split(".");
						Template.get_search(path, data,c,a);
						
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
			}else{
				
			}
			
		}
	},
	changeScope: function(){
		var scope=$('#scope').val();
		console.log(scope);
	},
	show_alert: function(text){
		if(text!=''){
			var obj = {};
			obj["message"] = text;
			
			var template = Handlebars.templates['warning-template.tmpl'];
			var html = template(obj);
			
			$("#notice-error").html(html);

			Util.openPop();

			Util.closePopTimeout(10000);
		}
	},
	show_error_alert: function(text){
		if(text!=''){
			var obj = {};
			obj["message"] = text;
			
			var template = Handlebars.templates['notice-template.tmpl'];
			var html = template(obj);
			
			$("#notice-error").html(html);

			Util.openPop();

			Util.closePopTimeout(10000);
		}
	},
	actor_profile_info: function(a){
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			$('#profileInfoArea').html('<div id="profileInfoAreaLoader" class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');
			var endURL=host+"/index.php?option=com_people&view=person&id="+a;
			ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
					Spinner.off();
					if (data)
					{
						var html='<div class="profile_top"><span class="avatar_wrapper large">';
						html+='<a href="#!/actorArea/people/'+data.id+'">';
						if(data.imageURL.small){
							html+='<img width="100%" src="'+data.imageURL.small.url+'">';
						}else{
							html+='<img width="100%" src="assets/images/icon-profile.png">';
						}
						html+='</a></span>';
						html+='<div class="profile_details"><h1>'+data.name+'</h1>';
						
						if(data.body!=null){
							html+='<h2>'+data.body+'</h2>';
						}
						if(data.information){
							html+="<table><tbody>";
							for(var key in data.information) {
								for(var key1 in data.information[key]) {
									if(data.information[key][key1]!='')
									html+='<tr><td><strong>'+key1+': </strong></td><td>'+data.information[key][key1]+'</td></tr>';
								}
							}
							html+="</tbody></table>";
						}
						html+='</div></div>';
						var button='';
						if(data.commands.indexOf("follow")!=-1){
							button+='<div class="follow_loader follow_loader_'+data.id+' hide profile_folow" style="text-align: center;"><img src="assets/images/spinner.gif" width="24" height="24"></div>';
							button+='<div id="follow_action_'+data.id+'" class="profile_folow"><a onclick="Wish.follow('+data.id+', this,\''+data.objectType+'\');" data-analytics="wishList_follow" rel="action-btn" href="javascript:void(0);" class="yellow_btn small button"><span><strong>Follow</strong></span></a></div>';
							button+='<div id="unfollow_action_'+data.id+'" style="display:none" class="profile_folow"><a onclick="Wish.unfollow('+data.id+', this,\''+data.objectType+'\');" data-analytics="wishList_unfollow" rel="action-btn" href="javascript:void(0);" class="grey_btn small button"><span><strong>Unfollow</strong></span></a></div>';
						}else if(data.commands.indexOf("unfollow")!=-1){
							button+='<div class="follow_loader follow_loader_'+data.id+' hide profile_folow" style="text-align: center;"><img src="assets/images/spinner.gif" width="24" height="24"></div>';
							button+='<div id="follow_action_'+data.id+'" style="display:none" class="profile_folow"><a onclick="Wish.follow('+data.id+', this,\''+data.objectType+'\');" data-analytics="wishList_follow" rel="action-btn" href="javascript:void(0);" class="yellow_btn small button"><span><strong>Follow</strong></span></a></div>';
							button+='<div id="unfollow_action_'+data.id+'" class="profile_folow"><a onclick="Wish.unfollow('+data.id+', this,\''+data.objectType+'\');" data-analytics="wishList_unfollow" rel="action-btn" href="javascript:void(0);" class="grey_btn small button"><span><strong>Unfollow</strong></span></a></div>';
						}
						$('#profileInfoArea').html(html+button);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
			/*for(var key in owner.information) {
				for(var key1 in owner.information[key]) {
					//console.log(key1+'='+owner.information[key][key1]); 
					$("#account-info-form #opensocial-"+key1).val(owner.information[key][key1]);
				}
			}*/
		}
	},
	friend_requests: function(a,b,c) {

		clearAjax();

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			if (a)
			{
				$("#more_friends").hide();
				$("#more_friends_list_loader").show();

				var offset = $("#currentFriendsArea div.list_box").length;

				ajaxStatement = $.ajax({
					url: host + "/user/friends?access_token="+token+"&offset="+offset,
					type: "GET",
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{
						$("#more_friends_list_loader").hide();
						$("#more_friends").show();

						if (data.meta.code == 200)
						{
							friends_more = data.response;
							Template.see_more_friends(friends_more);
						}
						else
						{
							Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
						}
					}
				});
			}
			else
			{
				var d = myStorage.view("myFriends");
				var pending = {};
				var friends = {};

				
				ajaxStatement = $.ajax({
					url: host + "/user/friends?access_token="+token+"&limit=15",
					type: "GET",
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{
						if (data.meta.code == 200)
						{
							friends = data.response;

							myStorage.save("myFriends", data.response);

							Template.just_friends("friendlistAreaContent", friends);

						}
						else
						{
							Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
						}
					}
				});


				ajaxStatement = $.ajax({
					url: host + "/user/pending?access_token="+token,
					type: "GET",
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{
						if (data.meta.code == 200)
						{
							pending = data.response;

							if (pending.count == 0) {
								$("#request_number").html("");
								$("#request_number").addClass("hide");
							}
							else {
								$("#request_number").html("("+pending.count+")");
								$("#request_number").removeClass("hide");
							}

							Template.pending_friends("friendlistAreaContent", null, pending, c);
						}
						else
						{
							Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
						}
					}
				});
			
				
			}
		}
	},
	resubmit: function(a,b) {
		
		$(".addLocationBtn").hide();
		
		//console.log(globalBID);
		
		clearAjax();
		
		$("#venue-search").hide();
		
		var l = JSON.parse($("#venuedetail_"+a).html());
		var j = JSON.parse($("#checkinbid_"+globalBID).html());
		
		var beerObj = {};
		
		beerObj["beer"] = j.beer;
		beerObj["brewery"] = j.brewery;
		beerObj["rating"] = j.rating;
		beerObj["venue"] = l;
		beerObj["is_loc"] = b;
		
		Template.resubmit(beerObj);
	},
	foursquare_venue_recent: function(position) {

		clearTimeout(locationTimeout);

		Geolocate.save(position);

		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			currentLat = position.coords.latitude;
			currentLng = position.coords.longitude;
			
			var d = new Date();
			var n = d.getTime();
			
			lastUpdated = n;

			if (currentLat == "" || currentLat == "") {

				Error.handle("We couldn't seem to locate you. Please try again or visit http://untp.it/gps for tips on how to fix this issue.", "Error", 500);

			}
			else {
				Template.venue_location("locationAreaContent", position.items, true);
			}
		}

	},
	foursquare_venues: function(position, a) {
		
		clearTimeout(locationTimeout);
		clearTimeout(locationMessageTimeout);

		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			if (position.coords) {

				Geolocate.save(position);

				currentLat = position.coords.latitude;
				currentLng = position.coords.longitude;
				
				var d = new Date();
				var n = d.getTime();
				
				lastUpdated = n;

				if (currentLat == "" || currentLat == "") {

					Error.handle("We couldn't seem to locate you. Please try again or visit http://untp.it/gps for tips on how to fix this issue.", "Error", 500);

				}
				else {

					ajaxStatement = $.ajax({
						url: host + "/venue/around?lat="+position.coords.latitude+"&lng="+position.coords.longitude+"&access_token="+token,
						type: "GET",
						dataType: "json",
					    error: function(xhr,ajaxOptions, thrownError)
						{
							Loading.off();
							
							Error.ajax_error(xhr, ajaxOptions, thrownError);
						},
						success: function(data)
						{
							Loading.off();
							
							if (data.meta.code == 200)
							{
								var obj = {
									coords: {
										latitude: currentLat,
										longitude: currentLng
									},
									items: data.response
								};

								memcache.set("recentLocations", JSON.stringify(obj), 600);

								Template.venue_location("locationAreaContent", data.response, true);
							}
							else
							{
								Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
							}
						}
					});

				}
			}
			else {
				$("#locationAreaContent").html("");
				Error.show("We couldn't obtain your location. Double check your location settings on your device. The error received was: " + lastKnownGeoError);
			}
		}
	},
	foursquare_venue_search: function(lat, lng, term) {

		var fromPage = $("#container div.active_page");

		var fromID = $(fromPage).attr("id");

		if (fromID == "locationArea") {

			var v = $("#locationArea .locationSearchTerm").val();

			$("#searchlocationArea .locationSearchTerm").val(v);
		}
		
		Page.change("#!/searchlocationArea", "push");

		clearTimeout(locationTimeout);
		clearTimeout(locationMessageTimeout);
		
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			if (lat != "" && lng != "") {

				ajaxStatement = $.ajax({
					url: host + "/venue/around?"+term+"&lat="+lat+"&lng="+lng+"&access_token="+token,
					type: "GET",
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{
						if (data.meta.code == 200)
						{
							$("#searchlocationAreaContent").html("");
							Template.venue_location("searchlocationAreaContent", data.response);
						}
						else
						{
							Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
						}
					}
				});
			}
			else {
				$("#searchlocationAreaContent").html("");
				Error.show("We couldn't obtain your location. Double check your location settings on your device. The error received was: " + lastKnownGeoError);
			}
		}
		
	
	},
	around_me: function(position) {
		
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			if (position.coords) {

				$("photoAreaContent_content").show();

				Geocode.reverse(position.coords.latitude, position.coords.longitude);
				
				ajaxStatement = $.ajax({
					url: host + "/thepub/local?limit=15&lat="+position.coords.latitude+"&lng="+position.coords.longitude+"&access_token="+token,
					type: "GET",
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{
						if (data.meta.code == 200)
						{
							Template.friend("photoAreaContent_content", data);
						}
						else
						{
							Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
						}
					}
				});
			}
			else {
				$("#photoAreaContent_content").hide();
				Error.show("We couldn't obtain your location. Double check your location settings on your device. The error received was: " + lastKnownGeoError);
			}
		}
		
	},
	media_single: function(a,b) {
		
		if (b == "single") {
			var j = $("#singlePhoto_"+a).html();

			if (j != "")
			{
				var fix = JSON.parse(j);

				Template.photo_single("photosSingleArea", fix);
			}
		}
		else if (b == "user") {
			var j = $("#photocheckinuser_"+a).html();

			if (j != "")
			{
				var fix = JSON.parse(j);

				Template.photo_single("photosSingleArea", fix);
			}
		}
		else if (b == "beer") {
			var j = $("#photocheckinbeer_"+a).html();

			if (j != "")
			{
				var fix = JSON.parse(j);

				Template.photo_single("photosSingleArea", fix);
			}
		}
		else if (b == "venue") {
			var j = $("#photocheckinvenue_"+a).html();

			if (j != "")
			{
				var fix = JSON.parse(j);

				Template.photo_single("photosSingleArea", fix);
			}
		}
		else {
			var j = $("#photocheckinbrewery_"+a).html();

			if (j != "")
			{
				var fix = JSON.parse(j);

				Template.photo_single("photosSingleArea", fix);
			}
		}
		
	},
	media: function(a,b,c) {
		
		clearAjax();
				
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var get_url;
			
			if (c) {
				
			}
			else {
				$("#photosGalleryArea").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');
			}
			
			$("#see_more_photos").hide();
			$("#more_photo_loader").show();
			
			if (a == "user")
			{
				if (c) 
				{
					get_url = host + "/user/photos/"+b+"?access_token="+token+"&limit=12&max_id="+c;
				}
				else
				{
					get_url = host + "/user/photos/"+b+"?access_token="+token+"&limit=12";
				}
			}
			else if (a == "beer")
			{
				if (c) {
					get_url = host + "/beer/photos/"+b+"?access_token="+token+"&max_id="+c+"&limit=12";
				}
				else
				{
					get_url = host + "/beer/photos/"+b+"?access_token="+token+"&limit=12";
				}
			}
			else if (a == "venue")
			{
				if (c) {
					get_url = host + "/venue/photos/"+b+"?access_token="+token+"&max_id="+c+"&limit=12";
				}
				else
				{
					get_url = host + "/venue/photos/"+b+"?access_token="+token+"&limit=12";
				}
			}
			else
			{
				if (c) {
					get_url = host + "/brewery/photos/"+b+"?access_token="+token+"&max_id="+c+"&limit=12";
				}
				else
				{
					get_url = host + "/brewery/photos/"+b+"?access_token="+token+"&limit=12";
				}
			}

			ajaxStatement = $.ajax({
				url: get_url,
				type: "GET",
				dataType: "json",
			    error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
					$("#more_photo_loader").hide();
				},
				success: function(data)
				{
					$("#more_photo_loader").hide();
					
					if (data.meta.code == 200)
					{
						if (data.response.count != 0) {
							$("#see_more_photos").show();
						}

						Template.photo_gallery("photosGalleryArea", data.response, a, b, c);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
			
		}
		
		
	},
	more_public: function(a) {
		
		clearAjax();
				
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#see_more_pub").hide()
			$("#see_more_pub_loader").show();

			var a = $("#topicAreaContent_content div.activity_item:last").attr("data-checkin-id");

			ajaxStatement = $.ajax({
				url: host + "/thepub?access_token="+token+"&max_id="+a,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#see_more_pub").show();
					$("#see_more_pub_loader").hide();
					
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#see_more_pub").show();
					$("#see_more_pub_loader").hide();

					if (data.meta.code == 200)
					{
						Template.pub("topicAreaContent_content", data.response, true);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
		
	},
	pub: function(a) {
		console.log('hello pub');
		$(".location_bar").hide();
		
		clearAjax();
				
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var publicFeed = myStorage.view("publicFeed");
			
			if (a) {
				
			}
			else {
				var publicFeed = myStorage.view("publicFeed");

				if (!publicFeed) {
				
				}
				else {
					Template.friend("topicAreaContent_content", publicFeed);
				}
			}
			
			ajaxStatement = $.ajax({
				url: host + "/thepub?access_token="+token,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					Spinner.off();
					
					if (data.meta.code == 200)
					{
						myStorage.save("publicFeed",  data);
						Template.pub("topicAreaContent_content", data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
	},
	more_friends: function(b) {

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$(b).hide();
			$("#more_friends_loader").show();
			
			var a = $("#dashboardAreaContent_content div.activity_item:last").attr("data-checkin-id");

			ajaxStatement = $.ajax({
				url: host + "/checkin/recent?access_token="+token+"&max_id="+a,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#more_friends_loader").hide();
					$(b).show();
					
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#more_friends_loader").hide();
					
					
					if (data.meta.code == 200)
					{
						if (data.response.checkins.count == 0) {
							$(b).hide();
						}
						else {
							$(b).show();
						}
						
						Template.friend("dashboardAreaContent_content", data, "append");
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
	},
	find_beer: function(position) {
		
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			currentLat = position.coords.latitude;
			currentLng = position.coords.longitude;
			
			Geocode.reverse(currentLat, currentLng);
			
			var dis = myStorage.view("distanceBeer");
			var rad = 5;
			
			if (!dis) {
				rad = 5;
			}	
			else {
				rad = dis;
			}
			
			$("#findBeerAreaContent").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');
			
			ajaxStatement = $.ajax({
				url: host + "/beer/find/"+findBeer+"?access_token="+token+"&lat="+currentLat+"&lng="+currentLng+"&radius="+rad,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						
						Template.find_beer("findBeerAreaContent", data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
	},
	venue_full: function(a) {

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			ajaxStatement = $.ajax({
				url: host + "/venue/info/"+a+"?access_token="+token,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						Template.venue_full("venueArea", data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}

	},
	venue: function(a,b,c) {
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			if (c == "discoverBeer") {
				
				var j = $("#discoverBeer_"+b).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.venue("venueArea", fix, true);
				}
				
			}
			else if (c == "photo_single") {
				var j = $("#photocheckin_"+b).html();

				if (j != "")
				{
					var fix = JSON.parse(j);
					
					Template.venue("venueArea", fix, true);
				}
			}
			else if (c == "venueStats") {
				
				var j = $("#venueStats_"+a).html();

				if (j != "")
				{
					var fix = JSON.parse(j);
					
					Template.venue("venueArea", fix, true);
				}
				
			}
			else if (c == "cheers") {

				var j = $("#cheersvenue_"+a).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					//console.log(fix);

					Template.venue("venueArea", fix, true);
				}

			}
			else if (c == "map") {
				
				var j = $("#mapvenue_"+a).html();

				if (j != "")
				{
					var fix = JSON.parse(j);
					
					Template.venue("venueArea", fix, true);
				}
				
			}
			else if (c == "discoverVenues") {
				
				var j = $("#discoverVenue_"+a).html();

				if (j != "")
				{
					var fix = JSON.parse(j);
					
					//console.log(fix);
					
					Template.venue("venueArea", fix, true);
				}
				
			}
			else if (c == "badgedetail") {

				var j = $("#venuebadge_"+a).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.venue("venueArea", fix, true);
				}

			}
			else {
				var j = $("#checkindetail_"+b).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.venue("venueArea", fix, true);
				}
			}
			
			ajaxStatement = $.ajax({
				url: host + "/venue/info/"+a+"?access_token="+token,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						Template.venue("venueDetailsArea", data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});	
		}
	},
	friends: function(refresh, start) {
		$(".location_bar").hide();

		if (start == "start") {
			Loading.on();
		}

		clearAjax();

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var friendFeed = myStorage.view("currentUser");

			if (!friendFeed) {

				ajaxStatement = $.ajax({
					//url: host + "/checkin/recent?limit=15&access_token="+token,
					url:'http://neuros.org/index.php?option=com_stories&view=stories&filter=leaders&format=json',
					type: "GET",
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{
						//console.log("data done stored");

						if (data)
						{
							/*Notifications.set(data.notifications);
							Notifications.friends();*/

							Spinner.off();

							Loading.off();

							myStorage.save("currentUser",  data);
							Template.friend("dashboardAreaContent_content", data);

							//Garbage.remove('activity_stream');
						}
						else
						{
							Loading.off();
							Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
						}
					}
				});
			}
			else
			{

				if ($("#dashboardAreaContent_content .activity_item").length == 0) {
					Template.friend("dashboardAreaContent_content", friendFeed);
				}

				if (refresh) {
					ajaxStatement = $.ajax({
						//url: host + "/checkin/recent?limit=15&access_token="+token,
						url:'http://neuros.org/index.php?option=com_stories&view=stories&filter=leaders&format=json',
						type: "GET",
						dataType: "json",
						error: function(xhr,ajaxOptions, thrownError)
						{
							Error.ajax_error(xhr, ajaxOptions, thrownError);
						},
						success: function(data)
						{
							if (data)
							{
								/*Notifications.set(data.notifications);
								Notifications.friends();*/
								
								myStorage.save("currentUser", data);
					
								$(data).each(function(i, items) {
									if (items.length != 0) {
										////console.log("#checkinid_"+items.checkin_id + " doesn't exist");
										////console.log("new " + items.checkin_id);
										var template = Handlebars.templates['activity-single-template.tmpl'];
										var html = template(items);
										var id;

										var done = "true";

										$("#dashboardAreaContent_content div.activity_item").each(function() {

											var check_in_id = parseInt($(this).attr("data-checkin-id"));

											if (check_in_id < items.checkin_id && done == "true") {
												////console.log($(this).attr("data-checkin-id") + " < " + items.checkin_id);
												$(this).before(html);
												$("#dashboardAreaContent_content .activity_item:last").remove();
												done = "false";
											}
										});

									}
									else {
										jsonAppended = false;

										var currentFriendship = $("#checkinid_"+items.checkin_id + " .relationshipAction").attr("data-friendship-status");
										var currentToast = $("#checkinid_"+items.checkin_id + " .relationshipAction").attr("data-toast-status");

										if (currentFriendship != items.user.relationship) {
											////console.log("friend relationship changed " + items.checkin_id)
											var template = Handlebars.templates['activity-action-template.tmpl'];
											var html = template(items);

											$("#checkinid_"+items.checkin_id + " .relationshipAction").html(html);

											var jsonString = JSON.stringify(items);

											$("#checkindetail_"+items.checkin_id).html(jsonString);

											jsonAppended = true;
										}

										var commentCount = $("#checkinid_"+items.checkin_id + " .comment_list").attr("data-comment-count");

										if (parseInt(commentCount) != items.comments.count) {
											////console.log("new comments for " + items.checkin_id)
											var template = Handlebars.templates['activity-comment-template.tmpl'];
											var html = template(items);

											$("#checkinid_"+items.checkin_id + " .comment_list").attr("data-comment-count", items.comments.count);
											$("#checkinid_"+items.checkin_id + " .comment_list").html(html);

											if (!jsonAppended) {
												var jsonString = JSON.stringify(items);
												$("#checkindetail_"+items.checkin_id).html(jsonString);
												jsonAppended = true;
											}
										}

										if ($("#checkinid_"+items.checkin_id + " .comment_list").attr("data-toast-count") == "") {
											////console.log($("#checkinid_"+items.checkin_id + " .comment_list"));
										}	
										else {
											var toastCount = $("#checkinid_"+items.checkin_id + " .comment_list").attr("data-toast-count");

											////console.log("tC: " + $("#checkinid_"+items.checkin_id + " .comment_list").attr("data-toast-count"));

											////console.log("TC for " + items.checkin_id + " is " + toastCount);
											if (parseInt(toastCount) != items.toasts.count) {
												////console.log("new toasts for " + items.checkin_id)
												var template = Handlebars.templates['toast-feed-template.tmpl'];
												var html = template(items);

												$("#checkinid_"+items.checkin_id + " .comment_list").attr("data-toast-count", items.toasts.count);
												$("#checkintoast_"+items.checkin_id).html(html);
												////console.log("toasted");

												if (!jsonAppended) {
													var jsonString = JSON.stringify(items);
													$("#checkindetail_"+items.checkin_id).html(jsonString);
												}
											}
										}
										

									}

								});

								$(".timeago").cuteTime({ refresh: 50000 });

								refreshScroll.go();

								Loading.off();
							}
							else
							{
								Loading.off();
								Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
							}
						}
					});
				}
			}
		}

	},
	your_profile: function(a) {

		clearAjax();

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			Spinner.on();

			if (a) {

			}
			else {

				if ($("#yourArea").html() == "") {

					var yourProfile = myStorage.view("yourProfile");

					if (!yourProfile) {

					}
					else {
						Template.your_full_profile("yourAreaContent", yourProfile);
					}
				}
			}

			ajaxStatement = $.ajax({
				url: host + "/user/info?access_token="+token,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					Spinner.off();

					if (data.meta.code == 200)
					{
						Pending.friends();
						Notifications.set(data.notifications);
						myStorage.save("yourProfile", data.response);

						if (a) {
							Template.your_full_profile("yourAreaContent", data.response);
						}
						else {
							Template.your_profile("yourProfileDetails", data.response);
						}
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	},
	profile: function(user, checkin_id, loc) {
		
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var method = true;

			$("#activeUser").val(user);
			$("#activeUserYou").val("false");

			if (loc == "pending")
			{
				var j = $("#pendingFriend_"+checkin_id).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.profile("profileArea", fix, true);
				}
			}
			else if (loc == "toastList") {
				var j = $("#friendtoastlist_"+checkin_id).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.profile("profileArea", fix, true);
				}
			}
			else if (loc == "friends") {
				var j = $("#currentFriend_"+checkin_id).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.profile("profileArea", fix, true);
				}
			}
			else if (loc == "toast") {
				var j = $("#toastprofile_"+checkin_id).html();

				if (j != "")
				{
					var fix = JSON.parse(j);
					
					Template.profile("profileArea", fix, true);
				}
			}
			else if (loc == "comment") {
				var j = $("#commentprofile_"+checkin_id).html();

				if (j != "")
				{
					var fix = JSON.parse(j);
					
					Template.profile("profileArea", fix, true);
				}
			}
			else if (loc == "friend_list") {
				var j = $("#userfrienddetaiL_"+checkin_id).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.profile("profileArea", fix, true);
				}
			}
			else if (loc == "full") {
				method = false;
				Feed.profile_full(user);
			}
			else {			
				if (checkin_id) {
					var j = $("#checkindetail_"+checkin_id).html();

					if (j != "")
					{
						var fix = JSON.parse(j);

						Template.profile("profileArea", fix, true);
					}
				}
				else {
					$("#profileArea").html('');
				}
			}
			
		
			if (method) {
				ajaxStatement = $.ajax({
					url: host + "/user/info/"+user+"?access_token="+token,
					type: "GET",
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{
						Spinner.off();
						
						if (data.meta.code == 200)
						{
							Notifications.set(data.notifications);
							
							Template.profile("profileDetailsArea", data.response);
						}
						else
						{
							Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
						}
					}
				});
			}
			
		}
	},
	profile_full: function(user) {

		clearAjax();

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			ajaxStatement = $.ajax({
				url: host + "/user/info/"+user+"?access_token="+token,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						Notifications.set(data.notifications);

						Template.profile_full("profileArea", data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});

		}
	},
	more_user_activity: function(user) {
	
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#user_activity_loader").show();
			$("#see_more_user_activity").hide();
			
			var offset = $("#activity_stream_profile_content div.activity_item:last").attr("data-checkin-id");
			
			ajaxStatement = $.ajax({
				url: host + "/user/checkins/"+user+"?access_token="+token+"&max_id="+offset,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#user_activity_loader").hide();
					$("#see_more_user_activity").show();
					
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#user_activity_loader").hide();
					$("#see_more_user_activity").show();
					
					if (data.meta.code == 200)
					{
						if (data.response.checkins.count == 0) {
							$("#see_more_user_activity").hide();
						}
						
						Template.profile_activity(data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	
		
	},
	stats_new_beers: function(a) {

		clearAjax();

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var age = $("#ageParam").val();

			var urlToGo = host + "/user/stats/new_beers?access_token="+token+"&age="+age;

			if (a) {

				$("#see_more_new_beers").hide();
				$("#see_more_new_beers_loader").show();

				var offset = $("#statsAreaNewBeersContent div.list_box").length;

				urlToGo = host + "/user/stats/new_beers?access_token="+token+"&age="+age+"&offset="+parseInt(offset);
			}

			$(".ageCount").html(age);

			ajaxStatement = $.ajax({
				url: urlToGo,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					if (a) {
						$("#see_more_new_beers").show();
						$("#see_more_new_beers_loader").hide();
					}

					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#see_more_new_beers_loader").hide();

					if (data.meta.code == 200)
					{
						if (data.response.beers.count == 0) {
							$("#see_more_new_beers").hide();
						}
						else {
							$("#see_more_new_beers").show();
						}

						Template.stats_new_beers("statsAreaNewBeersContent", data.response, a);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	},
	stats_new_venues: function(a) {

		clearAjax();

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var age = $("#ageParam").val();

			var urlToGo = host + "/user/stats/new_venues?access_token="+token+"&age="+age;

			if (a) {

				$("#see_more_new_venues").hide();
				$("#see_more_new_venues_loader").show();

				var offset = $("#statsAreaNewVenuesContent div.list_box").length;

				urlToGo = host + "/user/stats/new_venues?access_token="+token+"&age="+age+"&offset="+parseInt(offset);
			}

			$(".ageCount").html(age);

			ajaxStatement = $.ajax({
				url: urlToGo,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					if (a) {
						$("#see_more_new_venues").show();
						$("#see_more_new_venues_loader").hide();
					}

					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#see_more_new_venues_loader").hide();

					if (data.meta.code == 200)
					{
						if (data.response.venues.count == 0) {
							$("#see_more_new_venues").hide();
						}
						else {
							$("#see_more_new_venues").show();
						}
						
						Template.stats_new_venues("statsAreaNewVenuesContent", data.response, a);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	},
	stats_beer_styles: function(a, append) {

		clearAjax();

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var j = $("#beerstylesinfo_"+a).html();

			if (j != "")
			{
				var fix = JSON.parse(j);

				$(".styleName").html(fix.beer_style);
			}

			var age = $("#ageParam").val();

			var urlToGo = host + "/user/stats/top_beers_by_style?access_token="+token+"&age="+age+"&type_id="+a;

			if (append) {

				$("#see_more_new_styles").hide();
				$("#see_more_new_styles_loader").show();

				var offset = $("#statsAreaBeerStyleContent  div.list_box").length;

				urlToGo = host + "/user/stats/top_beers_by_style?access_token="+token+"&age="+age+"&offset="+parseInt(offset)+"&type_id="+a;
			}

			$(".ageCount").html(age);

			ajaxStatement = $.ajax({
				url: urlToGo,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					if (a) {
						$("#see_more_new_styles").show();
						$("#see_more_new_styles_loader").hide();
					}

					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#see_more_new_styles_loader").hide();

					if (data.meta.code == 200)
					{
						if (data.response.beers.count == 0) {
							$("#see_more_new_styles").hide();
						}
						else {
							$("#see_more_new_styles").show();
						}
						
						Template.stats_beer_styles("statsAreaBeerStyleContent", data.response, a, append);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	},
	stats: function(a) {

		clearAjax();

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			Util.closePop();

			var statsURL = host + "/user/stats/?access_token="+token;

			if (a) {

				myStorage.save("statsRangeSettings", a);

				statsURL = host + "/user/stats/?access_token="+token+"&age="+a;

				$("#ageStats").html(a);

				$(".ageCount").html(a);

				$("#ageParam").val(a);
			}
			else {

				myStorage.save("statsRangeSettings", 30);

				$("#ageStats").html(30);

				$("#ageParam").val(30);
			}

			ajaxStatement = $.ajax({
				url: statsURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						Template.stats("statsAreaContent", data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}

	},
	full_activity: function(user) {

		clearAjax();

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			ajaxStatement = $.ajax({
				url: host + "/user/checkins/"+user+"?access_token="+token,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#activity_loader").hide();
					$("#see_more_activity").show();

					if (data.meta.code == 200)
					{
						if (data.response.checkins.count == 0) {
							$("#see_more_activity").hide();
						}

						Template.profile_activity("listCheckinsAreaContentArea", data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}


	},
	more_activity: function(user) {

		clearAjax();

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#see_more_activity").hide();
			$("#activity_loader").show()

			var offset = $("#listCheckinsAreaContentArea div.activity_item:last").attr("data-checkin-id");

			ajaxStatement = $.ajax({
				url: host + "/user/checkins/"+user+"?access_token="+token+"&max_id="+offset,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#activity_loader").hide();
					$("#see_more_activity").show();
					

					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#activity_loader").hide();
					$("#see_more_activity").show();

					if (data.meta.code == 200)
					{
						if (data.response.checkins.count == 0) {
							$("#see_more_activity").hide();
						}

						Template.profile_activity("listCheckinsAreaContentArea", data.response, "append");
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}


	},
	beer_activity: function(bid) {
	
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#beer_activity_loader").show();
			$("#see_more_beer_activity").hide();
			
			var offset = $("#beer_stream_profile_content div.activity_item:last").attr("data-checkin-id");
			
			ajaxStatement = $.ajax({
				url: host + "/beer/checkins/"+bid+"?access_token="+token+"&max_id="+offset,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#beer_activity_loader").hide();
					$("#see_more_beer_activity").show();
					
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#beer_activity_loader").hide();
					$("#see_more_beer_activity").show();
					
					if (data.meta.code == 200)
					{
						if (data.response.checkins.count == 0) {
							$("#beer_activity_loader").hide();
						}
						
						Template.beer_activity(data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	
		
	},
	venue_activity: function(vid) {
	
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#venue_activity_loader").show();
			$("#see_more_venue_activity").hide();
			
			var offset = $("#venue_stream_profile_content div.activity_item:last").attr("data-checkin-id");
			
			ajaxStatement = $.ajax({
				url: host + "/venue/checkins/"+vid+"?access_token="+token+"&max_id="+offset,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#venue_activity_loader").hide();
					$("#see_more_venue_activity").show();
					
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#venue_activity_loader").hide();
					$("#see_more_venue_activity").show();
					
					if (data.meta.code == 200)
					{
						if (data.response.checkins.count == 0) {
							$("#see_more_venue_activity").hide();
						}
						
						Template.venue_activity(data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	
		
	},
	your_activity: function(vid) {
	
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#your_activity_loader").show();
			$("#see_more_your_activity").hide();
			
			var offset = $("#your_activity_stream_profile_content div.activity_item:last").attr("data-checkin-id");
			
			ajaxStatement = $.ajax({
				url: host + "/user/checkins/"+vid+"?access_token="+token+"&max_id="+offset,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#your_activity_loader").hide();
					$("#see_more_your_activity").show();
					
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#your_activity_loader").hide();
					$("#see_more_your_activity").show();
					
					if (data.meta.code == 200)
					{
						if (data.response.checkins.count == 0) {
							$("#see_more_your_activity").hide();
						}
						
						Template.your_activity(data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}	
	},
	brewery_activity: function(brewery_id) {
	
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#brewery_activity_loader").show();
			$("#see_more_brewery_activity").hide();
			
			var offset = $("#brewery_stream_profile div.activity_stream div.activity_item").length;
			
			ajaxStatement = $.ajax({
				url: host + "/brewery/checkins/"+brewery_id+"?access_token="+token+"&offset="+offset,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#brewery_activity_loader").hide();
					$("#see_more_brewery_activity").show();
					
					if (data.meta.code == 200)
					{
						if (data.response.checkins.count == 0) {
							$("#see_more_brewery_activity").hide();
						}
						
						Template.brewery_activity(data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	
		
	},
	more_beer: function(brewery_id) {
		
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{	
			$("#see_more_brewery_beer").hide();
			$("#brewery_beer_loader").show();
			
			var len = $("#brewery_beer_list_stream div.list_box").length;
			
			ajaxStatement = $.ajax({
				url: host + "/brewery/beer_list/"+brewery_id+"?access_token="+token+"&offset="+len+"&limit=15",
				type: "GET",
				dataType: "json",
			    error: function(xhr,ajaxOptions, thrownError)
				{
					$("#see_more_brewery_beer").show();
					$("#brewery_beer_loader").hide();
					
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					Spinner.off();
					
					
					$("#see_more_brewery_beer").show();
					$("#brewery_beer_loader").hide();
					
					if (data.meta.code == 200)
					{
						/*if (data.response.beers.count == 0) {
							$("#see_more_brewery_beer").hide();
						}*/
						
						Template.brewery_list(data.response.beers);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	},
	brewery_full_pull: function(brewery_id) {
		
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			ajaxStatement = $.ajax({
				url: host + "/brewery/info/"+brewery_id+"?access_token="+token,
				type: "GET",
				dataType: "json",
			    error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					Spinner.off();
					
					if (data.meta.code == 200)
					{
						/*f (data.notifications.unread_count.friends >= 1) {
							if ($("#pendingFriendsNotice span.pending").length == 0) {
								$("#pendingFriendsNotice").prepend('<span class="pending">!</span>');	
							}
						}
						else {
							$("#pendingFriendsNotice span.pending").remove();
						}*/

						Template.brewery_full("breweryDetailsArea", data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
	},
	brewery: function(brewery_id, a) {
		
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			
			if (a == "beertemplate") {
				var j = $("#brewerybeer_"+brewery_id).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.brewery("breweryArea", fix, true);
				}
			}
			else if (a == "full") {
				$("#breweryArea").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');
			}
			else {
				var j = $("#brewerysearch_"+brewery_id).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.brewery("breweryArea", fix, true);
				}
			}

			ajaxStatement = $.ajax({
				url: host + "/brewery/info/"+brewery_id+"?access_token="+token,
				type: "GET",
				dataType: "json",
			    error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					Spinner.off();
					
					if (data.meta.code == 200)
					{
						if (a == "full") {
							Template.brewery_full("breweryArea", data.response);
						}
						else {
							Template.brewery("breweryDetailsArea", data.response);
						}
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
			
	},
	your_side: function(a,b,c) {
		
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{		
			var source;
			var url;
			var type = "filter";
			
			if (c) {
				type = "full";
			}
		
			if (a == "beer") {
				url = host + "/beer/checkins/"+b+"?access_token="+token+"&type="+type;
				source = "beer_stream_profile_content";
				
				$("#see_more_beer_activity").hide();

				Toggle.tabs($(".beer-activity-tab ul li a:first"), 'beer_tabs', 'beer_stream_profile','beer-activity-tab')
			
			}
			else if (a == "venue") {
				url = host + "/venue/checkins/"+b+"?access_token="+token+"&type="+type;
				source = 'venue_stream_profile_content';

				$("#see_more_venue_activity").hide();
				
				Toggle.tabs($(".venue-activity-tab ul li a:first"), 'venue_tab_content', 'venue_stream_profile', 'venue-activity-tab');
			
			}
			else {
				url = host + "/brewery/checkins/"+b+"?access_token="+token+"&type="+type;
				source = "brewery_stream_profile_content";

				$("#see_more_brewery_activity").hide();
				
				Toggle.tabs($(".brewery-activity-tab ul li a:first"), 'brewery_tabs', 'brewery_stream_profile', 'brewery-activity-tab');
			}
			
			$("#"+source).html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');
			
			var p = $("#"+source).offset();
			
			window.scroll(0,p.top);

			ajaxStatement = $.ajax({
				url: url,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					Spinner.off();
					
					
					if (data.meta.code == 200)
					{
						Template.your_checkins(source, data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
	},
	beer_full: function(bid) {

		clearAjax();

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			ajaxStatement = $.ajax({
					url: host + "/beer/info/"+bid+"?access_token="+token,
					type: "GET",
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{
						if (data.meta.code == 200)
						{
							Template.beer_full("beerArea", data.response);
						}
						else
						{
							Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
						}
					}
				});
		}
	},
	beer: function(bid, checkin_id, area) {
				
		$(".beerSearch").val('');
		$(".beerSearchTermPre").val('');		
				
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			console.log(bid + " " + checkin_id + " " + area);
		
			if (area == "recent") {
				var j = $("#beerrecent_"+bid).html();

				if (j != "")
				{
					var fix = JSON.parse(j);
					
					Template.beer("beerArea", fix, true);
				}
			}
			else if (area == "statsbeer") {
				var j = $("#statsBeer_"+bid).html();

				if (j != "")
				{
					var fix = JSON.parse(j);
					
					Template.beer("beerArea", fix, true);
				}
			}
			else if (area == "photo_single") {
				var j = $("#photocheckin_"+checkin_id).html();

				if (j != "")
				{
					var fix = JSON.parse(j);
					
					Template.beer("beerArea", fix, true);
				}
			}
			else if (area == "cheers") {
				var j = $("#cheersbeer_"+bid).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.beer("beerArea", fix, true);
				}
			}
			else if (area == "discoverBeers") {
				
				var j = $("#discoverBeer_"+bid).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.beer("beerArea", fix, true);
				}
				
			}
			else if (area == "topbeer") {
				
				var j = $("#topbeer_"+bid).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.beer("beerArea", fix, true);
				}
				
			}
			else if (area == "recommend") {
				
				var j = $("#beerrec_"+bid).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.beer("beerArea", fix, true, true);
				}
				
			}
			else if (area == "wish") {
				
				var j = $("#beerwish_"+bid).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.beer("beerArea", fix, true);
				}
				
			}
			else if (area == "search") {
				var j = $("#beersearch_"+bid).html();

				if (j != "")
				{
					var fix = JSON.parse(j);
										
					Template.beer("beerArea", fix, true);
				}
			}
			else if (area == "trendingBeer") {
				var j = $("#trendingBeer_"+bid).html();

				if (j != "")
				{
					var fix = JSON.parse(j);
										
					Template.beer("beerArea", fix, true);
				}
			}
			else if (area == "badgedetail") {
				var j = $("#beerbadge_"+bid).html();

				if (j != "")
				{
					var fix = JSON.parse(j);
										
					Template.beer("beerArea", fix, true);
				}
			}
			else if (area == "distinct") {
				var j = $("#beerdistinct_"+bid).html();

				if (j != "")
				{
					var fix = JSON.parse(j);
					
					Template.beer("beerArea", fix, true);
				}
			}
			else if (area == "beerfinal") {
				var j = $("#beerfinal").html();

				if (j != "")
				{
					var fix = JSON.parse(j);
					
					Template.beer("beerArea", fix, true);
				}
			}
			else if (area == "beeradd") {
				var j = $("#beeradd_"+bid).html();

				if (j != "")
				{
					var fix = JSON.parse(j);
				
					Template.beer("beerArea", fix, true);
				}
			}
			else if (area == "wish_list") {
				var j = $("#wishlistbeer_"+bid).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.beer("beerArea", fix, true);
				}
			}
			else if (area == "venue") {
				var j = $("#beertopvenue_"+bid).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.beer("beerArea", fix, true); 
				}
			}
			else if (area == "full") {
				Feed.beer_full(bid);
			}
			else {
				var j = $("#checkindetail_"+checkin_id).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.beer("beerArea", fix, true);
				}
			}
			
			if ($("#beerDetailsArea").html() == "") {
				ajaxStatement = $.ajax({
					url: host + "/beer/info/"+bid+"?access_token="+token,
					type: "GET",
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{ 
						Spinner.off();
						if (data.meta.code == 200)
						{
							Template.beer("beerDetailsArea", data.response);
						}
						else
						{
							Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
						}
					}
				});
			}
		}
	},
	confirm: function(bid, a) {
		
		clearAjax();

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			if (a == "recent") {
				var j = $("#beerrecent_"+bid).html();

				var fix = JSON.parse(j);

				Template.confirm("confirmArea", fix);
			}
			else if (a == "trendingBeer") {
				
				var j = $("#trendingBeer_"+bid).html();

				var fix = JSON.parse(j);

				Template.confirm("confirmArea", fix);
				
			}
			else if (a == "topbeer") {
				
				
				var j = $("#topbeer_"+bid).html();

				var fix = JSON.parse(j);

				Template.confirm("confirmArea", fix);
			}
			else if (a == "venue") {
				
				
				var j = $("#beertopvenue_"+bid).html();

				var fix = JSON.parse(j);

				Template.confirm("confirmArea", fix);
			}
			else if (a == "checkin") {
				
				
				var j = $("#beercheckin_"+bid).html();

				var fix = JSON.parse(j);

				Template.confirm("confirmArea", fix);
			}
			else if (a == "search") {
				var j = $("#beersearch_"+bid).html();

				var fix = JSON.parse(j);

				Template.confirm("confirmArea", fix);
			}
			else {
				var j = $("#beerdetail_"+bid).html();

				var fix = JSON.parse(j);

				Template.confirm("confirmArea", fix);
			}
			
			if ($("#isRecommend").val() == "true") {
				$("#is_reco").val(1);
			}
			else {
				$("#is_reco").val(0);
			}
			
		}
	},
	checkin: function(checkin_id, source, refresh) {
			
		console.log(checkin_id + " | " + source + " | " + refresh);

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			if (source == "full") {
				//console.log("course full");
			}
			else if (source == "notifications") {
				var j = $("#notificationsdetails_"+checkin_id).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.checkin("indCheckin", fix, source);
				}
			}
			else if (source == "photo") {
				
				var j = $("#photocheckin_"+checkin_id).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.checkin("indCheckin", fix, source);
				}
			}
			else if (source == "public") {
				
				var j = $("#publicdetails_"+checkin_id).html();

				if (j != "")
				{
					var fix = JSON.parse(j);

					Template.checkin("indCheckin", fix, source);
				}
			}
			else {
				
				var j = $("#checkindetail_"+checkin_id).html();

				if (j != "")
				{
					var fix = JSON.parse(j);
	
					Template.checkin("indCheckin", fix, source);
				}
			}
			
			if (source == "photo" || source == "full") {
				
				var url = host + "/checkin/view/"+checkin_id+"?access_token="+token;

				console.log(url);

				$.ajax({
					url: url,
					type: "GET",
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						if (source == "full") {
							Loading.off();
						}
						
						console.log('error thronw: ' + thrownError);
						console.log("we have an error");
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{ 
						console.log(data.meta.code);

						Spinner.off();

						if (source == "full") {
							Loading.off();
						}

						if (data.meta.code == 200)
						{
							if (data.response.checkin.toasts.auth_toast) {
								$("#check_view .toast").addClass('active');
							}

							Template.checkin("indCheckin", data.response.checkin, source);
						}
						else
						{
							Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
						}
					}
				});
				
			}
			else {
				
				ajaxStatement = $.ajax({
					url: host + "/checkin/view/"+checkin_id+"?access_token="+token,
					type: "GET",
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{ 
						Spinner.off();

						if (data.meta.code == 200)
						{
							if (data.response.checkin.toasts.auth_toast) {
								$("#check_view .toast").addClass('active');
							}
							
							Template.checkin_interaction("", data.response.checkin, source);
						}
						else
						{
							Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
						}
					}
				});
			}
		}
	}
}
