var Friend = {
	request_remove: function(a,b,c) {
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var obj = {};
			obj["message"] = "Are you sure you want remove this user as friend?";
			obj["action_btn"] = "<a href='javascript:void(0);' onclick='Friend.remove("+a+", null, \""+c+"\");' rel='action-btn' class='yellow_btn'>Confirm</a>";

			/*var source   = $("#warning-template").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['warning-template.tmpl']
			var html = template(obj);

			$("#notice-error").html(html);

			Util.openPop();
		}
	},
	request: function(a,b, c) {
		
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{	
			if (c == "profile") {
				$(b).attr("onclick", "");
				$(b).removeClass("yellow_btn");
				$(b).addClass("grey_btn");
				$(b).html("Pending Friendship");
			}
			else if (c == "follow") {
				$(b).hide();
			}
			else {
				$(b).hide();
			}

			$.ajax({
				url: host + "/friend/request/"+a+"?access_token="+token,
				type: "GET",
				dataType: "json",
			     error: function(html)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						
					}
					else
					{
						$(b).show();
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	},
	approve: function(a,b,c) {
	
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{	
			if (c == "list") {
				$($(b).get(0).parentNode.parentNode).hide();
				
				var requestValue = $("#request_number").html();
				
				var newValue = requestValue.replace("(", "");
				
				var anotherValue = newValue.replace(")", "");
				
				var finalValue = parseInt(anotherValue) - 1;
				
				if (parseInt(finalValue) == 0) {
					$("#request_number").hide();
					$("#pendingFriendsNotice span.pending").remove();
				}
				else {
					$("#request_number").html("("+finalValue+")");
				}
			}
			else {
				$(b).hide();
			}

			$.ajax({
				url: host + "/friend/accept/"+a+"?access_token="+token,
				type: "GET",
				dataType: "json",
			     error: function(html)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{	
						Garbage.clean("myFriends");						
					}
					else
					{
						if (c == "list") {
							$($(b).get(0).parentNode.parentNode).show();
						}
						else {
							$(b).show();
						}
					
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
	},
	reject: function(a,b,c) {
		
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{	
			if (c == "list") {
				$("#friendItem_"+a).hide();
			}
			else {
				$(b).hide();
			}

			ajaxStatement = $.ajax({
				url: host + "/friend/reject/"+a+"?access_token="+token,
				type: "GET",
				dataType: "json",
			     error: function(html)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						$("#friendItem_"+a).remove();
						Garbage.clean("myFriends");
					}
					else
					{
						if (c == "list") {
							$("#friendItem_"+a).hide();
						}
						else {
							$(b).show();
						}
					
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
		
	},
	remove: function(a,b,c) {
		
		
		
		Util.closePop();

		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{	
			if (c == "list") {
				$("#friendItem_"+a).hide();
			}
			else {
				$(b).hide();
			}

			 $.ajax({
				url: host + "/friend/remove/"+a+"?access_token="+token,
				type: "GET",
				dataType: "json",
			    error: function(html)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						$("#friendItem_"+a).remove();
						Garbage.clean("myFriends");

						$("#dashboardAreaContent_content div.activity_item").each(function() {
							if ($(this).attr("data-user-id") == a) {
								$(this).remove();
							}
						})
					}
					else
					{
						if (c == "list") {
							$("#friendItem_"+a).hide();
						}
						else {
							$(b).hide();
						}
					
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
		
	}
}