var Geocode = {
	reverseSuper: function(a) {

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var args = $(a).serialize();

			var obj = [];

			ajaxStatement = $.ajax({
				url: host+ "/location/coords?access_token="+token,
				type: "GET",
				data: args,
				dataType: "json",
			    error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
					return obj;
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						if (data.response.length == 0) {

							var stringArgs = args.split("=");
						
							return obj;

						}
						else {

							var position = {};

							position.coords = {};

							position.coords.latitude = data.response[0].lat;
							position.coords.longitude = data.response[0].lon;

							

							$(data.response).each(function(i, items) {

								if (items.address.city) {
									var shortStreet = items.address.city + ", " + items.address.state;
								}
								else {
									var shortStreet = items.address.state;
								}

								var newObj = {
									"shortName": shortStreet,
									"latitude": items.lat,
									"longitude": items.lon
								}

								obj.push(newObj);
							})

							return obj;
						}	
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code);
						return obj;
					}

					
				}
			});
			
		}

	},
	reverse: function(lat,lng) {
		
		/*var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$.ajax({
				url: host + "/location/street?lat="+lat+"&lng="+lng+"&access_token="+token,
				type: "GET",
				dataType: "json",
			     error: function(html)
				{
					// error goes here
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						if (data.response.address) {
							if (data.response.address.road) {
								if (data.response.address.city) {
									var shortStreet = data.response.address.road + " - " + data.response.address.city + ", " + data.response.address.state;
								}
								else {
									var shortStreet = data.response.address.road + " - " + data.response.address.state;
								}
							}
							else {
								if (data.response.address.city) {
									var shortStreet = data.response.address.city + ", " + data.response.address.state;
								}
								else {
									var shortStreet = data.response.address.state;
								}
							}
						
							if (data.response.display_name) {
								$(".nearObj").html("Near: " + shortStreet);
							}
							else {
								$(".nearObj").html("Near: A Secret Place!");
							}
						}
						else {
							$(".nearObj").html("Near: A Secret Place!");
						}
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
			
		}*/
		
	}
}


var Geolocate = {
	getCurrentLat: function() {
		if (currentLat) {
			return currentLat;
		}
		else {
			return "";
		}
	},
	getCurrentLng: function() {
		
		if (currentLng) {
			return currentLng;
		}
		else {
			return "";
		}
	},
	store: function(a) {
		
		/*if (geo) {
			
			if (a) {
				callBack = a;
			}
			
			console.log("stored called");

			geo.getCurrentPosition(Geolocate.save, Geolocate.error);
		}
		else
		{
			Error.show("You browser doesn't support Geolcation");
		}*/
	},
	save: function(position) {
		console.log(position);
		currentLat = position.coords.latitude;
		currentLng = position.coords.longitude;

		$(".geoLatSearch").val(currentLat);
		$(".getLngSearch").val(currentLng);
		
		switch (callBack) {
			case "friends":
				Discover.friends();
				break;
			case "bars":
				Discover.bars();
				break;
			case "beers":
				Discover.beers();
				break;
			case "locations":
				Geolocate.venues(globalBID, true);
				break;
			default:
				callBack = "";
		}
		
		callBack = "";
		
		console.log("THE CURRENT LATITUDE IS: " + currentLat + " " + currentLng);
		
		Spinner.off();
			
		Geocode.reverse(currentLat, currentLng);
	},
	saveForCheckin: function() {

		if (geo) {
			nativePosition(Geolocate.save, Geolocate.nonError, opts);
		}
		else
		{
			Error.show("You browser doesn't support Geolcation");
		}
	},
	find_beer: function(a, b) {
		
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			findBeer = a;
			
			if (geo) {
				nativePosition(Feed.find_beer, Geolocate.error, opts);
			}
			else
			{
				Error.handle("You browser doesn't support Geolcation");
			}
		}
	},
	around_pub: function() {
		if (geo) {
			nativePosition(Feed.around_me, Geolocate.error, opts);
		}
		else
		{
			Error.handle("You browser doesn't support Geolcation");
		}
	},
	venue_search: function(a) {
		
		$(".location_bar").show();
		
		if (globalBID == 0 || currentLat == "" || currentLng == "") {
			Error.handle("Invalid BID");
		}
		else
		{
			$("#searchlocationAreaContent").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Finding Locations...</p></div>');
			
			var term = $(a).serialize();
			
			Feed.foursquare_venue_search(currentLat, currentLng, term);		
		}
		
		return false;		
	},
	venues: function(bid, refresh) {

		if (phonegap) {
			kt.loc(
				function good(args) {
					if (args) {

						kt.wifiCheck(
							function good(args) {
								console.log("wifi check good: " + args);
								if (args != "enabled" && args != "enabling" && !localStorage.getItem("wifiCheckDisplayed")) {
									toastPlugin.longshow("For better GPS reception, turn on your Wifi on your device.", function() {
										localStorage.setItem("wifiCheckDisplayed", "true");
										}, function() {
										// an error occured
									});
								}
							},
							function bad(args) {
								console.log("wifi check failed");
								localStorage.setItem("wifiCheckDisplayed", "true");
							}
						);
						
					}
					else {

						if (!localStorage.getItem("networkLocationCheck")) {
							toastPlugin.longshow("For better location search, please enable Location Services on your device.", function() {
								localStorage.setItem("networkLocationCheck", "true");
								}, function() {
								// an error occured
							});
						}
					}
				},
				function bad(args) {
					console.log("oh no");
					localStorage.setItem("networkLocationCheck", "true");
				}
			);
		}
	
		$(".location_bar").show();

		globalBID = bid;

		if (phonegap) {
			locationTimeout = setTimeout(function() {
				toastPlugin.shortshow("Still Trying To Get Your Location...", function() {
					// toast correctly displayed
					}, function() {
					// an error occured
				});
			}, 5000);
		}

		$("#venue-search-term").val('');
			
		if (refresh) {
			
			$("#locationAreaContent").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Finding Locations...</p></div>');
			
			Loading.on();
			
			memcache.remove("recentLocations");

			if (geo) {
				nativePosition(Feed.foursquare_venues, Geolocate.error, opts);
			}
			else
			{
				Error.show("Your app doesn't support Geolcation");
			}
		}
		else
		{
			$("#locationAreaContent").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Finding Locations...</p></div>');
			
			if (geo) {

				if (memcache.get("recentLocations")) {

					var dets = JSON.parse(memcache.get("recentLocations"));

					var position = {
						coords: {
							latitude: dets.coords.latitude,
							longitude: dets.coords.longitude
						},
						items: dets.items
					};

					Feed.foursquare_venue_recent(position, false);
				}
				else {

					if (nativePosition) {
						nativePosition(function(coords) {
							Feed.foursquare_venues(coords, false);
						}, Geolocate.error, opts);
					}
					else {
						Geolocate.error("nothing");
					}
				}
			}
			else
			{
				Error.show("Your app doesn't support Geolcation");
			}
		}

		
	},
	test: function() {
		
		Spinner.on();
		
		console.log("started");
		
		if (geo) {
			
			console.log("it's here");
			
			nativePosition(Geolocate.testGood, Geolocate.testBad, opts);
			
			console.log("afterwards");
		}
		else {
			
			Spinner.off();
			
			navigator.notification.alert(
			    'Your browser doesn\'t appear to support Geolocation.',  // message
			    null,         // callback
			    'Geolocation',            // title
			    'Done'                  // buttonName
			);
			
		}
	},
	testBad: function(error) {
		
		console.log("err");
		
		var message = lastKnownGeoError;

		navigator.notification.alert(
		    'We had a little trouble obtaining your location. Here is the error: ' + Geolocate.parseError(error),  // message
		    null,         // callback
		    'Geolocation',            // title
		    'Done'                  // buttonName
		);
	},
	testGood: function(position) {
		
		console.log("we got results");
		
		currentLat = position.coords.latitude;
		currentLng = position.coords.longitude;
		
		navigator.notification.alert(
		    'Great, we were able to obtain your location at: '+currentLat+', '+currentLng+'.',  // message
		    null,         // callback
		    'Geolocation',            // title
		    'Done'                  // buttonName
		);
		
		Spinner.off();
		
		Geocode.reverse(currentLat, currentLng);
	},
	error: function(error) {
		
		var msg;
		
		$("#notice-error").html('');

		var obj = {};
		obj["message"] = "We had a hard time obtaining your location.";
		obj["action_btn"] = "The error received was: " + Geolocate.parseError(error);
		console.log(obj);

		/*var source   = $("#warning-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['warning-template.tmpl'];
		var html = template(obj);

		$("#notice-error").html(html);

		Util.openPop();

		var obj = {};
		obj["h2_message"] = "We couldn't get your location.";
		obj["h3_message"] = "Please try to refresh this page.";
		console.log(obj);

		var template = Handlebars.templates['empty-list-box-minus-q.tmpl'];
		var html2 = template(obj);

		setTimeout(function() {
			var currentPage = $("#container div.active_page").attr('id');

			if (currentPage == "discoverBars") {
				console.log("here");
				$("#discoverBarsHolderPopular").html(html2);
				$("#discoverBarsHolderNearby").html(html2);
			}
			else if (currentPage.indexOf("location") >= 0) {
				if (currentPage == "locationArea") {
					$("#locationAreaContent").html(html2);
				}
				else if (currentPage == "searchlocationArea") {
					$("#locationAreaContent").html(html2);
				}
			}

		}, 500);
	},
	nonError: function(a) {
		console.log(a);
	},
	parseError: function(error) {
		var msg;
		console.log(error)
		switch(error.code) 
	    {
	    case error.PERMISSION_DENIED:
	      msg ="User denied the request for Geolocation."
	      break;
	    case error.POSITION_UNAVAILABLE:
	      msg ="Location information is unavailable."
	      break;
	    case error.TIMEOUT:
	      msg = "The request to get user location timed out."
	      break;
	    case error.UNKNOWN_ERROR:
	      msg = "An unknown error occurred."
	      break;
	      default:
	      msg = "An unknown error occurred."
	      break;
	    }
	  
	  return msg;
	}
 	
}

