(function() {
  var template = Handlebars.template, templates = Handlebars.templates = Handlebars.templates || {};
	templates['add-item-template.tmpl'] = template(function (Handlebars,depth0,helpers,partials,data) {
	helpers = helpers || Handlebars.helpers;
  var buffer = "", stack1, foundHelper, functionType="function", escapeExpression=this.escapeExpression, self=this, helperMissing=helpers.helperMissing;
	
	
	if(depth0.component=="topic"){
		buffer+=add_topic(depth0.id,depth0.groups);
	}else if(depth0.component=="page"){
		buffer+=add_page(depth0.id);
	}else if(depth0.component=="photo"){
		buffer+=add_photo(depth0.id);
	}
	
/*function to get topic post form*/
function add_topic(id,groups){
	var html='';
	
	html='<div class="blue_bar">Start A New Question</div>'+"\n";
	html+='<form id="topicForm"><ul>';
	
	if(groups){
	html+='<li><select class="dropdown" id="user_groups" name="user_groups">';
	html+='<option value="">Select group</option>';
	for (var i=0;i<groups.length;i++)
	{ 
		html+='<option value="'+groups[i].id+'">'+groups[i].name+'</option>';
	}
	html+='</select></li>';
	}
	
	html+='<li><input type="text" name="topic_title" autocomplete="false" id="topic_title" autocorrect="false" placeholder="Enter title"></li>';
	html+='<li><textarea name="topic_body" autocomplete="false" id="topic_body" autocorrect="false" placeholder="Enter body"></textarea></li>';
	html+='<input type="hidden" id="user_id" value="'+id+'" name="user_id">';
	html+='</ul></form>';
	html+='<a class="yellow_btn large" rel="action-btn" data-analytics="topicPost" href="javascript:void(0);" onclick="Feed.add_item_post(\'#topicForm\');" id="add-topic-btn">Submit</a>';
	html+='<div id="post_inner_spinner" class="loading_inner hide"><img src="assets/images/spinner.gif" width="24" height="24"><br><br></div>';
	return html;
}

/*function to get page post form*/
function add_page(id){
	var html='';
	
	html='<div class="blue_bar">Publish A New Page</div>'+"\n";
	html+='<form id="pageForm"><ul>';
	html+='<li><input type="text" name="page_title" autocomplete="false" id="page_title" autocorrect="false" placeholder="Enter page title"></li>';
	html+='<li><textarea name="page_body" autocomplete="false" id="page_body" autocorrect="false" placeholder="Enter page body"></textarea></li>';
	html+='<li><input type="text" name="page_excerpt" autocomplete="false" id="page_excerpt" autocorrect="false" placeholder="Enter page excerpt"></li>';
	
	html+='<input type="hidden" id="user_id" value="'+id+'" name="user_id">';
	html+='</ul></form>';
	html+='<a class="yellow_btn large" rel="action-btn" data-analytics="topicPost" href="javascript:void(0);" onclick="Feed.add_item_post(\'#pageForm\');" id="add-page-btn">Submit</a>';
	html+='<div id="post_inner_spinner" class="loading_inner hide"><img src="assets/images/spinner.gif" width="24" height="24"><br><br></div>';
	return html;
}

/*photo add form*/
function add_photo(id){
	var html='';
	
	html='<div class="blue_bar">Publish A Photo</div>'+"\n";
	html+='<form id="photoForm"><ul>';
	html+='<li><textarea name="page_body" autocomplete="false" id="page_body" autocorrect="false" placeholder="Enter page body"></textarea></li>';
	html+='<a class="change_avatar button brown_btn" onclick="MenuToggle.get_picture();" data-analytics="menuToggle_profileChange" rel="action-btn" href="javascript:void(0);">Browse</a><span class="image_name">No file choosen</span>';	
	html+='<input type="hidden" id="fileUrl" name="fileUrl"><input type="hidden" id="user_id" value="'+id+'" name="user_id">';
	html+='</ul><div class="append_image"></div></form>';
	html+='<br><a class="yellow_btn large" rel="action-btn" data-analytics="photoPost" href="javascript:void(0);" onclick="Photo.getSuccessPhotoAfter();" id="add-photoe-btn">Submit</a>';
	html+='<div id="post_inner_spinner" class="loading_inner hide"><img src="assets/images/spinner.gif" width="24" height="24"><br><br></div>';
	return html;
}


 return buffer;
});
})();