(function() {
  var template = Handlebars.template, templates = Handlebars.templates = Handlebars.templates || {};
templates['discoverNearbyBars.tmpl'] = template(function (Handlebars,depth0,helpers,partials,data) {
  helpers = helpers || Handlebars.helpers;
  var buffer = "", stack1, stack2, foundHelper, tmp1, self=this, functionType="function", helperMissing=helpers.helperMissing, undef=void 0, escapeExpression=this.escapeExpression;

function program1(depth0,data) {
  
  var buffer = "", stack1, stack2;
  buffer += "\n	<div class=\"list_box bottom_bar discover_bars\" data-sort-popular=\"";
  stack1 = depth0.total_users;
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "this.total_users", { hash: {} }); }
  buffer += escapeExpression(stack1) + "\" data-sort-category=\"";
  stack1 = depth0.venue;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.primary_category);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "this.venue.primary_category", { hash: {} }); }
  buffer += escapeExpression(stack1) + "\" data-sort-distance=\"";
  stack1 = depth0.distance;
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "this.distance", { hash: {} }); }
  buffer += escapeExpression(stack1) + "\">\n		<div class=\"details\">\n			<a href=\"#!/venueArea/";
  stack1 = depth0.venue;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.venue_id);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "this.venue.venue_id", { hash: {} }); }
  buffer += escapeExpression(stack1) + "/";
  stack1 = depth0.checkin_id;
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "this.checkin_id", { hash: {} }); }
  buffer += escapeExpression(stack1) + "/discoverVenues\">\n				<img width=\"50\" height=\"50\" src=\"";
  stack1 = depth0.venue;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.venue_icon);
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.lg);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "this.venue.venue_icon.lg", { hash: {} }); }
  buffer += escapeExpression(stack1) + "\">\n				<div>\n					<h2>";
  stack1 = depth0.venue;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.venue_name);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "this.venue.venue_name", { hash: {} }); }
  buffer += escapeExpression(stack1) + "</h2>\n					<h3>\n						";
  stack1 = depth0.venue;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.primary_category);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "this.venue.primary_category", { hash: {} }); }
  buffer += escapeExpression(stack1) + " ";
  stack1 = depth0.venue;
  foundHelper = helpers.venueCategory;
  stack2 = foundHelper || depth0.venueCategory;
  if(typeof stack2 === functionType) { stack1 = stack2.call(depth0, stack1, { hash: {} }); }
  else if(stack2=== undef) { stack1 = helperMissing.call(depth0, "venueCategory", stack1, { hash: {} }); }
  else { stack1 = stack2; }
  buffer += escapeExpression(stack1) + "\n					</h3>\n					<p>\n						<strong>";
  stack1 = depth0.venue;
  foundHelper = helpers.venueHelper;
  stack2 = foundHelper || depth0.venueHelper;
  if(typeof stack2 === functionType) { stack1 = stack2.call(depth0, stack1, { hash: {} }); }
  else if(stack2=== undef) { stack1 = helperMissing.call(depth0, "venueHelper", stack1, { hash: {} }); }
  else { stack1 = stack2; }
  buffer += escapeExpression(stack1) + "</strong>\n					</p>\n				</div>\n			</a>\n			<div class=\"distance\">\n				<a href=\"#\" rel=\"action-btn\">";
  stack1 = depth0;
  foundHelper = helpers.displayVenueCount;
  stack2 = foundHelper || depth0.displayVenueCount;
  if(typeof stack2 === functionType) { stack1 = stack2.call(depth0, stack1, { hash: {} }); }
  else if(stack2=== undef) { stack1 = helperMissing.call(depth0, "displayVenueCount", stack1, { hash: {} }); }
  else { stack1 = stack2; }
  buffer += escapeExpression(stack1) + "</a>\n			</div>\n			<div id=\"discoverVenue_";
  stack1 = depth0.venue;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.venue_id);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "this.venue.venue_id", { hash: {} }); }
  buffer += escapeExpression(stack1) + "\" style=\"display:none\">";
  stack1 = depth0;
  foundHelper = helpers.jason;
  stack2 = foundHelper || depth0.jason;
  if(typeof stack2 === functionType) { stack1 = stack2.call(depth0, stack1, { hash: {} }); }
  else if(stack2=== undef) { stack1 = helperMissing.call(depth0, "jason", stack1, { hash: {} }); }
  else { stack1 = stack2; }
  buffer += escapeExpression(stack1) + "</div>\n		</div>\n	</div>	\n";
  return buffer;}

  foundHelper = helpers.items;
  stack1 = foundHelper || depth0.items;
  stack2 = helpers.each;
  tmp1 = self.program(1, program1, data);
  tmp1.hash = {};
  tmp1.fn = tmp1;
  tmp1.inverse = self.noop;
  stack1 = stack2.call(depth0, stack1, tmp1);
  if(stack1 || stack1 === 0) { buffer += stack1; }
  buffer += "\n";
  return buffer;});
})();