(function() {
  var template = Handlebars.template, templates = Handlebars.templates = Handlebars.templates || {};
templates['friends-template.tmpl'] = template(function (Handlebars,depth0,helpers,partials,data) {
  helpers = helpers || Handlebars.helpers;
  var stack1, stack2, foundHelper, tmp1, self=this, functionType="function", helperMissing=helpers.helperMissing, undef=void 0, escapeExpression=this.escapeExpression;

function program1(depth0,data) {
  //edited by vissu
  var buffer;
  switch (depth0.name)
  {
  	case "note_add":buffer='<div class="list_box"><a href="#!/storyArea/note/'+depth0.object.id+'">'+depth0.subject.name+' shared a note</a></div>';
  					break;
  			
  	case "topic_add":buffer='<div class="list_box">'+depth0.object.owner.username+' started a topic</div>';
  					break;
  			
  	case "note_comment":buffer='<div class="list_box">'+depth0.object.owner.name+' commented on the note</div>';
  					break;
  			
  	case "topic_comment":buffer='<div class="list_box">'+depth0.object.owner.name+' commented on the topic</div>';
  					break;
  			
  	case "set_add":buffer='<div class="list_box">'+depth0.object.owner.name+' created a photo set</div>';
  					break;
  			
  	case "set_comment":buffer='<div class="list_box">'+depth0.object.owner.name+' commented on the set</div>';
  					break;
  			
  	case "actor_follow":buffer='';
  					break;
  			
  	case "avatar_edit":buffer='';
  					break;
  			
  	case "photo_add":buffer='<div class="list_box">'+depth0.object.owner.username+' shared a photo</div>';
  					break;
  			
  	case "photo_comment":buffer='<div class="list_box">'+depth0.object.owner.name+' commented on the photo</div>';
  					break;
  					
  					
  	default:buffer='<div class="list_box">'+depth0.name+'</div>';
  					break;
  }
  
  return buffer;
  /*var buffer = "", stack1, stack2, stack3;
  buffer += "\n	<div id=\"friendItem_";
  stack1 = depth0.user;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.uid);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "this.user.uid", { hash: {} }); }
  buffer += escapeExpression(stack1) + "\" class=\"list_box\">\n		<span class=\"friend-user-item\">\n			";
  stack1 = false;
  stack2 = depth0;
  foundHelper = helpers.relationshipHelper;
  stack3 = foundHelper || depth0.relationshipHelper;
  if(typeof stack3 === functionType) { stack1 = stack3.call(depth0, stack2, stack1, { hash: {} }); }
  else if(stack3=== undef) { stack1 = helperMissing.call(depth0, "relationshipHelper", stack2, stack1, { hash: {} }); }
  else { stack1 = stack3; }
  buffer += escapeExpression(stack1) + "\n			<a class=\"item\" href=\"#!/profileArea/";
  stack1 = depth0.user;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.user_name);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "this.user.user_name", { hash: {} }); }
  buffer += escapeExpression(stack1) + "/";
  stack1 = depth0.user;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.uid);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "this.user.uid", { hash: {} }); }
  buffer += escapeExpression(stack1) + "/friends\">\n				<span class=\"avatar_wrapper\">\n					<img width=\"40\" height=\"40\" src=\"";
  stack1 = depth0.user;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.user_avatar);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "this.user.user_avatar", { hash: {} }); }
  buffer += escapeExpression(stack1) + "\">\n					";
  stack1 = depth0.user;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.is_supporter);
  stack2 = helpers['if'];
  tmp1 = self.program(2, program2, data);
  tmp1.hash = {};
  tmp1.fn = tmp1;
  tmp1.inverse = self.noop;
  stack1 = stack2.call(depth0, stack1, tmp1);
  if(stack1 || stack1 === 0) { buffer += stack1; }
  buffer += "\n				</span>\n				<div>\n					<h2>";
  stack1 = depth0.user;
  foundHelper = helpers.fullName;
  stack2 = foundHelper || depth0.fullName;
  if(typeof stack2 === functionType) { stack1 = stack2.call(depth0, stack1, { hash: {} }); }
  else if(stack2=== undef) { stack1 = helperMissing.call(depth0, "fullName", stack1, { hash: {} }); }
  else { stack1 = stack2; }
  buffer += escapeExpression(stack1) + "</h2>\n					<h3>";
  stack1 = depth0;
  foundHelper = helpers.userNameHelper;
  stack2 = foundHelper || depth0.userNameHelper;
  if(typeof stack2 === functionType) { stack1 = stack2.call(depth0, stack1, { hash: {} }); }
  else if(stack2=== undef) { stack1 = helperMissing.call(depth0, "userNameHelper", stack1, { hash: {} }); }
  else { stack1 = stack2; }
  buffer += escapeExpression(stack1) + "</h3>\n					<p><strong>";
  stack1 = depth0.user;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.location);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "this.user.location", { hash: {} }); }
  buffer += escapeExpression(stack1) + "</strong></p>\n				</div>\n			</a>\n			<div id=\"currentFriend_";
  stack1 = depth0.user;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.uid);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "this.user.uid", { hash: {} }); }
  buffer += escapeExpression(stack1) + "\" style=\"display: none;\">";
  stack1 = depth0;
  foundHelper = helpers.jason;
  stack2 = foundHelper || depth0.jason;
  if(typeof stack2 === functionType) { stack1 = stack2.call(depth0, stack1, { hash: {} }); }
  else if(stack2=== undef) { stack1 = helperMissing.call(depth0, "jason", stack1, { hash: {} }); }
  else { stack1 = stack2; }
  buffer += escapeExpression(stack1) + "</div>\n		</span>\n	</div>\n";
  return buffer;*/}
function program2(depth0,data) {
  
  
  return "\n						<span class=\"flag\"></span>\n					";}

  foundHelper = helpers.items;
  stack1 = foundHelper || depth0.data;
  stack2 = helpers.each;
  tmp1 = self.program(1, program1, data);
  tmp1.hash = {};
  tmp1.fn = tmp1;
  tmp1.inverse = self.noop;
  stack1 = stack2.call(depth0, stack1, tmp1);
  if(stack1 || stack1 === 0) { return stack1; }
  else { return ''; }});
})();