 var Photo = {
	toggle: function() {

		var obj = {};
		obj["message"] = "Where do you want to take the photo from?";

		/*var source   = $("#warning-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['photo-select-template.tmpl']
		var html = template(obj);

		$("#notice-error").html(html);

		Util.openPop();
	},
	toggleAfter: function() {

		var obj = {};
		obj["message"] = "Where do you want to take the photo from?";

		/*var source   = $("#warning-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['photo-select-template-after.tmpl']
		var html = template(obj);

		$("#notice-error").html(html);

		Util.openPop();
	},
	start_delete: function(photo_id) {

		window.scroll(0,0);

		$("#notice-error").html('');

		var obj = {};
		obj["message"] = "Are you sure you want remove this photo? This cannot be undone.";
		obj["action_btn"] = "<a href='javascript:void(0);' onclick='Photo.delete_photo("+photo_id+");' rel='action-btn' class='yellow_btn'>Confirm</a>";

		console.log(obj);

		/*var source   = $("#warning-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['warning-template.tmpl'];
		var html = template(obj);

		$("#notice-error").html(html);

		Util.openPop();
	},
	start_delete_photo: function(photo_id) {

		window.scroll(0,0);

		$("#notice-error").html('');

		var obj = {};
		obj["message"] = "Are you sure you want remove this photo?";
		obj["action_btn"] = "<a href='javascript:void(0);' onclick='Photo.delete_photo("+photo_id+");' rel='action-btn' class='yellow_btn'>Confirm</a>";
	
		/*var source   = $("#warning-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['warning-template.tmpl'];
		var html = template(obj);

		$("#notice-error").html(html);

		Util.openPop();

	},
	delete_photo: function(photo_id) {

		Util.closePop();

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			Loading.on();

			$("#photo-checkin-area").hide();

			$.ajax({
				url: host + "/photo/delete/"+photo_id+"?access_token="+token,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					Loading.off();
					
					if (data.meta.code == 200)
					{
						$("#photo-checkin-area").remove();
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}

	},
	start_flag: function(photo_id) {

		$("#notice-error").html('');

		var obj = {};
		obj["photo_id"] = photo_id;
		obj["message"] = "Why are you flagging this photo?";

		console.log(obj);

		/*var source   = $("#warning-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['photo-flag-template.tmpl'];
		var html = template(obj);

		$("#notice-error").html(html);

		Util.openPop();
	},
	flag: function(photo_id, type_id) {

		Util.closePop();

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			Loading.on();

			$.ajax({
				url: host + "/photo/flag/"+photo_id+"?access_token="+token+"&flag_type="+type_id,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					Loading.off();
					
					if (data.meta.code == 200)
					{
						var obj = {};
						obj["message"] = "This photo has been flagged.";
						obj["action_btn"] = "Our moderator team will investigate this and take the action to get it cleaned up. Thanks for submitting!";

						/*var source   = $("#warning-template").html();
						var template = Handlebars.compile(source);*/

						var template = Handlebars.templates['warning-template.tmpl']
						var html = template(obj);

						$("#notice-error").html(html);

						Util.openPop();

						Util.closePopTimeout(3000);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}

	},
	go_android: function(buttonIndex) {
		
		Util.closePop();
		
		if (buttonIndex == 0) {
			navigator.camera.getPicture(Photo.getSuccess, Photo.getFail, {quality: 100, destinationType: destinationType.FILE_URI, sourceType: pictureSource.PHOTOLIBRARY, targetWidth: 1000, targetHeight: 1000});
		}
		else if (buttonIndex == 1) {
			navigator.camera.getPicture(Photo.getSuccess, Photo.getFail, {quality: 100, destinationType: destinationType.FILE_URI, sourceType: pictureSource.CAMERA, saveToPhotoAlbum: true, targetWidth: 1000, targetHeight: 1000});

		}
	 	else {

		}
		
	},
	afterCheckin: function(buttonIndex) {
		
		Util.closePop();
		
		var pictureSource = navigator.camera.PictureSourceType;
       	var destinationType = navigator.camera.DestinationType;
		
		if (buttonIndex == 0) {
			navigator.camera.getPicture(Photo.getSuccessAfter, Photo.getFail, {quality: 100, destinationType: destinationType.FILE_URI, sourceType: pictureSource.PHOTOLIBRARY, targetWidth: 1000, targetHeight: 1000});
		}
		else if (buttonIndex == 1) {
			navigator.camera.getPicture(Photo.getSuccessAfter, Photo.getFail, {quality: 100, destinationType: destinationType.FILE_URI, sourceType: pictureSource.CAMERA, saveToPhotoAlbum: true, targetWidth: 1000, targetHeight: 1000});

		}
	 	else {

		}
		
	},
	postAfter: function (imageURL) {
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{	
			progressHud.show("Uploading Photo...");

			var checkin_id = $("#check_view").attr('data-checkin');
			var uid = $("#check_view").attr('data-user-id');

			var fileURI = imageURL;

			var options = new FileUploadOptions();
			options.mimeType="image/jpeg";
			options.fileKey="file";
			//options.fileName=fileURI.substr(fileURI.lastIndexOf('/')+1);

			var params = new Object();
			params.checkin_id = checkin_id;
			params.photo_key = session_time;
			params.user_id = uid;

			options.params = params;

			var url_to = host + "/photo/add/"+checkin_id+"?access_token="+token+"&overrideShare=true";

			var ft = new FileTransfer();

			ft.upload(fileURI, url_to, Photo.uploadGoodAfter, Photo.uploadBadAfter, options);
		}
	},
	getSuccessAfter: function(imageURL) {


		var photoEditorUse = myStorage.view("photo_editor");
		var savePhotoEditor = myStorage.view("photo_save");

		if (photoEditorUse == "1") {

			var saveToAlbum = "no";

			if (savePhotoEditor == "1") {
				saveToAlbum = "yes";
			}

			window.plugins.aviary.show(imageURL, saveToAlbum, {
				success: function(result){
					Photo.postAfter(result.src);
				},
				error: function(message){
					$("#notice-error").html('');

					var object = {};

					object["message"] = "We had problem opening the Photo Editor. Please try again.";

					var template = Handlebars.templates['error-template.tmpl'];
					var html = template(object);

					$("#notice-error").html(html);
				
					Util.openPop();

					Util.closePopTimeout(3000);
				}
			});
		}
		else {
			Photo.postAfter(imageURL);
		}
	},
	uploadGoodAfter: function() {

		toastPlugin.shortshow("Your photo has been uploaded.", function() {
			// toast correctly displayed
			}, function() {
			// an error occured
		});

		var checkin_id = $("#check_view").attr('data-checkin');

		progressHud.hide();

		Feed.checkin(checkin_id, "full");
	},
	uploadBadAfter: function(r) {

		console.log(r);

		progressHud.hide();

		$("#notice-error").html('');

		var object = {};

		object["message"] = "We had problem uploading your photo. Please try again.";

		var template = Handlebars.templates['error-template.tmpl'];
		var html = template(object);

		$("#notice-error").html(html);
	
		Util.openPop();

		Util.closePopTimeout(3000);
	},	
	getSuccessProfile: function(imageURL) {
		console.log('entry getSuccessProfile');
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{	
			console.log('imageURL='+imageURL);
			$("#tmpPhotoAvatar").val(imageURL);
			var owner = myStorage.view("currentUser");
			var fileURI = imageURL;

			var options = new FileUploadOptions();
			options.mimeType="image/jpeg";
			options.fileKey="file";
			options.name="portrait";
			options.filename="image.jpg";
			//options.fileName=fileURI.substr(fileURI.lastIndexOf('/')+1);

			var url_to = host + "/index.php?option=com_people&view=person&edit=avatar&id="+owner.id;

			var ft = new FileTransfer();

			ft.upload(fileURI, url_to, Photo.uploadGoodProfile, Photo.uploadBadProfile, options);
		}

	},	
	getSuccessPhoto: function(imageURL) {
		Spinner.on();
		var token = Validate.token();
		
		if (!token)
		{
			Spinner.off();
			Error.token();
		}
		else
		{	
			console.log(imageURL);
			
			$("#fileUrl").val(imageURL);
			var img_name=imageURL.substr(imageURL.lastIndexOf('/')+1);
			console.log(img_name)
			//var j = $("#photoForm").serializeArray();
			//$("#pageForm .append_image").html('<img src="'+imageURL+'" height="60" width="60">');
			$('span.image_name').text('image.jpg');
			//console.log(j);
			Spinner.off();
		}

	},
	getSuccessPhotoAfter:function() {
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{	
			$("#post_inner_spinner").removeClass("hide");
			
			var j = $("#photoForm").serializeArray();
			//console.log(j);
			var fileURI = j[1].value;
			if(fileURI!=""){
				Spinner.on();
				progressHud.show("Uploading Photo...");
				/*get current logged in user*/
				var currentUser = myStorage.view("currentUser");
				var id=currentUser.id;			/*logged in user id*/
				
				var options = new FileUploadOptions();
				options.mimeType="image/jpeg";
				options.fileKey="file";
				//options.fileName=fileURI.substr(fileURI.lastIndexOf('/')+1);
				
				var params = new Object();
				params.body = j[0].value;
	
				options.params = params;
				
				var url_to = host + "/index.php?option=com_photos&view=photo&oid="+id;
	
				var ft = new FileTransfer();
	
				ft.upload(fileURI, url_to, Photo.uploadGoodPhoto, Photo.uploadBadPhoto, options);
			}else{
				Feed.show_alert('fill all fields');
			}
		}
	},
	editSuccess: function(imageURL) {
		

		$("#photo-result").attr("src", imageURL);
		
		largeImage = imageURL;
			
		$("#addPhotoContent").html('<span class="remove_photo">Tap to Change</span><img src="'+imageURL+'" width="70" height="70" />');
		$("#is_photo").val("true");
	    $("#photo_data").val(imageURL);
		$("#addPhotoContent").attr("onclick", "Photo.remove();");
	},
	editFail: function(fail) {
		console.log("failed");
		console.log(a);
	},
	getSuccess: function(imageURL) {

		//plugins.ImageFilter.clean();

		/*$("#photo-result").attr("src", imageURL);
		
		largeImage = imageURL;
			
		$("#addPhotoContent").html('<span class="remove_photo">Tap to Change</span><img src="'+imageURL+'" width="70" height="70" />');
		$("#is_photo").val("true");
	    $("#photo_data").val(imageURL);
		$("#addPhotoContent").attr("onclick", "Photo.remove();");*/

		var photoEditorUse = myStorage.view("photo_editor");
		var savePhotoEditor = myStorage.view("photo_save");

		if (photoEditorUse == "1") {

			var saveToAlbum = "no";

			if (savePhotoEditor == "1") {
				saveToAlbum = "yes";
			}

			window.plugins.aviary.show(imageURL, saveToAlbum , {
				success: function(result){
					Photo.editSuccess(result.src);
				},
				error: function(message){
					$("#notice-error").html('');

					var object = {};

					object["message"] = "We had a problem opening the Photo Editor. Please try again.";

					var template = Handlebars.templates['error-template.tmpl'];
					var html = template(object);

					$("#notice-error").html(html);
				
					Util.openPop();

					Util.closePopTimeout(3000);
				}
			});
		}
		else {
			Photo.editSuccess(imageURL);
		}
	},
	getFail: function(message) {
		$(".change_avatar").removeClass("loading");
		console.log("MESSAGE FAIL: " + message);
	},
	remove: function() {
		$("#is_photo").val("false");
	    $("#photo_data").val("");
		$("#addPhotoContent").attr("onclick", "Photo.toggle();");
		$("#addPhotoContent").html('');
	},
	uploadGoodProfile: function(r) {
		
				var owner = myStorage.view("currentUser");
				var id=owner.id;
		clearTimeout(uploadProgress);
		clearInterval(uploadProgress);	
		
		console.log('r='+r.responseCode);

		Garbage.clean("yourProfile");

		if (r.responseCode==205) {
			$(".profile_loading").hide();
			Feed.actor_profile_avatar(id);
		}
		else {
			$(".profile_loading").hide();
			
			$("#notice-error").html('');

			var object = {};

			object["message"] = "We had problem uploading your avatar. Please try again.";

			var template = Handlebars.templates['error-template.tmpl'];
			var html = template(object);

			$("#notice-error").html(html);
		
			Util.openPop();

			Util.closePopTimeout(3000);
		}

	},
	uploadBadProfile: function(r) {

		$(".change_avatar").removeClass("loading");
		console.log('entry uploadBadProfile');
		clearTimeout(uploadProgress);
		clearInterval(uploadProgress);
		
		console.log(r);

		$("#notice-error").html('');

		var object = {};

		object["message"] = "We had problem uploading your avatar. Please try again.";

		var template = Handlebars.templates['error-template.tmpl'];
		var html = template(object);

		$("#notice-error").html(html);
	
		Util.openPop();

		Util.closePopTimeout(3000);
	},
	uploadGoodPhoto: function(r) {
		console.log(r);
		if (r.responseCode == 200) {
			progressHud.hide();
			$("#post_inner_spinner").addClass("hide");
			Spinner.off();
			Feed.show_alert("success");
		}
		else {
			progressHud.hide();
			$("#post_inner_spinner").addClass("hide");
			Spinner.off();
			Feed.show_alert("fail");
			Util.closePopTimeout(3000);
		}
		Page.change("#!/photoArea", "start");

	},
	uploadBadPhoto: function(r) {
		progressHud.hide();
		Spinner.off();
		$("#post_inner_spinner").addClass("hide");
		console.log(r);

		var object = {};

		object["message"] = "We had problem uploading your avatar. Please try again.";

		var template = Handlebars.templates['error-template.tmpl'];
		var html = template(object);

		$("#notice-error").html(html);
	
		Util.openPop();
		
		Util.closePopTimeout(3000);
		Page.change("#!/photoArea", "start");
	},
	uploadGood: function(r) {
		
		clearTimeout(uploadProgress);
		clearInterval(uploadProgress);	
		
		console.log(r);
		
		if (parseInt(r.responseCode) == 200) {
			$(".progress_bar").hide();
			$("#progress_status").html("Awesome! Your photo has been uploaded.");
		}
		else {
			$(".progress_bar").hide();
			$("#progress_status").html("Shucks! We had a problem uploading your photo. Touch here to try again.");
			$(".photo_upload").attr("ontouchstart", "Photo.processAgain();");
		}
	},
	processAgain: function() {
		
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{		
			$(".photo_upload").attr("ontouchstart", "");
		
			$('.photo_upload').html('<p id="progress_status">We\'re Uploading Your Photo!</p><div class="progress_bar"><span class="progress_bar_inner">0%</span><div class="progress" style="width: 0%"></div></div>');

			var j = $("#photo_details").html();
		
			var json = JSON.parse(j);
		
			var fileURI = json.media.photo_data;
		
			var options = new FileUploadOptions();
			options.mimeType="image/jpeg";
			options.fileKey="file";
			//options.fileName=fileURI.substr(fileURI.lastIndexOf('/')+1);

			var params = new Object();
			params.checkin_id = json.checkin_id;
			params.photo_key = json.media.photo_key;
			params.user_id = json.user.uid;

			options.params = params;
		
			var photo_file = json.media.photo_data;
		
			var url_to = host + "/photo/add/"+json.checkin_id+"?access_token="+token;
		
			uploadProgress = setInterval("pBar.increase();",1000);

			var ft = new FileTransfer();

			/*ft.onprogress = function(progressEvent) {
			    if (progressEvent.lengthComputable) {
			      loadingStatus.setPercentage(progressEvent.loaded / progressEvent.total);
			    } else {
			      loadingStatus.increment();
			    }
			};*/
		
			ft.upload(photo_file, url_to, Photo.uploadGood, Photo.uploadBad, options);
		}
		
	},
	uploadBad: function(r) {
		clearTimeout(uploadProgress);
		clearInterval(uploadProgress);
		
		console.log(r)
		
		$(".progress_bar").hide();
		$("#progress_status").html("Shucks! We had a problem uploading your photo. Touch here to try again.");
		$(".photo_upload").attr("ontouchstart", "Photo.processAgain();");
	}
}

var loadingStatus = {
	setPercentage: function(newProgress) {

		newProgress = Math.round(parseInt(newProgress) * 100);

		$(".progress").attr('data-progress', newProgress);

		$(".progress_bar_inner").html(newProgress+"%");

        $(".progress").attr("style", "width: "+newProgress+"%");
	},
	increment: function() {

		var progress = $(".progress").attr('data-progress');

	    if (parseInt(progress) <= 100)
	    {
			var randomnumber=Math.floor(Math.random()*15)

	        var newProgress = parseInt(progress) + parseInt(randomnumber);

			if (parseInt(newProgress) >= 98)
			{
				newProgress = 98;
				$(".progress_bar").hide();
				$("#progress_status").html("Please Wait...");
			}

			$(".progress").attr('data-progress', newProgress);

			$(".progress_bar_inner").html(newProgress+"%");

	        $(".progress").attr("style", "width: "+newProgress+"%");
	    }
	    else
	    {
			$(".progress").attr('data-progress', '0');
	    }

	}
}

