var propose = {
	go_to_edit: function(a) {
		
		clearAjax();
		
		Loading.on();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$.ajax({
				url: host + "/beer/simple/"+a+"?access_token="+token,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Loading.off();
					Nav.goBack();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					Loading.off();
					
					if (data.meta.code == 200)
					{
						Template.propose_edit("proposeEditAreaContent", data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	},
	flag: function() {
		
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#edit-btns").hide();
			$("#edit-loading").show();
			
			Filter.toggle('beerEditToggle');
			
			var a = $("#beer_template").attr("data-beer");
			
			ajaxStatement = $.ajax({
				url: host + "/beer/proposedupe/"+a+"?access_token="+token,
				type: "POST",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Filter.toggle('beerEditToggle')
					
				
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#edit-btns").show();
					$("#edit-loading").hide();
					
					if (data.meta.code == 200)
					{
						if (data.response.result == "success") {
							
							var obj = {};
							obj["message"] = "This beer as been flagged a duplicate";
							obj["action_btn"] = "Our moderator team will investigate this and take the action to get it cleaned up. Thanks for submitting!";

							/*var source   = $("#warning-template").html();
							var template = Handlebars.compile(source);*/

							var template = Handlebars.templates['warning-template.tmpl']
							var html = template(obj);

							$("#notice-error").html(html);

							Util.openPop();

							Util.closePopTimeout(3000);
						}
					}
					else
					{
						Filter.toggle('beerEditToggle')
						
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
	},
	save_edit: function(a,b) {
		
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#edit-btns").hide();
			$("#edit-loading").show();
			
			var d = $(b).serialize();
			
			ajaxStatement = $.ajax({
				url: host + "/beer/proposeedit/"+a+"?access_token="+token,
				type: "POST",
				data: d,
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#edit-btns").show();
					$("#edit-loading").hide();
					
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#edit-btns").show();
					$("#edit-loading").hide();
					
					if (data.meta.code == 200)
					{
						if (data.response.result == "success") {
							
							Nav.goBack();
							
							var obj = {};
							obj["message"] = "Your proposed edit has been saved.";
							obj["action_btn"] = "Our moderator team will investigate this and take the action to get it cleaned up. Thanks for submitting!";

							/*var source   = $("#warning-template").html();
							var template = Handlebars.compile(source);*/

							var template = Handlebars.templates['notice-template.tmpl']
							var html = template(obj);

							$("#notice-error").html(html);

							Util.openPop();

							Util.closePopTimeout(3000);
						}
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
		
	},
}