var Settings = {
	pushSetup: function(userSettings) {
		
		console.log("PUSH SETTUP HAPPENING");

		udid = device.uuid;

		push_enabled_udid = false;

		if (udid != "") {
			
			$("#push-header").show();
			$(".push-details").show();
			$("#push_options").show();

			$(userSettings.user.settings.push_devices.device_udid.items).each(function(i, items) {
				console.log(udid + " = " + items.device_udid);
				if (udid == items.device_udid) {
					console.log("yes");
					push_enabled_udid = true;

					$(".push_options").show();
				
					$("#push_enabled").addClass("active");

					$("#push_enabled_btn").val(1);
					$("#push_toasts").val(items.push_types.toast);
					$("#push_comments").val(items.push_types.comment);	
					$("#push_friends").val(items.push_types.friends);	
					$("#push_badges").val(items.push_types.badges);	

					if (items.push_types.toast == 1) {
						$("#li_push_toasts").addClass("active");
					}
					else {
						$("#li_push_toasts").removeClass("active");
					}

					if (items.push_types.comment == 1) {
						$("#li_push_comments").addClass("active");
					}
					else {
						$("#li_push_comments").removeClass("active");
					}

					if (items.push_types.badges == 1) {
						$("#li_push_badges").addClass("active");
					}
					else {
						$("#li_push_badges").removeClass("active");
					}

					if (items.push_types.friends == 1) {
						$("#li_push_friends").addClass("active");
					}
					else {
						$("#li_push_friends").removeClass("active");
					}


					$("#push-from-awesome").show();

					$("#push_enabled").hide();
					console.log("MATCH");
					return false;
				}
			});

			console.log("PUSH NOTIFICAITONS: " + push_enabled_udid);

			if (!push_enabled_udid) {
				$(".push_options").hide();
				$("#li_push_toasts").removeClass("active");
				$("#li_push_comments").removeClass("active");
				$("#push_toasts").val(0);
				$("#push_comments").val(0);	
				$("#push_enabled_btn").val(0);
				$("#push_enabled").hide();
				$("#push-from-awesome").hide();
				$("#sound-section").hide();
			}
			else {
				var disNA = myStorage.view("notificationAlert");

				console.log("YOU LOCATION ALERT IS: " + disNA);

				if (!disNA) {
					myStorage.save("notificationAlert", "1");
					$(".sound_option").removeClass("active");
					$("#li_is_sound").addClass("active");
				}
				else {

					if (disNA == "1") {
						$(".sound_option").removeClass("active");
						$("#li_is_sound").addClass("active");
					}
					else if (disNA == "2") {
						$(".sound_option").removeClass("active");
						$("#li_is_vibrate").addClass("active");
					}
					else if (disNA == "3") {
						$(".sound_option").removeClass("active");
						$("#li_is_vibsound").addClass("active");
					}
					else {
						$(".sound_option").removeClass("active");
						$("#li_is_none").addClass("active");
					}
				}

				$("#sound-section").show();
			}
		}
		else {
			$("#push-header").hide();
			$("#push_enabled").hide();
			$(".push-details").hide();
		}

		
	},  
	init: function(data) {
		
		Settings.pushSetup(data);
		//myStorage.save("userSettings",  data);

		if (enhancedLocation == "1") {
			$("#enhanced_location").val(1);
		}
		else {
			$("#enhanced_location").val(2);
		}

		if (data.user.is_private) {
			$("#account_private").attr("value", 1);
			$("#private_option").attr("class", "active");
		}
		else {
			$("#account_private").attr("value", 0);
			$("#private_option").attr("class", "");
		}
		
		if (data.user.settings.is_map) {
			$("#map_privacy").attr("value", 1);
			$("#map_option").attr("class", "active");
		}
		else {
			$("#map_privacy").attr("value", 0);
			$("#map_option").attr("class", "");
		}

		if (data.user.settings.notifications) {
			if (data.user.settings.notifications.toast) {
				$("#li_is_toast").attr("class", "active");
				$("#is_toast_option").attr("value", 1);
			}
			else {
				$("#li_is_toast").attr("class", "");
				$("#is_toast_option").attr("value", 0);
			}

			if (data.user.settings.notifications.comment) {
				$("#li_is_comment").attr("class", "active");
				$("#is_comment_option").attr("value", 1);
			}
			else {
				$("#li_is_comment").attr("class", "");
				$("#is_comment_option").attr("value", 0);
			}


			if (data.user.settings.notifications.friend) {
				$("#li_is_friend").attr("class", "active");
				$("#is_friend_option").attr("value", 1);
			}
			else {
				$("#li_is_friend").attr("class", "");
				$("#is_friend_option").attr("value", 0);
			}
		}
		
		if (data.user.contact.facebook) {
			
			$(".social_scanning_facebook").removeClass("inactive");
			$(".social_scanning_facebook").attr("rel");
			
			$("#default_facebook_checkins").show();
			$("#default_facebook_badges").show();
			
			if (data.user.settings.badge.badges_to_facebook) {
				$("#badges_to_facebook").attr("value", 1);
				$("#default_facebook_badges").attr("class", "active");
			}
			else {
				$("#badges_to_facebook").attr("value", 0);
				$("#default_facebook_badges").attr("class", "");
			}
			
			if (data.user.settings.checkin.checkin_to_facebook) {
				$("#checkins_to_facebook").attr("value", 1);
				$("#default_facebook_checkins").attr("class", "active");
			}
			else {
				$("#checkins_to_facebook").attr("value", 0);
				$("#default_facebook_checkins").attr("class", "");
			}
			
		}
		else {
			$("#default_facebook_checkins").hide();
			$("#default_facebook_badges").hide();
			$(".social_scanning_facebook").addClass("inactive");
			$(".social_scanning_facebook").attr("rel", "action-btn");
		}
		
		if (data.user.contact.twitter) {
			
			$("#default_twitter_checkins").show();
			$("#default_twitter_badges").show();
			$(".social_scanning_twitter").removeClass("inactive");
			$(".social_scanning_twitter").removeAttr("rel");
			
			if (data.user.settings.badge.badges_to_twitter) {
				$("#badges_to_twitter").attr("value", 1);
				$("#default_twitter_badges").attr("class", "active");
			}
			else {
				$("#badges_to_twitter").attr("value", 0);
				$("#default_twitter_badges").attr("class", "");
			}
			
			if (data.user.settings.checkin.checkin_to_twitter) {
				$("#checkins_to_twitter").attr("value", 1);
				$("#default_twitter_checkins").attr("class", "active");
			}
			else {
				$("#twitter_to_facebook").attr("value", 0);
				$("#default_twitter_checkins").attr("class", "");
			}
		}
		else {
			$("#default_twitter_checkins").hide();
			$("#default_twitter_badges").hide();
			$(".social_scanning_twitter").addClass("inactive");
			$(".social_scanning_twitter").attr("rel", "action-btn");
		}
		
		
		if (data.user.contact.foursquare) {
			
			$(".social_scanning_foursquare").removeClass("inactive");
			$(".social_scanning_foursquare").removeAttr('rel');
			$("#default_4sq_checkins").show();
			
			if (data.user.settings.checkin.checkin_to_foursquare) {
				$("#checkins_to_4sq").attr("value", 1);
				$("#default_4sq_checkins").attr("class", "active");
			}
			else {
				$("#twitter_to_4sq").attr("value", 0);
				$("#default_4sq_checkins").attr("class", "");
			}
		}
		else {
			$("#default_4sq_checkins").hide();
			$(".social_scanning_foursquare").addClass("inactive");
			$(".social_scanning_foursquare").attr("rel", "action-btn");
		}
		
		if (data.user.settings.navigation.default_to_checkin) {
			$("#startup_pref").attr("value", 1);
			$("#default_startup").attr("class", "active");
		}
		else {
			$("#startup_pref").attr("value", 0);
			$("#default_startup").attr("class", "");
		}

		var template = Handlebars.templates['settings-template.tmpl']
		
		var html = template(data);

		$("#usernameProfileList").html(data.user.user_name);
		
		$("#settings-elements").html(html);
		
		//Settings.pushSetup(data);

		var template = Handlebars.templates['social-settings-template.tmpl']
		
		var html = template(data);

		var locationSettings = myStorage.view("locationSettings");
		
		if (!locationSettings) {
			$("#location_settings").val("webview");
		}
		else {
			$("#location_settings").val(locationSettings);
		}
		
		var dis = myStorage.view("distanceFriends");
		
		if (!dis) {
			$("#friends_distance").val(5);
		}
		else {
			$("#friends_distance").val(dis);
		}

		var disDB = myStorage.view("discoverBeerDistance");

		if (!disDB) {
			$("#discover_beer_distance").val(5);
		}
		else {
			$("#discover_beer_distance").val(disDB);
		}

		var disB = myStorage.view("distanceBeer");
		
		if (!disB) {
			$("#beer_distance").val(5);
		}
		else {
			$("#beer_distance").val(disB);
		}

		var disBs = myStorage.view("distanceBars");
		
		if (!disBs) {
			$("#bars_distance").val(5);
		}
		else {
			$("#bars_distance").val(disBs);
		}

		var disBw = myStorage.view("distanceBreweries");
		
		if (!disBw) {
			$("#breweries_distance").val(30);
		}
		else {
			$("#breweries_distance").val(disBw);
		}

		var photoEditorUse = myStorage.view("photo_editor");

		if (!photoEditorUse) {
			$("#photo_editor_selection").addClass("active");
			myStorage.save("photo_editor", "1");
		}
		else {
			if (photoEditorUse == "1") {
				$("#photo_editor_selection").addClass("active");
				$("#photo_editor_option").val("1");
			}
			else {
				$("#photo_editor_selection").removeClass("active");
				$("#photo_editor_option").val("0");
			}
		}

		var savePhotoEditor = myStorage.view("photo_save");

		if (!savePhotoEditor) {
			$("#photo_save_option").addClass("active");
			myStorage.save("photo_save", "1");
		}
		else {
			if (savePhotoEditor == "1") {
				$("#photo_save_option").addClass("active");
				$("#photo_editor_option").val("1");
			}
			else {
				$("#photo_save_option").removeClass("active");
				$("#photo_editor_option").val("0");
			}
		}

		$("#social-settings-accounts").html(html);
		
		if (data.user.contact.twitter || data.user.contact.facebook || data.user.contact.foursquare) {
			$("#checkins-header").show();
			$(".checkins-account").show();
		}
		else {
			$("#checkins-header").hide();
			$(".checkins-account").hide();
		}
		
		if (data.user.contact.twitter || data.user.contact.facebook) {
			$("#badges-header").show();
			$(".badges-account").show();
		}
		else {
			$("#badges-header").hide();
			$(".badges-account").hide();
		}
		
		Limiter.limit('bio', 'bio-counter', 140);
	},
	enhanced_location: function(a) {
		if ($(a).val() == "") {
			myStorage.save("enhancedLocation", "1");
			enhancedLocation = "1";
		}
		else {
			myStorage.save("enhancedLocation", $(a).val());
			enhancedLocation = "2";
		}
	},
	update_editor: function(a,b) {
		console.log($(a).hasClass("active"));
		console.log(b);
		if ($(a).hasClass("active")) {
			$("#"+b).val(0);
			$(a).removeClass("active")
			myStorage.save("photo_editor", "0");
		}
		else {
			$("#"+b).val(1);
			$(a).addClass("active")
			myStorage.save("photo_editor", "1");
		}
	},
	update_photo_save: function(a,b) {
		if ($(a).hasClass("active")) {
			$("#"+b).val(0);
			$(a).removeClass("active")
			myStorage.save("photo_save", "0");
		}
		else {
			$("#"+b).val(1);
			$(a).addClass("active")
			myStorage.save("photo_save", "1");
		}
	},
	location_settings: function(a) {
		
		console.log($(a).val());
		
		if ($(a).val() == "") {
			myStorage.save("locationSettings", "native");
			geo = cordova.require('cordova/plugin/geolocation');

		}
		else {
			myStorage.save("locationSettings", $(a).val());
			geo = navigator.geolocation;
		}
	},
	map_breweries: function(a) {
		
		console.log($(a).val());
		
		if ($(a).val() == "") {
			myStorage.save("distanceBreweries", 30);
		}
		else {
			myStorage.save("distanceBreweries", $(a).val());
		}
	},
	map_distance: function(a) {
		
		console.log($(a).val());
		
		if ($(a).val() == "") {
			myStorage.save("distanceFriends", 5);
		}
		else {
			myStorage.save("distanceFriends", $(a).val());
		}
	},
	beer_distance: function(a) {
		if ($(a).val() == "") {
			myStorage.save("distanceBeer", 5);
		}
		else {
			myStorage.save("distanceBeer", $(a).val());
		}
	},
	discover_beer_distance: function(a) {
		if ($(a).val() == "") {
			myStorage.save("discoverBeerDistance", 5);
		}
		else {
			myStorage.save("discoverBeerDistance", $(a).val());
		}
	},
	bars_distance: function(a) {
		if ($(a).val() == "") {
			myStorage.save("distanceBars", 5);
		}
		else {
			myStorage.save("distanceBars", $(a).val());
		}
	},
	bars_distance: function(a) {
		if ($(a).val() == "") {
			myStorage.save("distanceBars", 5);
		}
		else {
			myStorage.save("distanceBars", $(a).val());
		}
	},
	update_sound_note: function(a) {
		if ($(a).attr("data-sound-option")) {
			myStorage.save("notificationAlert", $(a).attr("data-sound-option"));
			$(".sound_option").removeClass("active");
			$(a).addClass("active");
		}
	},
	change_password: function(a,b) {
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var owner = myStorage.view("currentUser");
			var args = $("#change-password-form").serializeArray();
			var formArray = {};

		    $.map(args, function(n, i){
		        formArray[n['name']] = n['value'];
		    });
		    console.log(formArray);
		    if(formArray['new_password']==formArray['confirm_password']){
		    
			$("#change_password_btn").hide();
			$("#change_password_loader").show();
			
			$.ajax({
				url: host + "/index.php?option=com_people&view=person&id="+owner.id,
				type: "POST",
				data: {password:formArray['new_password']},
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#change_password_btn").show();
					$("#change_password_loader").hide();
					
					$("#change-password-form input").val('');
					
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(html)
				{
					$("#change_password_btn").show();
					$("#change_password_loader").hide();
					
					$("#change-password-form input").val('');
					
					if (html)
					{
							console.log(html);
							/*var obj = {};
							obj["message"] = "Your profile has been updated.";*/
							
							/*var source   = $("#warning-template").html();
							var template = Handlebars.compile(source);*/

							/*var template = Handlebars.templates['notice-template.tmpl'];
							var html = template(obj);

							$("#notice-error").html(html);

							Util.openPop();

							Util.closePopTimeout(3000);*/
							$("#update-password-notice").removeClass('hide');
							window.setTimeout(function(){$("#update-password-notice").addClass("hide");}, 5000);
					}
					else
					{
						Error.handle(html.meta.error_detail, html.meta.error_type, html.meta.code);
					}
				}
			});
			}else{
				Feed.show_alert('Paswords should match');
			}
		}
		
	},
	remove_ua_push: function(a,b) {

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var args = b+"="+$("#"+b).val()+"&udid="+udid;

			current_class = $(a).attr("class");

			console.log(args);

			$.ajax({
				url: host + "/account/deletepush?access_token="+token,
				type: "POST",
				data: args,
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(html)
				{
					if (html.meta.code == 200)
					{
						if (html.response.result == "success") {
						 	$(a).attr("class", "");
						 	$(".push_options").hide();
						 	localStorage.setItem("utnoPush", true);
						 	localStorage.removeItem('pushReg');
						 	$("#"+b).val(0);
						 	$("#push_enabled").html("<span></span>Enable Push Notifications");
						}
						else {
							
							$(a).attr("class", current_class);
							
							Error.handle("Oh no! There was an issue with your request, please try again", "", html.meta.code);
						}
					}
					else
					{
						$(a).attr("class", current_class);
						
						Error.handle(html.meta.error_detail, html.meta.error_type, html.meta.code);
					}
				}
			});
		}
	},
	update_push: function(a,b) {

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else {
		
			/*current_class = $(a).attr("class");

			if ($("#"+b).val() == 1) {
				$(a).attr("class", "loading");
				
				//Settings.remove_ua_push(a,b);
				
				pushNotification.unregister(function(args) { console.log("done")  }, function(args) { $(a).attr("class", current_class); pushFunctions.errorHandlerSettings(args); });
			}
			else {
				
				localStorage.removeItem("utnoPush");

				$(a).attr("class", "loading");

				pushNotification.register(pushFunctions.tokenHandler, function(args) { $(a).attr("class", current_class); pushFunctions.errorHandlerSettings(args); }, {"senderID":"760784898343","ecb":"onNotificationGCM"});
			}*/
			
			$(".push_notification").removeClass("active");
			$(a).addClass("active");
			var key=myStorage.view('reg_id');
			var owner=myStorage.view('currentUser');
			var Uid=owner.id;
			if(key!='' && Uid!=''){
			$.post("http://neuros.org/neuros_mobile/update.php", {user_id:Uid,key:key,status:b});
			}
		}
	},
	check_status: function() {

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else {
		
			var key=myStorage.view('reg_id');
			var owner=myStorage.view('currentUser');
			var Uid=owner.id;
			if(key!='' && Uid!=''){
			
		   $.ajax({
				url: "http://neuros.org/neuros_mobile/status.php",
				type: "POST",
				data: {user_id:Uid,key:key},
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					//Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
			    	if(data==1)
			      		$('#push_enabled').addClass('active');
			      	if(data==0)
			      		$('#push_disabled').addClass('active');
					}
			});
			}
		}
	},
	update_push_settings: function(a,b) {

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			if (localStorage.getItem("GCMToken")) {

				var gcmToken = localStorage.getItem("GCMToken");

				current_class = $(a).attr("class");

				if ($(a).hasClass("active")) {
					$("#"+b).val(0);
				}
				else {
					$("#"+b).val(1);
				}
				
				var args = b+"="+$("#"+b).val()+"&udid="+udid+"&push_platform=Android&token="+gcmToken;

				console.log(args);

				$(a).attr("class", "loading");

				$.ajax({
					url: host + "/account/updatepush?access_token="+token,
					type: "POST",
					data: args,
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						$(a).removeClass("loading");
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(html)
					{
						console.log(html.query);
						
						$(a).removeClass("loading");

						if (html.meta.code == 200)
						{
							if (html.response.result == "success") {
							 	// active state
								
								if (html.response.option) {
									$(a).addClass("active")
								}
								else {
									$(a).removeClass("active");
								}
							}
							else {
								
								$(a).attr("class", current_class);
								
								Error.handle("Oh no! There was an issue with your request, please try again", "", html.meta.code);
							}
						}
						else
						{
							$(a).attr("class", current_class);
							
							Error.handle(html.meta.error_detail, html.meta.error_type, html.meta.code);
						}
					}
				});
			}
			else {
				Error.handle("Your device is not set up to receive push notifications. Please re-install the application.", "", "");
			}
			
		}	

	},
	update_privacy: function(a,b) {
		
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var current_class = $(a).attr("class");
			
			if (current_class == "active") {
				$("#"+b).val(0);
			}
			else {
				$("#"+b).val(1);
			}
			
			var args = b+"="+$("#"+b).val();

			$(a).attr("class", "loading");

			$.ajax({
				url: host + "/account/updatesettings?access_token="+token,
				type: "POST",
				data: args,
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(html)
				{
					if (html.meta.code == 200)
					{
						if (html.response.result == "success") {
						 	// active state
							
							if (html.response.option) {
								$(a).attr("class", "active");
							}
							else {
								$(a).attr("class", "");
							}
							
							init.Social();
						
						}
						else {
							
							$(a).attr("class", current_class);
							
							Error.handle("Oh no! There was an issue with your request, please try again", "", html.meta.code);
						}
					}
					else
					{
						$(a).attr("class", current_class);
						
						Error.handle(html.meta.error_detail, html.meta.error_type, html.meta.code);
					}
				}
			});
		}	
		
	},
	update_profile: function(a) {
				
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var args = $("#settings-form").serialize();
			
			$("#update_profile_btn").hide();
			$("#update_profile_loader").show();
			
			$.ajax({
				url: host + "/account/updateprofile?access_token="+token,
				type: "POST",
				data: args,
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#update_profile_btn").show();
					$("#update_profile_loader").hide();
					
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(html)
				{
					$("#update_profile_btn").show();
					$("#update_profile_loader").hide();
					
					if (html.meta.code == 200)
					{
						if (html.response.result == "success") {
							
							var obj = {};
							obj["message"] = "Your profile has been updated.";
							
							/*var source   = $("#warning-template").html();
							var template = Handlebars.compile(source);*/

							var template = Handlebars.templates['notice-template.tmpl'];
							var html = template(obj);

							$("#notice-error").html(html);

							Util.openPop();

							Util.closePopTimeout(3000);
							
						}
						else {
							Error.handle("Oh no! There was an issue with your request, please try again", "", html.meta.code);
						}
					}
					else
					{
						Error.handle(html.meta.error_detail, html.meta.error_type, html.meta.code);
					}
				}
			});
		}
		
	},
	get_user_details: function(){
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var owner = myStorage.view("currentUser");
			$("#account-update-form #name").val(owner.name);
			$("#account-update-form #username").val(owner.username);
			$("#account-update-form #email").val(owner.email);
			$("#account-update-form li span").html(''); 
		}
	},
	get_user_info: function(){
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var owner = myStorage.view("currentUser");
			$("#account-info-form #name").val(owner.name);
			$("#account-info-form #body").val(owner.body);
			$("#account-info-form #gender").val(owner.gender);
			
			for(var key in owner.information) {
				for(var key1 in owner.information[key]) {
					//console.log(key1+'='+owner.information[key][key1]); 
					$("#account-info-form #opensocial-"+key1).val(owner.information[key][key1]);
				}
			}
		}
	},
	validate: function(form,key) {
			var value=$(form+" #"+key).val();
			console.log(value);
			var owner = myStorage.view("currentUser");
			if(key=='username'){
				var key_value=owner.username;
			}else if(key=='email'){
				var key_value=owner.email;
			}
			if(value!=''){
				if(value!=key_value){
				var endURL=host+"/index.php?option=com_people&view=person";
				ajaxStatement = $.ajax({
				url: endURL,
				type: "POST",
				data: {action:'validate',key:key,value:value},
				dataType: "json",
			    error: function(xhr,ajaxOptions, thrownError)
				{
					$(form+" span."+key).html('<img src="assets/images/clear_btn.png" height="20">');
				},
				success: function(html)
				{
					$(form+" span."+key).html('<img src="assets/images/quick_check.png" height="20">');
				}
				});
				}
			}else{
				$(form+" span."+key).html('<img src="assets/images/clear_btn.png" height="20">');
			}
	},
	update_account: function(form){
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var owner = myStorage.view("currentUser");
			var name=$("#account-update-form #name").val();
			var username=$("#account-update-form #username").val();
			var email=$("#account-update-form #email").val();
			if(name!='' && username!='' && email!=''){
				$("#account-form_btn").hide();
				$("#account-form_loader").show();
				var endURL=host+"/index.php?option=com_people&view=person&id="+owner.id;
				ajaxStatement = $.ajax({
				url: endURL,
				type: "POST",
				data: {name:name,username:username,email:email},
				dataType: "json",
			    error: function(xhr,ajaxOptions, thrownError)
				{
					$("#account-form_btn").show();
					$("#account-form_loader").hide();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(html)
				{
					$("#account-form_btn").show();
					$("#account-form_loader").hide();
					$('#account-update-notice').removeClass('hide');
					myStorage.save("currentUser",  html);
					window.setTimeout(function(){$("#account-update-notice").addClass("hide");}, 5000);
				}
				});
			}
		}
	},
	update_info: function(form){
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var owner = myStorage.view("currentUser");
			var name=$(form+" #name").val();
			var body=$(form+" #body").val();
			var gender=$(form+" #gender").val();
			var args = $(form).serialize();
				$("#account_info_btn").hide();
				$("#account_info_loader").show();
				var endURL=host+"/index.php?option=com_people&view=person&id="+owner.id;
				ajaxStatement = $.ajax({
				url: endURL,
				type: "POST",
				data: args,
				dataType: "json",
			    error: function(xhr,ajaxOptions, thrownError)
				{
					$("#account_info_btn").show();
					$("#account_info_loader").hide();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(html)
				{
					$("#account_info_btn").show();
					$("#account_info_loader").hide();
					$('#account-info-notice').removeClass('hide');
					myStorage.save("currentUser",  html);
					window.setTimeout(function(){$("#account-info-notice").addClass("hide");}, 5000);
				}
				});
		}
	}
}