var Social = {
	start: function(a) {
		
		var obj = {};
		obj["message"] = "Are you sure you want remove this social account?";
		obj["action_btn"] = "<a href='javascript:void(0);' onclick='Social.remove(\""+a+"\");' rel='action-btn' class='yellow_btn'>Confirm</a>";
		
		/*var source   = $("#warning-template").html();
		var template = Handlebars.compile(source);*/
		
		var template = Handlebars.templates['warning-template.tmpl']
		var html = template(obj);
		
		$("#notice-error").html(html);

		Util.openPop();
	},
	start_connect: function(a) {
		
		if (phonegap) {
			
			var token = Validate.token();

			if (!token)
			{
				Error.token();
			}
			else
			{
				if (a == "facebook") {

					facebookConnect.login({permissions: ["email", "user_about_me", "user_location", "publish_stream", "publish_actions", "photo_upload"], appId: client_id_fb}, function(results) {
			    		//var results = JSON.stringify(result);

			    		console.log("typeof :" + typeof results);
			    		
			    		if (results.error) {

			    			var obj = {};
							obj["message"] = "We had a problem connecting with Facebook.";
							obj["action_btn"] = "You can connect your Facebook account to Neuros once you complete the sign up process."

							/*var source   = $("#warning-template").html();
							var template = Handlebars.compile(source);*/

							var template = Handlebars.templates['notice-template.tmpl'];
							var html = template(obj);

							$("#notice-error").html(html);

							Util.openPopTimeout();
			    		}
			    		else {

			    			if (results.accessToken && results.first_name) {
			    				var social_account = results.accessToken;
				    			var firstName = results.first_name;
				    			var lastName = results.last_name;
				    			var account_name = firstName + " " + lastName;
				    			var account_id = results.id; 

				    			var args = "social_type=facebook&social_token="+social_account+"&account_id="+account_id+"&account_name="+account_name;

				    			console.log(args);
						
								$.ajax({
									url: host + "/account/addsocial?access_token="+token,
									type: "POST",
									data: args,
									dataType: "json",
								    error: function(html)
									{
										alert("error!");
										var obj = {};
										obj["message"] = "We had a problem connecting with Facebook.";
										obj["action_btn"] = "You can connect your Facebook account to Neuros once you complete the sign up process."

										/*var source   = $("#warning-template").html();
										var template = Handlebars.compile(source);*/

										var template = Handlebars.templates['notice-template.tmpl'];
										var html = template(obj);

										$("#notice-error").html(html);

										Util.openPopTimeout();
									},
									success: function(html)
									{
										console.log(html.meta.code);
										if (html.meta.code == 200)
										{
											init.Social(true);
											$(".facebook").attr("onclick", 'Social.toggle("facebook", "fb");');	
											Social.toggle("facebook", "fb");
										}
										else
										{
											Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
										}
									}
								});
			    			}
			    			else {
			    				var obj = {};
								obj["message"] = "We had a problem connecting with Facebook.";
								obj["action_btn"] = "You can connect your Facebook account to Neuros once you complete the sign up process."

								/*var source   = $("#warning-template").html();
								var template = Handlebars.compile(source);*/

								var template = Handlebars.templates['notice-template.tmpl'];
								var html = template(obj);

								$("#notice-error").html(html);

								Util.openPopTimeout();
			    			}
			    		}
			    	});
				}
				else {
					window.plugins.childBrowser.showWebPage("http://neuros.org/auth/"+a+"?access_token="+token);
					window.plugins.childBrowser.onLocationChange = function(loc){Social.onLocationChange(loc, a);};
				}
			}
		}
		else {
			alert("Not supported in the web version.")
		}
	},
	onLocationChange: function(newloc, a) {

		console.log("LOC IS: " + newloc.indexOf("account/settings/social"));

		if(newloc.indexOf("account/settings/social") >= 19)
		{
			var obj = newloc.split("?");
			if (obj[1]) {
			    var obj_2 = obj[1].split("&");
				
				window.plugins.childBrowser.close();
				
			    if (obj_2[1] == "result=success") {
					init.Social(true);
					
					if (a == "twitter") {
						$(".twitter").attr("onclick", 'Social.toggle("twitter", "tw");');						
						Social.toggle("twitter", "tw");
					}
					else if (a == "facebook") {
						
						$(".facebook").attr("onclick", 'Social.toggle("facebook", "fb");');	
						Social.toggle("facebook", "fb");
					}
					else {
						$(".foursquare").attr("onclick", 'Social.toggle("foursquare", "4sq");');	
						Social.toggle("foursquare", "4sq");
					}
				}
				else 
				{
					if (obj_2[1] == "result=dupe") {
						Error.handle("You appear to already have this account social account linked to an Neuros profile. Please try again.", "", "");
					}
					else {
						Error.handle("We had a problem linking your social account. Please try again.", "", "");
					}
				}

			}
			else {
				window.plugins.childBrowser.close();
				
				Error.handle("We had a problem linking your social account. Please try again.", "", "");
			}
		}
	},
	remove: function(a) {
		
		Util.closePop();
		
		$("#"+a+"_container").hide();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var args = "social_type="+a;
			
		 	$.ajax({
				url: host + "/account/removesocial?access_token="+token,
				type: "POST",
				data: args,
				dataType: "json",
			     error: function(html)
				{
					// error goes here
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						init.Social();			
					}
					else
					{
						$("#"+a+"_container").show();
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
			
		}
	},
	toggle: function(b,a){
		
		if ($("."+b).hasClass("active")) {
			$("."+b).removeClass('active');
			$("#"+a).val("off");
		}
		else {
			$("."+b).addClass('active');
			$("#"+a).val("on");
		}
		
	},
	scan_check: function(a) {
		
		var u = myStorage.view("socialSettings");

		if (u) {
			
			var auto = myStorage.view("socialSettings");
			
			if (a == "twitter") {
				if (auto.user.contact.twitter) {
					return true;
				}
				else {
					return false;
				}
			}
			else if (a == "facebook") {
				if (auto.user.contact.facebook) {
					return true;
				}
				else {
					return false;
				}
			}
			else if (a == "foursquare") {
				if (auto.user.contact.foursquare) {
					return true;
				}
				else {
					return false;
				}
			}
		}
		else {
			return false;
		}
	},
	check: function(a) {
		
		var u = myStorage.view("socialSettings");

		if (u) {
			
			var auto = myStorage.view("socialSettings");
			
			if (a == "twitter") {
				if (auto.user.contact.twitter) {
					return true;
				}
				else {
					Social.start_connect('twitter');
				}
			}
			else if (a == "facebook") {
				if (auto.user.contact.facebook) {
					return true;
				}
				else {
					Social.start_connect('facebook');
				}
			}
			else if (a == "foursquare") {
				if (auto.user.contact.foursquare) {
					return true;
				}
				else {
					Social.start_connect('foursquare');
				}
			}
		}
		else {
			Social.start_connect(a);
		}
	},
	automate: function() {
		
		var auto = myStorage.view("socialSettings");
		
		if (auto) {
			if (parseInt(auto.user.settings.checkin.checkin_to_twitter) == 1) {
				$(".twitter").addClass('active');
				$("#tw").val("on");
			}
			else {
				$(".twitter").removeClass('active');
				$("#tw").val("off");
			}
		
			if (parseInt(auto.user.settings.checkin.checkin_to_facebook) == 1) {
				$(".facebook").addClass('active');
				$("#fb").val("on");
			}
			else {
				$(".facebook").removeClass('active');
				$("#fb").val("off");
			}
		
			if (parseInt(auto.user.settings.checkin.checkin_to_foursquare) == 1) {
				$(".foursquare").addClass('active');
				$("#4sq").val("on");
			}
			else {
				$(".foursquare").removeClass('active');
				$("#4sq").val("off");
			}
		}
	},
	check_social_confirm: function(a) {
		
		var u = myStorage.view("socialSettings");

		if (u) {
						
			if (a == "twitter") {
				if (u.user.contact.twitter) {
					Social.toggle('twitter', "tw");
				}
				else {
					Social.start_connect('twitter');
				}
			}
			else if (a == "facebook") {
				if (u.user.contact.facebook) {
					Social.toggle('facebook', "fb");
				}
				else {
					Social.start_connect('facebook');
				}
			}
			else if (a == "foursquare") {
				if (u.user.contact.foursquare) {
					Social.toggle('foursquare', "4sq");
				}
				else {
					Social.start_connect('foursquare');
				}
			}
			else {
				
			}
		}
		else {
			Social.start_connect(a);
		}
	}
	
}

