(function() {
  var template = Handlebars.template, templates = Handlebars.templates = Handlebars.templates || {};
	templates['actor-profile-template.tmpl'] = template(function (Handlebars,depth0,helpers,partials,data) {
	helpers = helpers || Handlebars.helpers;
  var buffer = "", stack1, foundHelper, functionType="function", escapeExpression=this.escapeExpression, self=this, helperMissing=helpers.helperMissing;
	var owner = myStorage.view("currentUser");
	var component='';
	if(depth0.objectType=="com.groups.group"){
		component="group";
		var Utype="group";
	}else if(depth0.objectType=="com.people.person"){
		component="person";
		var Utype="people";
	}
	var commands=depth0.commands;
	var unfollow = commands.indexOf("unfollow");
	if(depth0.imageURL.small){
	var image='<img width="100%" src="'+depth0.imageURL.small.url+'">';
	}else{
	var image='<img width="100%" src="assets/images/icon-profile.png">';
	}
	buffer+='<div class="profile_top">';
	
		buffer+='<span class="avatar_wrapper large">';
		if(commands.indexOf("edit")!=-1){
			buffer+='<a class="change_avatar" onclick="MenuToggle.profile_picture();" data-analytics="menuToggle_profileChange" rel="action-btn" href="javascript:void(0);"><span><strong>CHANGE</strong></span></a>';
		}
		buffer+=image+'</span>';
		buffer+='<div class="profile_details"><h1>'+depth0.name+'</h1>';
		if(depth0.body!=null){
			buffer+='<h2>'+depth0.body+'</h2>';
		}
		if(depth0.information){
			if(depth0.information['EDUCATION-INFORMATION']){
				if(depth0.information['EDUCATION-INFORMATION'].degree && depth0.information['EDUCATION-INFORMATION'].degree!=''){
					buffer+='<h2><strong>Graduation:</strong> '+depth0.information['EDUCATION-INFORMATION'].degree;
					if(depth0.information['EDUCATION-INFORMATION']['year-of-graduation'] && depth0.information['EDUCATION-INFORMATION']['year-of-graduation']!='')
					buffer+=','+depth0.information['EDUCATION-INFORMATION']['year-of-graduation'];
					buffer+='</h2>';
				}
				if(depth0.information['EDUCATION-INFORMATION'].college && depth0.information['EDUCATION-INFORMATION'].college!=''){
					buffer+='<h2><strong>College:</strong> '+depth0.information['EDUCATION-INFORMATION'].college+'</h2>';
				}
			}
		}
		
	buffer+='</div>';
	if(depth0.id==owner.id)
		buffer+='<a href="#!/profileInfo" class="actor-profile-edit">Edit profile</a>'
	buffer+='</div>';
	
	buffer+='<div id="profileDetailsArea">';
	buffer+='<div class="follow_loader follow_loader_'+depth0.id+' hide" style="text-align: center;"><img src="assets/images/spinner.gif" width="24" height="24"></div>';
	if(commands.indexOf("follow")!=-1){
		buffer+='<div id="follow_action_'+depth0.id+'"><a onclick="Wish.follow('+depth0.id+', this,\''+depth0.objectType+'\');" data-analytics="wishList_follow" rel="action-btn" href="javascript:void(0);" class="yellow_btn small button"><span><strong>Follow</strong></span></a></div>';
		buffer+='<div id="unfollow_action_'+depth0.id+'" style="display:none"><a onclick="Wish.unfollow('+depth0.id+', this,\''+depth0.objectType+'\');" data-analytics="wishList_unfollow" rel="action-btn" href="javascript:void(0);" class="grey_btn small button"><span><strong>Unfollow</strong></span></a></div>';
	}else if(commands.indexOf("unfollow")!=-1){
		buffer+='<div id="follow_action_'+depth0.id+'" style="display:none"><a onclick="Wish.follow('+depth0.id+', this,\''+depth0.objectType+'\');" data-analytics="wishList_follow" rel="action-btn" href="javascript:void(0);" class="yellow_btn small button"><span><strong>Follow</strong></span></a></div>';
		buffer+='<div id="unfollow_action_'+depth0.id+'"><a onclick="Wish.unfollow('+depth0.id+', this,\''+depth0.objectType+'\');" data-analytics="wishList_unfollow" rel="action-btn" href="javascript:void(0);" class="grey_btn small button"><span><strong>Unfollow</strong></span></a></div>';
	}
		buffer+='<div class="profile_stats">';
		
			buffer+='<div><span>Followers:</span><p>'+depth0.followerCount+'</p></div>';
			if(component=="person"){buffer+='<div><span>Following:</span><p>'+depth0.leaderCount+'</p></div>';}
		buffer+='</div>';
		
		buffer+='<div class="profile profile_menu"><ul>';
		
			buffer+='<li><a href="#!/topicArea/'+depth0.id+'/'+component+'">Questions</a></li>';
			
			buffer+='<li><a href="#!/photoArea/'+depth0.id+'/'+component+'">Photos</a></li>';
			
			buffer+='<li><a href="#!/pageArea/'+depth0.id+'/'+component+'">Pages</a></li>';
		
		if(depth0.information && depth0.objectType!="com.groups.group"){
			buffer+='<li><a href="#!/profileInfoArea/'+depth0.id+'">Information</a></li>';
		}
		buffer+='</ul></div></div>';
		
		if(depth0.composers.notes && depth0.objectType!="com.groups.group"){
			buffer+='<div id="story_add1"><div class="comment_box tab-view" style="margin-bottom: 20px;">';
			buffer+='<form onsubmit="Feed.story_post(this,'+depth0.id+'); return false;">';
			buffer+='<input type="hidden" name="page" value="#!/actorArea/'+Utype+'/'+depth0.id+'"><input id="story_body" type="text" class="needsclick" name="body" placeholder="Share Status">';
			buffer+='</form></div>';
			buffer+='<div id="story_inner_spinner" class="loading_inner hide"><img src="assets/images/spinner.gif" width="24" height="24"><br><br></div></div>';
		}
	buffer+='<div class="blue_bar">Recent Activity</div><div class="recent_activity"></div>';
	
	
	
 return buffer;
});
})();