(function() {
  var template = Handlebars.template, templates = Handlebars.templates = Handlebars.templates || {};
templates['beer-edit-template.tmpl'] = template(function (Handlebars,depth0,helpers,partials,data) {
  helpers = helpers || Handlebars.helpers;
  var buffer = "", stack1, foundHelper, self=this, functionType="function", helperMissing=helpers.helperMissing, undef=void 0, escapeExpression=this.escapeExpression;


  buffer += "<div class=\"flash\" id=\"beer_edit_screen\" style=\"display: none;\">Your changes were submitted to a Moderator for review.</div>\n<div class=\"beer_edit_text friends_search_text\"> <strong>See something wrong?</strong> Help us out and suggest an edit.<br />We will then review your change. </div>\n<div class=\"list\">\n<div class=\"list_box\"> <a href=\"javascript:void(0);\" rel=\"action-btn\"> <img width=\"50\" height=\"50\" src=\"";
  foundHelper = helpers.beer;
  stack1 = foundHelper || depth0.beer;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.beer_label);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "beer.beer_label", { hash: {} }); }
  buffer += escapeExpression(stack1) + "\">\n  <div>\n    <h2>";
  foundHelper = helpers.beer;
  stack1 = foundHelper || depth0.beer;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.beer_name);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "beer.beer_name", { hash: {} }); }
  buffer += escapeExpression(stack1) + "</h2>\n    <h3>";
  foundHelper = helpers.brewery;
  stack1 = foundHelper || depth0.brewery;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.brewery_name);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "brewery.brewery_name", { hash: {} }); }
  buffer += escapeExpression(stack1) + "</h3>\n    <p><strong>Style: </strong>";
  foundHelper = helpers.beer;
  stack1 = foundHelper || depth0.beer;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.beer_style);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "beer.beer_style", { hash: {} }); }
  buffer += escapeExpression(stack1) + "</p>\n  </div>\n  </a>\n</div>\n<div class=\"account\">\n  <form id=\"edit-beer-form\">\n    <ul>\n      <li>\n        <input class=\"standard\" type=\"text\" autocaptialize=\"true\" autocorrect=\"false\" autocomplete=\"false\" name=\"beer_name\" id=\"beer_form_name\" placeholder=\"Beer Name\" value=\"";
  foundHelper = helpers.beer;
  stack1 = foundHelper || depth0.beer;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.beer_name);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "beer.beer_name", { hash: {} }); }
  buffer += escapeExpression(stack1) + "\">\n      </li>\n      <li>\n        <input class=\"standard\" type=\"text\" autocaptialize=\"true\" autocorrect=\"false\" autocomplete=\"false\" name=\"beer_abv\" placeholder=\"ABV (ex. 4.0)\" value=\"";
  foundHelper = helpers.beer;
  stack1 = foundHelper || depth0.beer;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.beer_abv);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "beer.beer_abv", { hash: {} }); }
  buffer += escapeExpression(stack1) + "\">\n      </li>\n      <li>\n        <input class=\"standard\" type=\"text\" autocaptialize=\"true\" autocorrect=\"false\" autocomplete=\"false\" name=\"beer_ibu\" placeholder=\"IBU (ex. 150)\" value=\"";
  foundHelper = helpers.beer;
  stack1 = foundHelper || depth0.beer;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.beer_ibu);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "beer.beer_ibu", { hash: {} }); }
  buffer += escapeExpression(stack1) + "\">\n      </li>\n      <li>\n        <select id=\"beer_types_edit\" name=\"beer_type\" class='dropdown standard'>\n          <option value=\"0\">Styles are Loading...</option>\n        </select>\n      </li>\n      <li>\n        <textarea name=\"beer_description\" class=\"standard\" placeholder=\"Describe this beer (optional)\">";
  foundHelper = helpers.beer;
  stack1 = foundHelper || depth0.beer;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.beer_description);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "beer.beer_description", { hash: {} }); }
  buffer += escapeExpression(stack1) + "</textarea>\n      </li>\n    </ul>\n  </form>\n</div>\n<div id=\"edit-loading\" style=\"display: none;\" class=\"loading_inner\"> <img src=\"assets/images/spinner.gif\" width=\"24\" height=\"24\" /><br />\n  <br />\n  <p>Loading...</p>\n</div>\n<span id=\"edit-btns\"> <a href=\"#\" rel=\"action-btn\" onclick=\"propose.save_edit(";
  foundHelper = helpers.beer;
  stack1 = foundHelper || depth0.beer;
  stack1 = (stack1 === null || stack1 === undefined || stack1 === false ? stack1 : stack1.bid);
  if(typeof stack1 === functionType) { stack1 = stack1.call(depth0, { hash: {} }); }
  else if(stack1=== undef) { stack1 = helperMissing.call(depth0, "beer.bid", { hash: {} }); }
  buffer += escapeExpression(stack1) + ", $('#edit-beer-form')); return false;\" class=\"yellow_btn large\"> Propose Edit </a> <a href=\"#\" rel=\"action-btn\" onclick=\"Nav.goBack(); return false;\" class=\"grey_btn small\"> Cancel </a> </span>\n</div>\n";
  return buffer;});
})();