(function() {
  var template = Handlebars.template, templates = Handlebars.templates = Handlebars.templates || {};
templates['confirm-template.tmpl'] = template(function (Handlebars,depth0,helpers,partials,data) {
  helpers = helpers || Handlebars.helpers;
  var buffer = "", stack1, foundHelper, functionType="function", escapeExpression=this.escapeExpression, helperMissing=helpers.helperMissing;


  buffer += " <div class=\"check_in_confirm\">\n\n	<div class=\"list_box\">\n		<img src=\"";
  stack1 = depth0.beer;
  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.beer_label;
  stack1 = typeof stack1 === functionType ? stack1() : stack1;
  buffer += escapeExpression(stack1) + "\">\n			<div>\n				<h2>";
  stack1 = depth0.beer;
  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.beer_name;
  stack1 = typeof stack1 === functionType ? stack1() : stack1;
  buffer += escapeExpression(stack1) + "</h2>\n				<h3>";
  foundHelper = helpers.breweryBeer;
  stack1 = foundHelper ? foundHelper.call(depth0, depth0, {hash:{}}) : helperMissing.call(depth0, "breweryBeer", depth0, {hash:{}});
  buffer += escapeExpression(stack1) + "</h3>\n			</div>\n	</div>\n\n	<div id=\"foursquare_area\">\n		<a href=\"#!/locationArea/";
  stack1 = depth0.beer;
  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.bid;
  stack1 = typeof stack1 === functionType ? stack1() : stack1;
  buffer += escapeExpression(stack1) + "\" class=\"addLocationBtn confirm yellow_btn large\">Add Location</a>\n	</div>\n\n	<div class=\"comment_photo\">\n\n		<span class=\"add_photo yellow_btn\">\n			<a href=\"javascript:void(0);\" onclick=\"Photo.toggle();\" data-analytics=\"photoToggle_btn\" rel=\"action-btn\" id=\"addPhotoContent\"></a>\n		</span>\n\n		<form id=\"confirm_form\" accept-charset=\"UTF-8\">\n\n			<span id=\"checkin-counter\" class=\"counter\">140</span>\n\n			<textarea name=\"shout\" class=\"needsclick\" id=\"checkin-comment\" onkeyup=\"Limiter.limit('checkin-comment', 'checkin-counter', 140);\" placeholder=\"How was it? Leave a note...\" class=\"comment\"></textarea>\n\n			<input type=\"hidden\" name=\"bid\" id=\"bid\" value=\"";
  stack1 = depth0.beer;
  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.bid;
  stack1 = typeof stack1 === functionType ? stack1() : stack1;
  buffer += escapeExpression(stack1) + "\" />\n			<input type=\"hidden\" name=\"gmt_offset\" id=\"gmt_offset\" value=\"";
  foundHelper = helpers.timeZoneOffset;
  stack1 = foundHelper ? foundHelper.call(depth0, depth0, {hash:{}}) : helperMissing.call(depth0, "timeZoneOffset", depth0, {hash:{}});
  buffer += escapeExpression(stack1) + "\" />\n			<input type=\"hidden\" name=\"timezone\" id=\"timezone\" value=\"";
  foundHelper = helpers.timeZone;
  stack1 = foundHelper ? foundHelper.call(depth0, depth0, {hash:{}}) : helperMissing.call(depth0, "timeZone", depth0, {hash:{}});
  buffer += escapeExpression(stack1) + "\" />\n			<input type=\"hidden\" name=\"facebook\" id=\"fb\" value=\"off\" />\n			<input type=\"hidden\" name=\"twitter\" id=\"tw\" value=\"off\" />\n			<input type=\"hidden\" name=\"foursquare\" id=\"4sq\" value=\"off\" />\n			<input type=\"hidden\" name=\"get_rec\" id=\"get_rec\" value=\"false\" />\n\n			<input type=\"hidden\" name=\"rating\" id=\"rating_score\" value=\"";
  foundHelper = helpers.rating;
  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
  else { stack1 = depth0.rating; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
  buffer += escapeExpression(stack1) + "\"/>\n\n			<input type=\"hidden\" name=\"geolat\" id=\"geolat\" value=\"";
  foundHelper = helpers.currentLocationLat;
  stack1 = foundHelper ? foundHelper.call(depth0, depth0, {hash:{}}) : helperMissing.call(depth0, "currentLocationLat", depth0, {hash:{}});
  buffer += escapeExpression(stack1) + "\" />\n			<input type=\"hidden\" name=\"geolng\" id=\"geolng\" value=\"";
  foundHelper = helpers.currentLocationLng;
  stack1 = foundHelper ? foundHelper.call(depth0, depth0, {hash:{}}) : helperMissing.call(depth0, "currentLocationLng", depth0, {hash:{}});
  buffer += escapeExpression(stack1) + "\" />\n			<input type=\"hidden\" name=\"foursquare_id\" id=\"foursquare_id\" value=\"\" />\n\n			<input type=\"hidden\" name=\"is_photo\" id=\"is_photo\" value=\"false\" />\n			<input type=\"hidden\" name=\"photo_data\" id=\"photo_data\" value=\"\" />\n\n			<input type=\"hidden\" name=\"is_reco\" id=\"is_reco\" value=\"0\" />\n\n		</form>\n\n	</div>\n\n\n	<div class=\"rate_beer\" style=\"display: none;\">What do you think? Rate this beer...\n\n		 <input type=\"text\" id=\"ratingSlider\" data-slider=\"true\" data-slider-values=\"0,1,1.5,2,2.5,3,3.5,4,4.5,5\" data-slider-snap=\"true\">\n		 <div class=\"rating_output\"><p class=\"output\"></p></div>\n\n	</div>\n\n	<div class=\"share\">\n		<p>Share This:</p>\n			<ul>\n					<li class=\"facebook\" rel=\"action-btn\" onclick=\"Social.check_social_confirm('facebook');\"><a rel=\"action-btn\" href=\"javascript:void(0);\">Share on Twitter</a></li>\n					<li class=\"twitter\" rel=\"action-btn\" onclick=\"Social.check_social_confirm('twitter');\"><a rel=\"action-btn\" href=\"javascript:void(0);\">Share on Facebook</a></li>\n					<li class=\"foursquare\" rel=\"action-btn\" style=\"display: none;\" id=\"foursquare_social\" onclick=\"Social.check_social_confirm('foursquare');\"><a rel=\"action-btn\" href=\"javascript:void(0);\">Share on Foursquare</a></li>\n			</ul>\n	</div>\n\n	<a id=\"check-in-btn\" href=\"javascript:void(0);\" rel=\"action-btn\" class=\"confirm yellow_btn large button\">Confirm Your Brew</a>\n\n	<div id=\"check-in-loader\" class=\"loading_inner\" style=\"display:none;\">\n		<img src=\"assets/images/spinner.gif\" width=\"24\" height=\"24\" />\n	</div>\n\n\n	<div id=\"checkinbid_";
  stack1 = depth0.beer;
  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.bid;
  stack1 = typeof stack1 === functionType ? stack1() : stack1;
  buffer += escapeExpression(stack1) + "\" style=\"display: none;\">";
  foundHelper = helpers.jason;
  stack1 = foundHelper ? foundHelper.call(depth0, depth0, {hash:{}}) : helperMissing.call(depth0, "jason", depth0, {hash:{}});
  buffer += escapeExpression(stack1) + "</div>\n\n</div>";
  return buffer;});
})();