(function() {
  var template = Handlebars.template, templates = Handlebars.templates = Handlebars.templates || {};
templates['dashboard-template.tmpl'] = template(function (Handlebars,depth0,helpers,partials,data) {
  helpers = helpers || Handlebars.helpers;
  var i=0,stack1, stack2, foundHelper, tmp1, self=this, functionType="function", helperMissing=helpers.helperMissing, undef=void 0, escapeExpression=this.escapeExpression;

function program1(depth0,data) {
  //edited by vissu
 
  var image;
  var unixtime="";
unixtime=moment().max(depth0.creatiomTime);
  unixtime.seconds(19800);
unixtime=moment(unixtime).fromNow();
  var buffer='';
  var default_image='';
  if(depth0.subject){
  	if(depth0.subject.imageURL.small){
  		image='<div class="user-block"><a href="#!/actorArea/people/'+depth0.subject.id+'"><img width="42" height="42" src="'+depth0.subject.imageURL.small.url+'" class="lazy avatar"></a></div>';
  	}else{
  		image='<div class="user-block"><a href="#!/actorArea/people/'+depth0.subject.id+'"><img width="42" height="42" src="assets/images/icon-profile.png" class="lazy avatar"></a></div>';
  	}
  }else if(!depth0.subject && depth0.object){
  	  if(depth0.object.author.imageURL.small){
  		image='<div class="user-block"><a href="#!/actorArea/people/'+depth0.object.author.id+'"><img width="42" height="42" src="'+depth0.object.author.imageURL.small.url+'" class="lazy avatar"></a></div>';
	  }else{
	  	image='<div class="user-block"><a href="#!/actorArea/people/'+depth0.object.author.id+'"><img width="42" height="42" src="assets/images/icon-profile.png" class="lazy avatar"></a></div>';
	  }
  }
  if(depth0.subjects){
	var uName=depth0.subjects[0].name;
  }else if(depth0.subject){
  	var uName=depth0.subject.name;
  }
  if(depth0.objects){
	var objId=depth0.objects[0].id;
	if(depth0.objects[0].imageURL)
	var objImg=depth0.objects[0].imageURL.small.url;
  }else if(depth0.object){
  	var objId=depth0.object.id;
  	if(depth0.object.imageURL)
  	var objImg=depth0.object.imageURL.small.url;
  }
  switch (depth0.name)
  {
  	case "note_add":buffer+='<div class="list_box">'+image;
  					
  					buffer+='<a href="#!/storyArea/note/'+objId+'">'+depth0.object.author.name;
  					if(depth0.object.author.id!=depth0.object.owner.id)
  					buffer+=' shared a note <br><span class="onProfile">on '+depth0.object.owner.name+' profile<span>';
  					
  					buffer+='</a>';
  					buffer+='<a href="#!/storyArea/note/'+objId+'"><div class="details"><div class="body">'+depth0.object.body+'</div></div></a>';
  					buffer+='<div class="when timeago" data-greg-time="'+unixtime+'">'+unixtime+'</div></div>';
  					break;
  			
  	case "topic_add":buffer+='<div class="list_box">';
  					 buffer+='<div class="header">'+image+'<a href="#!/storyArea/topic/'+objId+'">'+depth0.object.author.name+' started a question';
  					if(depth0.object.author.id!=depth0.object.owner.id)
  					buffer+='<br><span class="onProfile">on '+depth0.object.owner.name+' profile<span>';
  					
  					 buffer+='</a></div>';
  					 buffer+='<a href="#!/storyArea/topic/'+objId+'"><div class="details"><div class="title"><p>'+depth0.object.name+'</p></div><div class="body">'+depth0.object.body+'</div></div></a>';
  					 buffer+='<div class="when timeago" data-greg-time="'+unixtime+'">'+unixtime+'</div></div>';
  					 break;
  			
  	case "note_comment":buffer+='<div class="list_box">'+image;
  					buffer+='<a href="#!/storyArea/note/'+objId+'">'+uName+' commented on the note</a>';
  					buffer+='<a href="#!/storyArea/note/'+objId+'"><div class="details"><div class="body">'+depth0.object.body+'</div></div></a>';
  					buffer+='<div class="when timeago">'+unixtime+'</div></div>';
  					break;
  			
  	case "topic_comment":buffer+='<div class="list_box">';
  					 buffer+='<div class="header">'+image+'<a href="#!/storyArea/topic/'+objId+'">'+uName+' commented on the question</a></div>';
  					 buffer+='<a href="#!/storyArea/topic/'+objId+'"><div class="details"><div class="title"><p>'+depth0.object.name;
  					 if(depth0.object.owner.objectType=="com.groups.group"){
						buffer+='<span>on '+depth0.object.owner.name+'s profile</span>';
					 }
  					 buffer+='</p></div><div class="body">'+depth0.object.body+'</div></div></a>';
  					 buffer+='<div class="when timeago">'+unixtime+'</div></div>';
  					 break;
  			
  	case "photo_add":buffer+=dashboard_photo(depth0,image,unixtime,' shared');
  					break;
  			
  	case "photo_comment":buffer+=dashboard_photo(depth0,image,unixtime,' comment on');
  					break;
  			
  	case "page_add":buffer+='<div class="list_box">';
					buffer+='<div class="header">'+image+'<a href="#!/storyArea/page/'+objId+'">'+depth0.object.author.name+' shared a page';
  					if(depth0.object.author.id!=depth0.object.owner.id)
  					buffer+='<br><span class="onProfile">on '+depth0.object.owner.name+' profile<span>';
  					
  					 buffer+='</a></div>';
					buffer+='<a href="#!/storyArea/page/'+objId+'"><div class="details"><div class="title"><p>'+depth0.object.name+'</p></div><div class="body">'+depth0.object.body+'</div></div></a>';
					buffer+='<div class="when timeago">'+unixtime+'</div></div>';
					break;
  			
  	case "page_comment":buffer+='<div class="list_box">';
					buffer+='<div class="header">'+image+'<a href="#!/storyArea/page/'+objId+'">'+uName+' commented on a page</a></div>';
					buffer+='<a href="#!/storyArea/page/'+objId+'"><div class="details"><div class="title"><p>'+depth0.object.name+'</p></div><div class="body">'+depth0.object.body+'</div></div></a>';
					buffer+='<div class="when timeago">'+unixtime+'</div></div>';
					break;
  					
  					
  	default:buffer+='';
  					break;
  }
  i++;
  return buffer;
 }
function dashboard_photo(depth0,image,unixtime,text){
	
	var buffer='';
	if(depth0.objects){
		var objId=depth0.objects[0].id;
		if(depth0.objects[0].imageURL)
		var objImg=depth0.objects[0].imageURL.small.url;
		var object=depth0.objects[0];
	}else if(depth0.object){
		var objId=depth0.object.id;
	  	if(depth0.object.imageURL)
	  	var objImg=depth0.object.imageURL.small.url;
		var object=depth0.object;
	}
	buffer+='<div class="list_box activity_item" style="padding: 0;"><div class="container" style="padding: 0;">';
  	buffer+='<div class="details">'+image+'<div class="when timeago">'+unixtime+'</div><a href="#!/storyArea/photo/'+objId+'" class="node-text">'+depth0.subject.name+text+' a photo</a>';
  	buffer+='<a href="#!/storyArea/photo/'+objId+'"><div class="title clr"><p>';
  	
  	if(object.name!=null){buffer+=object.name}
  	
  	buffer+='</p></div><div class="comment hasrating clr">';
  	
  	if(object.body!=null){buffer+=object.body}
  	
  	buffer+='</div></a></div>';
  	buffer+='<div class="header has-photo"><a style="background-image: url('+objImg+');" class="photo" href="#!/storyArea/photo/'+objId+'"></a></div>';
  	buffer+='</div></div>';
	return buffer;
}

  foundHelper = helpers.items;
  stack1 = foundHelper || depth0.data;
  stack2 = helpers.each;
  tmp1 = self.program(1, program1, data);
  tmp1.hash = {};
  tmp1.fn = tmp1;
  tmp1.inverse = self.noop;
  stack1 = stack2.call(depth0, stack1, tmp1);
  if(stack1 || stack1 === 0) { return stack1; }
  else { return ''; }});
})();