 var Template = {
	discoverBars: function(location, data, b, d) {
		//var source   = $("#discoverBars-template").html();
		//var template = Handlebars.compile(source);

		if (b) {

			$("#pop_loader").hide();

			if (data.count == 0) {
				$("#see_more_pop").hide();
				$("#pop_loader").hide();
			}
			else {

				$("#see_more_pop").show();

				var template = Handlebars.templates['discoverBars-template.tmpl'];

				var html = template(data);

				console.log("yes");

				$("#discoverBarsHolder").append(html);
			}
		}
		else {
		
			if (data.count == 0) {
				var obj = {};
				obj["h2_message"] = "We can't seem to find any bars around your area!";
				obj["h3_message"] = "Use the filter option in the settings, to change your radius!";

				/*var source   = $("#empty-list-box").html();
				var template = Handlebars.compile(source);*/
				var template = Handlebars.templates['empty-list-box.tmpl'];
				var html = template(obj);

				$("#"+location).html(html);
			}
			else {
				var template = Handlebars.templates['discoverBars-template.tmpl'];

				var html = template(data);

				$("#"+location).html(html);
			}
		}
		
		if (d) {
			$("#see_more_pop").remove();
		}
		else {
			if ($(".discover_bars").length >= 10 && $("#see_more_pop").length == 0) {
				$("#discoverBarsHolder").after('<div id="pop_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_pop" href="javascript:void(0);" onclick="Discover.see_more_bars();" class="yellow_btn small button">See More Bars</a>')
			}
		}
		


		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();
	},
	discoverNearbyBars: function(location, data, b, d) {
		//var source   = $("#discoverBars-template").html();
		//var template = Handlebars.compile(source);

		if (b) {

			$("#pop_loader").hide();

			if (data.count == 0) {
				$("#see_more_pop").hide();
				$("#pop_loader").hide();
			}
			else {

				$("#see_more_pop").show();

				var template = Handlebars.templates['discoverbarsNearby-template.tmpl'];

				var html = template(data);

				console.log("yes");

				$("#discoverBarsHolder").append(html);
			}
		}
		else {
		
			if (data.count == 0) {
				var obj = {};
				obj["h2_message"] = "We can't seem to find any bars around your area!";
				obj["h3_message"] = "Use the filter option in the settings, to change your radius!";

				/*var source   = $("#empty-list-box").html();
				var template = Handlebars.compile(source);*/
				var template = Handlebars.templates['empty-list-box.tmpl'];
				var html = template(obj);

				$("#"+location).html(html);
			}
			else {
				var template = Handlebars.templates["discoverbarsNearby-template.tmpl"];

				var html = template(data);

				$("#"+location).html(html);
			}
		}
			
		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();
	},
	discoverBeers: function(location, data) {

		if (data.count == 0) {
			var obj = {};
			obj["h2_message"] = "We can't seem to find any beers around you!";
			obj["h3_message"] = "Use the filter options in the settings to change our radius!";

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/
			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);

			$("#"+location).html(html);
		}
		else {
			var template = Handlebars.templates['discoverBeers-template.tmpl'];

			var html = template(data);

			$("#"+location).html(html);

			$(".timeago").cuteTime({ refresh: 50000 });
		}

		refreshScroll.go();
	},
	trendingBeer: function(location_micro, location_macro, data) {
		/*var source   = $("#discoverTrending-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['discoverTrending-template.tmpl'];

		var html = template(data.micro);

		$("#"+location_micro).html(html);

		$(".timeago").cuteTime({ refresh: 50000 });

		var html = template(data.macro);

		$("#"+location_macro).html(html);

		refreshScroll.go();

	},
	cheers: function(location, data) {

		var template = Handlebars.templates['cheers-template.tmpl'];

		/*var source   = $("#cheers-template").html();
		var template = Handlebars.compile(source);*/
		var html = template(data);

		$("#"+location).html(html);

		if (data.badges.count != 0) {
			$(".stage").hide();
			$("#badge-results").show();
		}
		else if (data.promotions.count != 0) {
			$(".stage").hide();
			$("#promo-results").show();
		}
		else {

		}
		Feed.recommend_after(data.beer.beer_style_id);

		$("#tab_bar").removeClass('hide').addClass("show");

		refreshScroll.go();
	},
	recommend_after: function(data) {

		if (data.items.length != 0) {

			var template = Handlebars.templates['beer-recommend-list.tmpl'];

			/*var source   = $("#beer-recommend-list").html();
			var template = Handlebars.compile(source);*/
			var html = template(data);

			$("#recommend-bar-area").html(html);

			if (data.rec_type == "local") {
				$("#recommend-bar").html("Local Recommendations by Style");
			}
			else {
				$("#recommend-bar").html("Recommendations by Style");
			}
		}
		else {
			$("#recommend-bar-area").html('');
			$("#recommend-bar").hide();
		}

		refreshScroll.go();
	},
	notifications: function(location, info, b) {

		/*var source   = $("#notifications-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['notifications-template.tmpl'];
		var html = template(info);

		$("#"+location).html(html);

		if (b) {
			Toggle.tabs($("#note-end"), 'note-panel', 'news-areas', 'notifiication-tab');
		}
		else {
			Toggle.tabs($("#note-start"), 'note-panel', 'note-areas', 'notifiication-tab');
			
		}

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();
	},
	brewery_search_append: function(location, info) {

		var template = Handlebars.templates['brewerysearch-append-template.tmpl'];
		var html = template(info);

		$("#"+location).append(html);

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();

	},
	beer_search_append: function(location, info) {

		var template = Handlebars.templates['beersearch-append-template.tmpl'];
		var html = template(info.beers);


		$("#beerResults").append(html);

		var template = Handlebars.templates['beersearch-append-template.tmpl'];
		var html = template(info.homebrew);

		$("#homebrewResults").append(html);

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();
	},
	beer_search: function(location, info) {

		/*var source   = $("#beersearch-template").html();
		var template = Handlebars.compile(source);*/
		var template = Handlebars.templates['beersearch-template.tmpl'];
		var html = template(info);

		$("#beer-search").html(html);

		if ($(".beer-search").length >= 15 && $("#beer_search_loader").length == 0) {
			$("#beer-search-header").after('<div id="beer_search_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_search" href="javascript:void(0);" onclick="Feed.beer_search_more();" class="yellow_btn small">See More Beers</a>');
			
		}	

		/*var source   = $("#brewerysearch-template").html();
		var template = Handlebars.compile(source);*/
		var template = Handlebars.templates['brewerysearch-template.tmpl'];
		var html = template(info);



		$("#brewery-search").html(html);


		if ($(".brewery-search").length >= 15 && $("#brewery_search_loader").length == 0) {
			$("#brewery-search-header").after('<div id="brewery_search_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_brewery_search" href="javascript:void(0);" onclick="Feed.brewery_search_more();" class="yellow_btn small">See More Breweries</a>');
			
		}

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();
	},
	badge_single: function(location, info, c)  {

		if (c == "earned") {
			//var source   = $("#badge-single-template").html();
			var template = Handlebars.templates['badge-single-template.tmpl'];
		}
		else {
			//var source   = $("#badge-single-unearned-template").html();
			var template = Handlebars.templates['badge-single-unearned-template.tmpl'];
		}

		//var template = Handlebars.compile(source);
		var html = template(info);

		$("#"+location).html(html);

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();
	},
	user_badge: function(location, info) {

		/*var source   = $("#badge-list-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['badge-list-template.tmpl'];
		var html = template(info);

		$("#"+location).html(html);

		if (info.message && info.message == "private") {

			$("#notice-error").html('');

			var obj = {};
			obj["message"] = "It appears that this users's account is private.";
			obj["action_btn"] = "You cannot see their badge list without being their friend.";
			console.log(obj);

			/*var source   = $("#warning-template").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['warning-template.tmpl'];
			var html = template(obj);

			$("#notice-error").html(html);

			Util.openPop();

			Util.closePopTimeout(3000);

		}

		refreshScroll.go();

	},
	distinct_beer: function(location, info, c) {

		/*var source   = $("#distinct-beer-template").html();
		var template = Handlebars.compile(source);*/

		if (info.beers.sort_english && !info.is_search) {
			$("#sortBy").html("Sorted By: " + info.beers.sort_english);
			$(".grey_bar").show();
		}
		else {
			$("#sortBy").html('');
			$(".grey_bar").hide();
		}

		var template = Handlebars.templates['distinct-beer-template.tmpl'];
		var html = template(info.beers);

		if (c) {
			$("#distinctAreaContent").append(html);
		}
		else {

			$("#"+location).html(html);

			if (info.count != 0) {

				if ($("#distinct_loader").length == 0 && !info.is_search) {
					$("#distinctAreaContent").after('<div id="distinct_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_distinct" href="javascript:void(0);" onclick="Feed.distinct_beer(null, true);" class="yellow_btn small button">See More Beers</a>');
				}
				else {

					if (!info.is_search) {
						$("#see_more_distinct").show();
					}	
					else {
						$("#see_more_distinct").hide();
					}
					
				}				
			}
		}

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();
	},
	user_search: function(location, info) {

		/*var source   = $("#friends-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['friends-template.tmpl'];
		var html = template(info);

		$("#"+location).html(html);

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();
	},
	add_beer_search: function(location, info) {

		/*var source   = $("#addbeer-beer-template").html();
		var template = Handlebars.compile(source);*/
		var template = Handlebars.templates['addbeer-beer-template.tmpl'];

		var html = template(info);

		$("#"+location).html(html);

		refreshScroll.go();

	},
	add_brewery_search: function(location, info) {

		/*var source   = $("#addbeer-brewery-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['addbeer-brewery-template.tmpl'];
		var html = template(info);

		$("#"+location).html(html);

		refreshScroll.go();

	},
	toasts: function(location, info, a, b) {

		if (info.count == 0) {
			var obj = {};
			obj["h2_message"] = "No one has appeared to toast this chekin.";
			obj["h3_message"] = "Toast it!";

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/
			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);

			$("#"+location).html(html);
		}
		else {
			/*var source   = $("#beer-recommend-list").html();
			var template = Handlebars.compile(source);*/


			var template = Handlebars.templates['toasts-list-template.tmpl'];

			if (window.screen.height >= 568) {
				info["lazy"] = true;
		    }	
		    else {
		    	info["lazy"] = false;
		    }

			var html = template(info);

			if (b) {
				$("#"+location).append(html);
			}
			else {
				$("#"+location).html(html);
			}

			if ($("#more_toastlist").length == 0 && info.count >= 25) {
				$("#toastListAreaContent").after('<a rel="action-btn" id="more_toastlist" href="javascript:void(0);" onclick="Feed.toasts('+a+', true);" class="yellow_btn small button">See More Toasts</a><div id="more_toasts_loader" class="loading_inner" style="display: none; padding-top: 10px;"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
			}

		}

		refreshScroll.go();
	},
	recommend: function(location, info, a) {

		if (info.count == 0 && !a) {
			var obj = {};
			obj["h2_message"] = "We can't seem to find any recommendations.";
			obj["h3_message"] = "Please try again!";

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/
			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);

			$("#"+location).html(html);
		}
		else {
			/*var source   = $("#beer-recommend-list").html();
			var template = Handlebars.compile(source);*/


			var template = Handlebars.templates['beer-recommend-list.tmpl'];
			var html = template(info);

			if (a) {
				$("#"+location).append(html);
			}
			else {
				$("#"+location).html(html);
			}
			

			if ($("#more_suggestions").length == 0) {
				$("#suggestedArea").append('<a rel="action-btn" id="more_suggestions" href="javascript:void(0);" onclick="Feed.recommend(true);" class="yellow_btn small">See More Recommendations</a><div id="more_suggestions_loader" class="loading_inner" style="display: none; padding-top: 10px;"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
			}

		}

		refreshScroll.go();

	},
	user_wishlist: function(location, info, user, append, you) {

		var rel = $("#user_profile").attr("data-relationship");

		console.log(user +  " " + append + " " + you);

		if (info.count == 0 && append != "append") {

			var obj = {};

			if (you == "you") {
				obj["h2_message"] = "Empty wishlist.";
				obj["h3_message"] = "Add something you want to try later!";
			}
			else {
				obj["h2_message"] = "This user's wishlist is empty or is private.";
				obj["h3_message"] = "Perhaps you could recommend something to them to add!";
			}

			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);

			$("#"+location).html(html);
		}
		else {
			/*var source   = $("#beer-wishlist").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['beer-wishlist.tmpl'];

			var html = template(info);
			
			if (append == "append") {
				$("#"+location).append(html);
			}
			else {
				$("#"+location).html(html);
			}
			
			if (info.count >= 15) {

				if ($("#see_more_wish_list").length == 0) {
					
					if (you) {
						$("#wishListButtons").html('<a id="see_more_wish_list" rel="action-btn" href="javascript:void(0);" onclick="Feed.wishlist(\''+user+'\', \'append\', true);" class="yellow_btn small">See More Wish List</a><div id="see_more_wish_list_loader" class="loading_inner" style="display: none; padding-top: 10px;"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
					}
					else {
						$("#wishListButtons").html('<a id="see_more_wish_list" rel="action-btn" href="javascript:void(0);" onclick="Feed.wishlist(\''+user+'\', \'append\', false);" class="yellow_btn small">See More Wish List</a><div id="see_more_wish_list_loader" class="loading_inner" style="display: none; padding-top: 10px;"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
					}
					
					
				}
						
			}
			else {
				$("#wishListButtons").html('');
			}
		}

		refreshScroll.go();
	},
	user_friends: function(location, info, user, append) {
		if (info.count == 0 && append != "append") {

			var obj = {};

			obj["h2_message"] = "This user has no friends or is private.";
			obj["h3_message"] = "Maybe you should be the first!";

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);
			
			$("#userFriendListContentArea").html(html);
		}
		else {
			console.log(info.data.length);
			var template = Handlebars.templates['friends-template.tmpl'];
			var html = template(info);
			//var html="id="+info.id+"<br><br>name="+info.name+"<br><br>body="+info.body;
			if (append == "append") {
				$("#dashboardAreaContent_content").append(html);
			}
			else {
				$("#dashboardAreaContent_content").html(html);
			}
			
			if (info.data.length >= 20) {

						
					$("#dashboardAreaSeeMore").html('<a id="see_more_user_friends" rel="action-btn" href="javascript:void(0);" onclick="Feed.get_stories(\''+user+'\', \'append\');" class="yellow_btn small">See More Stories</a><div id="see_more_user_friends_loader" class="loading_inner" style="display: none; padding-top: 10px;"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
					
			}
			else {
				$("#userFriendsButtons").html('');
			}

		}

		refreshScroll.go();
	},
	//added by vissu
	get_stories: function(location, info, user, append) {
		if (info.count == 0 && append != "append") {

			var obj = {};

			obj["h2_message"] = "This user has no friends or is private.";
			obj["h3_message"] = "Maybe you should be the first!";

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);
			
			$("#userFriendListContentArea").html(html);
		}
		else {
			console.log(info.data.length);
			var owner = myStorage.view("currentUser");
			console.log(owner.id);
			var template = Handlebars.templates['dashboard-template.tmpl'];
			var html='<div id="story_add"><div class="comment_box tab-view" style="margin-bottom: 20px;">';
				html+='<form onsubmit="Feed.story_post(this); return false;"><input type="hidden" name="page" value="#!/dashboardArea"><input id="story_body" type="text" class="needsclick" name="body" placeholder="Share status"></form>';
				html+='</div><div id="story_inner_spinner" class="loading_inner hide"><img src="assets/images/spinner.gif" width="24" height="24"><br><br></div>';
				html+='</div>';
				
			html += template(info);
			//var html="id="+info.id+"<br><br>name="+info.name+"<br><br>body="+info.body;
			if (append == "append") {
				html = template(info);
				$("#dashboardAreaContent_content").append(html);
			}
			else {
				html += template(info);
				$("#dashboardAreaContent_content").html(html);
			}
			
			if (info.data.length >= 20) {

						
					$("#dashboardAreaSeeMore").html('<a id="see_more_user_friends" rel="action-btn" href="javascript:void(0);" onclick="Feed.get_stories(\''+user+'\', \'append\');" class="yellow_btn small">See More Stories</a><div id="see_more_user_friends_loader" class="loading_inner" style="display: none; padding-top: 10px;"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
					
			}
			else {
				$("#userFriendsButtons").html('');
			}

		}

		refreshScroll.go();
	},
	get_topics: function(location, info, user, append) {
		if (info.data.length == 0 && append != "append") {

			var obj = {};

			obj["h2_message"] = "This group has no topics or is private.";
			obj["h3_message"] = "";

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);
			
			$("#topicAreaContent_content").html(html);
		}
		else {
			console.log(info.data.length);
			var template = Handlebars.templates['topics-template.tmpl'];
			var html = template(info);
			var groups = myStorage.view("myGroups");
			var owner = myStorage.view("currentUser");
			var user_id=owner.id;
			if(user){
				
				if(groups.indexOf(parseInt(user))!=-1){
				var addButton='<a class="yellow_btn small" href="#!/addAction/topic/'+user+'">Add A Topic</a>';
				}else if(user==user_id){
					var addButton='<a class="yellow_btn small" href="#!/addAction/topic">Add A Topic</a>';
				}else{
					var addButton='';
				}
			}else{
				var addButton='<a class="yellow_btn small" href="#!/addAction/topic">Add A Topic</a>';
			}
			if (append == "append") {
				$("#topicAreaContent_content").append(html);
			}
			else {
				$("#topicAreaContent_content").html(addButton+html);
			}
			
			if (info.data.length >= 20) {

						
					$("#topicAreaSeeMore").html('<a id="see_more_user_friends" rel="action-btn" href="javascript:void(0);" onclick="Feed.get_topics(\''+user+'\', \'append\');" class="yellow_btn small">See More Topics</a><div id="see_more_user_friends_loader" class="loading_inner" style="display: none; padding-top: 10px;"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
					
			}
			else {
				$("#topicAreaSeeMore").html('');
			}

		}

		refreshScroll.go();
	},
	get_photos: function(location, info, user, append) {
		if (info.data.length == 0 && append != "append") {

			var obj = {};

			obj["h2_message"] = "This group has no photos or is private.";
			obj["h3_message"] = "";

			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);
			
			$("#photoAreaContent_content").html(html);
		}
		else {
			console.log(info.data.length);
			var template = Handlebars.templates['photos-template.tmpl'];
			var html = template(info);
			
			var groups = myStorage.view("myGroups");
			var owner = myStorage.view("currentUser");
			var user_id=owner.id;
			if(user){
				
				if(groups.indexOf(parseInt(user))!=-1){
				var addButton='<a class="yellow_btn small" href="#!/addAction/photo/'+user+'">Add A Photo</a>';
				}else if(user==user_id){
					var addButton='<a class="yellow_btn small" href="#!/addAction/photo">Add A Photo</a>';
				}else{
					var addButton='';
				}
			}else{
				var addButton='<a class="yellow_btn small" href="#!/addAction/photo">Add A Photo</a>';
			}
			//var html="id="+info.id+"<br><br>name="+info.name+"<br><br>body="+info.body;
			if (append == "append") {
				$("#photoAreaContent_content").append(html);
			}
			else {
				$("#photoAreaContent_content").html(addButton+html);
			}
			
			if (info.data.length >= 20) {

						
					$("#photoAreaSeeMore").html('<a id="see_more_user_friends" rel="action-btn" href="javascript:void(0);" onclick="Feed.get_photos(\''+user+'\', \'append\');" class="yellow_btn small">See More Photos</a><div id="see_more_user_friends_loader" class="loading_inner" style="display: none; padding-top: 10px;"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
					
			}
			else {
				$("#userFriendsButtons").html('');
			}

		}

		refreshScroll.go();
	},
	get_pages: function(location, info, user, append) {
		if (info.data.length == 0 && append != "append") {

			var obj = {};

			obj["h2_message"] = "This group has no pages or is private.";
			obj["h3_message"] = "";

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);
			
			$("#pageAreaContent_content").html(html);
		}
		else {
			console.log(info.data.length);
			var template = Handlebars.templates['pages-template.tmpl'];
			var html = template(info);
			
			var groups = myStorage.view("myGroups");
			var owner = myStorage.view("currentUser");
			var user_id=owner.id;
			if(user){
				
				if(groups.indexOf(parseInt(user))!=-1){
				var addButton='<a class="yellow_btn small" href="#!/addAction/page/'+user+'">Add A Page</a>';
				}else if(user==user_id){
					var addButton='<a class="yellow_btn small" href="#!/addAction/page">Add A Page</a>';
				}else{
					var addButton='';
				}
			}else{
				var addButton='<a class="yellow_btn small" href="#!/addAction/page">Add A Page</a>';
			}
			//var html="id="+info.id+"<br><br>name="+info.name+"<br><br>body="+info.body;
			if (append == "append") {
				$("#pageAreaContent_content").append(html);
			}
			else {
				$("#pageAreaContent_content").html(addButton+html);
			}
			
			if (info.data.length >= 20) {

						
					$("#pageAreaSeeMore").html('<a id="see_more_user_friends" rel="action-btn" href="javascript:void(0);" onclick="Feed.get_pages(\''+user+'\', \'append\');" class="yellow_btn small">See More Pages</a><div id="see_more_user_friends_loader" class="loading_inner" style="display: none; padding-top: 10px;"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
					
			}
			else {
				$("#userFriendsButtons").html('');
			}

		}

		refreshScroll.go();
	},
	single_story: function(location, info, component,id) {
		console.log(info);
		$("#storyArea").html('<div class="storyArea_content"></div><div class="storyArea_comments"><div class="blue_bar">Comments</div><div class="comment_list" id="'+id+'"></div></div><div class="storyArea_comment_box"></div>');
			var template = Handlebars.templates['single-story-template.tmpl'];
			var html = template(info);
			
			//html+='<div class="list_box">'+info.body+'</div>';
			if(html)
			$("#storyArea .storyArea_content").html(html);
			
				var html1 = '<form class="comment-form"><span accept-charset="UTF-8" class="counter" id="comment_counter">140</span><input type="hidden" value="#!/storyArea/'+component+'/'+id+'"><textarea onkeydown="Limiter.limit(\'comment_box\', \'comment_counter\', 140);" placeholder="Add a comment" id="comment_box" name="comment" class="needsclick"></textarea></form><a class="yellow_btn large comment_btn" onclick="Feed.story_comment(this); return false;" rel="action-btn" data-analytics="postComment_btn" href="#">POST COMMENT</a>';
		
				html1 += '<div id="comment_inner_spinner" class="loading_inner hide"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /></div>';

				
				//var html='<form class="comment-form"><span accept-charset="UTF-8" class="counter" id="comment_counter">140</span><textarea onkeydown="Limiter.limit(\'story-comment-box\', \'comment_counter\', 140);" placeholder="Add a comment" id="story-comment-box" name="comment" class="needsclick"></textarea></form><a class="yellow_btn large comment_btn" onclick="CommentThis.addThis(this, 42915434); return false;" rel="action-btn" data-analytics="postComment_btn" href="#">POST COMMENT</a>';
				
				$("#storyArea .storyArea_comment_box").append(html1);
			
			
		refreshScroll.go();
	},
	story_comments: function(location, info, component,id) {
		console.log(info);
			var template = Handlebars.templates['story-comments-template.tmpl'];
			var html = template(info);
			//var html='<div class="list_box">'+info.body+'</div>';
			if(html){
			/*$("#storyArea .storyArea_comments").append('<div class="blue_bar">Comments</div>');
			$("#storyArea .storyArea_comments").append('<div class="comment_list" id="'+id+'"></div>');*/
			$("#storyArea .storyArea_comments .comment_list").append(html);
			}
			
		refreshScroll.go();
	},
	add_item: function(location, info) {
		console.log(info);
			var template = Handlebars.templates['add-item-template.tmpl'];
			var html = template(info);
			
			if(html){
			$("#addAction").html(html);
			}
			
		refreshScroll.go();
	},
	actor_list: function(location, info,a) {
		console.log(info);
			var template = Handlebars.templates['actor-list-template.tmpl'];
			var html = template(info);
			if(html){
				
				if(a == "append"){
					$("#actorListContent_content .list").append(html);
				}else{
					$("#actorListContent_content").html('<div class="list">'+html+'</div');
				}
			}
			if (info.data.length >= 20) {
					$("#actorListSeeMore").html('<a id="see_more_actors" rel="action-btn" href="javascript:void(0);" onclick="Feed.actor_list(\'append\');" class="yellow_btn small">See More Groups</a><div id="see_more_user_groups_loader" class="loading_inner" style="display: none; padding-top: 10px;"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
			}else{
				$("#actorListSeeMore").html('');
			}
			//$("#actorListContent_content").html('<div class="list"><div class="list_box bottom_bar"><div class="details">hello</div></div></div>');
		refreshScroll.go();
	},
	actor_profile: function(location, info,component,id){
		console.log(info);
			var template = Handlebars.templates['actor-profile-template.tmpl'];
			var html = template(info);
			if(html){
				$('#actorArea_content').html(html);
			}
	},
	
	actor_profile_content: function(location, info,component,id){
		console.log(info);
			
			var template = Handlebars.templates['dashboard-template.tmpl'];
			var html = template(info);
			if(html){
				$('#actorArea_content .recent_activity').append(html);
			}
			if (info.data.length >= 20) {

					$("#actorProfileContentSeeMore").html('<a id="see_more_user_feed" rel="action-btn" href="javascript:void(0);" onclick="Feed.actor_profile_content(\''+component+'\',\''+id+'\', \'append\');" class="yellow_btn small">See More Stories</a><div id="see_more_feed_loader" class="loading_inner" style="display: none; padding-top: 10px;"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
					
			}
			else {
				$("#actorProfileContentSeeMore").html('');
			}
	},
	get_search:  function(location, info,component,append){
		console.log(info.scopes.length);

			if (info.data.length >= 20) {

					$("#searchAreaSeeMore").html('<a id="see_more_search_feed" rel="action-btn" href="javascript:void(0);" onclick="Feed.get_search(\'append\');" class="yellow_btn small">See More Stories</a><div id="see_more_search_loader" class="loading_inner" style="display: none; padding-top: 10px;"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
					
			}else{
					$("#searchAreaSeeMore").html('');
			}

			var i,scopes='<select class="dropdown" onchange="Feed.get_search()" id="scope" name="scope"><option value="">Select</option>';
			for(i=0;i<info.scopes.length;i++){
				if(info.scopes[i].count>0){
					scope = info.scopes[i].name;
					scope_name=scope.split(".");
					if(component==scope_name[0])
					scopes+='<option value="'+scope+'" selected>'+scope_name[0]+'</option>';
					else
					scopes+='<option value="'+scope+'">'+scope_name[0]+'</option>';
				}
			}
			scopes+='<select><br><br>';
			scopes+='<div id="search_loader" class="loading_inner" style="display: none; padding: 10px;"><img src="assets/images/spinner.gif" width="24" height="24" /></div>'
			$("#searchArea").addClass("active_page");
			
			if(component && component!="people" && component!="groups"){
				var template = Handlebars.templates[''+component+'-template.tmpl'];
			}else if(component=="people" || component=="groups"){
				var template = Handlebars.templates['actors-template.tmpl'];
			}
			
			var html = template(info);
			if(html){
				if(append){
					$('#searchAreaContent_content').append(html);
				}else{
					$('#searchAreaContent_content').html(html);
					$('#searchAreaContent_content').prepend(scopes);
				}
			}
	},
	venue_recent_location: function(location, info) {

		var template = Handlebars.templates['recent-location-template.tmpl'];

		var html = template(info);

		$("#"+location).html(html);
	},
	venue_location: function(location, info, a) {

		$("#foursquare-locations-search").show();

		/*var source   = $("#foursquare-location-template").html();
		var template = Handlebars.compile(source);*/

		if (a) {
			var template = Handlebars.templates['recent-location-template.tmpl'];

			var html = template(info);

			$("#"+location).html(html);
		}


		if (info.foursquare.response.code == 200) {

			if (info.foursquare.count == 0) {
				var obj = {};
				obj["h2_message"] = "No venues found with that name.";
				obj["h3_message"] = "Check your spelling and try again!";

				/*var source   = $("#empty-list-box").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['empty-list-box.tmpl'];
				var html = template(obj);

				$("#"+location).append(html);
			}
			else {

				var template = Handlebars.templates['foursquare-location-template.tmpl'];
				var html = template(info);

				$("#"+location).append(html);
			}
		}
		else {

			var obj = {};
			obj["h2_message"] = "Foursquare appears to be down.";
			obj["h3_message"] = info.foursquare.response.detail;

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);

			$("#"+location).append(html);
		}

		Loading.off();

		refreshScroll.go();

	},
	see_more_friends: function(f) {

		/*var source   = $("#friends-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['friends-template.tmpl'];
		var html = template(f);

		if (html == "") {
			$("#more_friends").hide();
		}

		$("#currentFriendsArea").append(html);

		refreshScroll.go();

	},
	just_friends: function(location, f) {

		if (f.count == 0) {
			var obj = {};
			obj["h2_message"] = "You have no friends.";
				obj["h3_message"] = "You should go search for some and start sharing!";

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);

			$("#currentFriendsArea").html(html);
		}
		else {
			/*var source   = $("#friends-template").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['friends-template.tmpl'];
			var html = template(f);
			$("#currentFriendsArea").html(html);

			if (parseInt(f.count) >= 15) {

				if ($("#more_friends").length == 0) {
					$("#currentFriends").append('<a id="more_friends" rel="action-btn" href="javascript:void(0);" onclick="Feed.friend_requests(true);" class="yellow_btn small button">See More Friends</a><div id="more_friends_list_loader" class="loading_inner" style="display: none; padding-top: 10px;"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
				}

				

			}
		}

		refreshScroll.go();
	},
	pending_friends: function(location,f,p,c) {

		/*var source   = $("#request-template").html();
		var template = Handlebars.compile(source);*/

		if (p.count == 0) {
			var obj = {};
			obj["h2_message"] = "You do not appear to have any pending friends requests!";
			obj["h3_message"] = "";

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);

			$("#pendingFriends").html(html);
		}
		else {

			var template = Handlebars.templates['request-template.tmpl'];
			var html = template(p);
			$("#pendingFriends").html(html);
		}


		/*
		if (f.count == 0) {
			var obj = {};
			obj["h2_message"] = "You have no friends.";
				obj["h3_message"] = "You should go search for some and start sharing!";


			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);

			$("#currentFriendsArea").html(html);
		}
		else {
	
			var template = Handlebars.templates['friends-template.tmpl'];
			var html = template(f);
			$("#currentFriendsArea").html(html);

			if (parseInt(f.count) >= 15) {

				if ($("#more_friends").length == 0) {
					$("#currentFriends").append('<a id="more_friends" rel="action-btn" href="javascript:void(0);" onclick="Feed.friend_requests(true);" class="yellow_btn small button">See More Friends</a><div id="more_friends_list_loader" class="loading_inner" style="display: none; padding-top: 10px;"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
				}

				

			}
		}*/


		if (c == "friends" || c == "pending") {

		}
		else {
			if (parseInt(p.count) >= 1) {
				Toggle.tabs($("#requested-tab"), 'friends-tab', 'pendingFriends', 'friendlist-tab');
			}
			else
			{
				Toggle.tabs($('#friends-list-tab'), 'friends-tab', 'currentFriends' , 'friendlist-tab');
			}			
		}


		refreshScroll.go();
	},
	checkin_interaction: function(location, data) {
		
		var template = Handlebars.templates['refresh-checkin-template.tmpl'];

		var html = template(data);

		$("#checkininteractions_"+data.checkin_id).html(html);

		if (data.comments.count == 0 && data.toasts.count == 0)
		{
			if (data.user.relationship != "friends" && data.user.relationship != "self")
			{
				$(".interactions_header").hide();
			}
		}
		else
		{
			$(".interactions_header").show();
		}

		if (data.session_time) {
			session_time = data.session_time;
		}
		else {
			session_time = "";	
		}

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();
	},
	resubmit: function(info) {
		var template = Handlebars.templates['resubmit-foursquare-template.tmpl'];

		var html = template(info);

		$("#foursquare_area").html(html);

		$("#foursquare_id").val(info.venue.foursquare.foursquare_id);

		$("#geolat").val(Geolocate.getCurrentLat());
		$("#geolng").val(Geolocate.getCurrentLng());

		$("#foursquare_social").show();

		refreshScroll.go();
	},
	checkin: function(location, info, source) {
		/*var source   = $("#checkin-template").html();
		var template = Handlebars.compile(source);*/
			
		var template = Handlebars.templates['checkin-template.tmpl'];

		var html = template(info);
		$("#"+location).html(html);

		$(".timeago").cuteTime({ refresh: 50000 });

		var checkin_id = $("#check_view").attr('data-checkin');
			
		$("#checkin-settings").show();

		if (info.session_time) {
			session_time = info.session_time;
		}
		else {
			session_time = "";	
		}

		refreshScroll.go(source);

	},
	pub: function(location, info, append) {


		var template = Handlebars.templates['activity-template.tmpl'];
		/*var source   = $("#activity-template").html();
		var template = Handlebars.compile(source);*/
		var html = template(info);

		$("#"+location).html(html);

		$(".timeago").cuteTime({ refresh: 50000 });

		if ($("#see_more_pub").length == 0 && info.checkins.count > 15) {

			var ht = '<a id="see_more_pub" href="javascript:void(0);"rel="action-btn" onclick="Feed.more_public;" class="yellow_btn small">See More Activity</a><div id="see_more_pub_loader" style="display: none; padding-top: 10px;" class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /></div>'

			$("topicAreaCotent div.activity_stream").after(ht);
		}

		refreshScroll.go();

	},
	photo_single: function(location, info) {

		/*var source   = $("#photo-single-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['photo-single-template.tmpl'];
		var html = template(info);

		$("#"+location).html(html);

		refreshScroll.go();
	},
	photo_gallery: function(location, info, a, b, c) {

		/*var source   = $("#photo-gallery-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['photo-gallery-template.tmpl'];
		var html = template(info.media);

		if (c) {
			$("ul.photo_gallery").append(html);
		}
		else {
			$("#"+location).html("<ul class='photo_gallery'>"+html+"</ul>");
		}

		if ($(".photo_items").length >= 12) {

			var lim = info.pagination.max_id;
			
			if ($("#see_more_photos").length == 0) {
				$("ul.photo_gallery").after('<a id="see_more_photos" href="javascript:void(0);"rel="action-btn" onclick="Feed.media(\''+a+'\', \''+b+'\', '+lim+');" class="yellow_btn small">See More Photos</a><div id="more_photo_loader" style="display: none; padding-top: 10px;" class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
			}
			else {
				$("#see_more_photos").attr("onclick", 'Feed.media(\''+a+'\', \''+b+'\', '+lim+');');
			}
		}
		else {
			$("#see_more_photos").hide();
		}

		refreshScroll.go();

	},
	friend: function(location, info, append) {
	
		if (info.length == 0 && !append) {

			if (info.response.user) {
				if (info.response.user.is_private == 1 && info.response.user.relationship == "none") {
					var obj = {};
					obj["h2_message"] = "This user's account is private.";
					obj["h3_message"] = "Request to be their freind!";
				}
				else {
					var obj = {};
					obj["h2_message"] = "You have no friends.";
					obj["h3_message"] = "You should go search for some and start sharing!";
				}
			}
			else {
				var obj = {};
				obj["h2_message"] = "There is no activity.";
				obj["h3_message"] = "Search for and add friends by tapping the Friends tab.";
			}

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['empty-list-box.tmpl']

			var html = template(obj);

			$("#"+location).html(html);

		}
		else {
			/*var source   = $("#activity-template").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['activity-template.tmpl'];
			var html = template(info);

			if (html == "") {
				$("#see_more_friends").hide();
			}

			if (append) {
				$("#dashboardAreaContent_content").append(html);
			}
			else {
				$("#"+location).html(html);
			}

			$(".timeago").cuteTime({ refresh: 50000 });

			if ($("#see_more_friends").length == 0 && info >= 12) {
				$("#dashboardAreaContent_content").after('<a id="see_more_friends" href="javascript:void(0);" onclick="Feed.more_friends(this);" rel="action-btn" class="yellow_btn small">See More Activity</a><div id="more_friends_loader" style="display: none; padding-top: 10px;" class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
			}
		}

		refreshScroll.go();
	},
	stats_beer_styles: function(location, data, a, append) {

		if (data.beers.count == 0 && append != "append") {
			var obj = {};
			obj["h2_message"] = "You did not have any beers with this style during this period.";
			obj["h3_message"] = "Go grab a beer and check-in to get started!";

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);

			$("#"+location).html(html);
		}
		else {

			var template = Handlebars.templates['stats-top-beers-template.tmpl'];
			var html = template(data.beers);

			if (append == "append") {
				$("#"+location).append(html);	
			}
			else {
				$("#"+location).html(html);
			}

			if ($("#see_more_new_styles").length == 0 && data.beers.count >= 10) {
				$("#"+location).after('<a id="see_more_new_styles" href="javascript:void(0);" onclick="Feed.stats_beer_styles('+a+', \'append\');" rel="action-btn" class="yellow_btn small">See More Beers</a><div id="see_more_new_styles_loader" style="display: none; padding-top: 10px;" class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
			}
		}

		$("#loading-overlay").removeClass("loading");
		refreshScroll.go();

	},
	stats_new_beers: function(location, data, append) {

		if (data.beers.count == 0 && append != "append") {
			var obj = {};
			obj["h2_message"] = "You did not have any new beer during this period.";
			obj["h3_message"] = "Go grab a beer and check-in to get started!";

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);

			$("#"+location).html(html);
		}
		else {

			var template = Handlebars.templates['stats-top-beers-template.tmpl'];
			var html = template(data.beers);

			if (append == "append") {
				$("#"+location).append(html);	
			}
			else {
				$("#"+location).html(html);
			}

			if ($("#see_more_new_beers").length == 0 && data.beers.count >= 10) {
				$("#"+location).after('<a id="see_more_new_beers" href="javascript:void(0);" onclick="Feed.stats_new_beers(\'append\');" rel="action-btn" class="yellow_btn small">See More Beers</a><div id="see_more_new_beers_loader" style="display: none; padding-top: 10px;" class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
			}
		}

		refreshScroll.go();
	},
	stats_new_venues: function(location, data, append) {

		if (data.venues.count == 0 && append != "append") {

			var obj = {};
			obj["h2_message"] = "You did not visit any new venues during this period.";
			obj["h3_message"] = "Head over to the Discover Tab and start finding new venues!";

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);

			$("#"+location).html(html);

		}
		else {

			var template = Handlebars.templates['stats-top-venues-template.tmpl'];
			var html = template(data.venues);

			if (append == "append") {
				$("#"+location).append(html);	
			}
			else {
				$("#"+location).html(html);
			}


			if ($("#see_more_new_venues").length == 0 && data.venues.count >= 10) {
				$("#"+location).after('<a id="see_more_new_beers" href="javascript:void(0);" onclick="Feed.stats_new_venues(\'append\');" rel="action-btn" class="yellow_btn small">See More Beers</a><div id="see_more_new_venues_loader" style="display: none; padding-top: 10px;" class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /></div>');
			}
		}

		refreshScroll.go();
		
	},
	stats: function(location, data) {

		var template = Handlebars.templates['stats-template.tmpl'];
		var html = template(data);

		$("#"+location).html(html);

		//$("#lineGraphArea").css("padding", "0px");

		Stats.build(data.stats);

		//Stats.build();
		
		var template = Handlebars.templates['stats-top-beers-template.tmpl'];
		var html = template(data.stats.top_beers.beers);

		$("#statsAreaTopBeersContent").html(html);

		var template = Handlebars.templates['stats-top-venues-template.tmpl'];
		var html = template(data.stats.top_venues.venues);

		$("#statsAreaTopVenuesContent").html(html);

		var template = Handlebars.templates['stats-top-breweries-template.tmpl'];
		var html = template(data);

		$("#statsAreaTopBreweriesContent").html(html);

		var template = Handlebars.templates['stats-top-styles-template.tmpl'];
		var html = template(data);

		$("#statsAreaTopStylesContent").html(html);

		refreshScroll.go();

	},
	profile_full: function(location, data) {

		var template = Handlebars.templates['profile-full-template.tmpl'];
		var html = template(data);

		$("#"+location).html(html);

		refreshScroll.go();

		if (data.user.checkins) {
				if (data.user.checkins.count == 0 ) {

				var obj = {};

				if (data.user.is_private == 1 && data.user.relationship == "none") {
					obj["h2_message"] = "This user's account is private.";
					obj["h3_message"] = "Request to be their friend today!";
					$(".profile_stats").hide();
				}
				else if (data.user.relationship == "self") {
					obj["h2_message"] = "You don't have any public activity.";
					obj["h3_message"] = "What's up with that?";
				}
				else {
					obj["h2_message"] = "This user doesn't have any public activity.";
					obj["h3_message"] = "What's up with that?";
				}

				/*var source   = $("#empty-list-box").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['empty-list-box.tmpl'];
				var html = template(obj);

				$("#listCheckinsAreaContentArea").html(html);
				$("#activity_stream_profile_content").html(html);

				refreshScroll.go();
			}
			else {
				/*var source   = $("#activity-template").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['activity-template.tmpl']
				var html = template(data.user);

				$("#listCheckinsAreaContentArea").html(html);
				$("#activity_stream_profile_content").html(html);

				var template = Handlebars.templates['activity-template.tmpl'];

				var html = template(data.user);

				$("#listCheckinsAreaContentArea").html(html);

				if (data.user.checkins.count >= 12) {
					$("#checkinButtons").html('<div id="activity_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_activity" href="javascript:void(0);" onclick="Feed.more_activity(\''+data.user.user_name+'\');" class="yellow_btn small">See More Activity</a>');
				}

				if (data.user.checkins.count >= 3) {
					more = true;
					len = 3;
				}
				else {
					more = false;
					len = data.user.checkins.count;
				}

				var template = Handlebars.templates['single-activity-template.tmpl'];

				var html = template(data.user);

				$("#activity_stream_profile_content").html(html);


				if (more) {
					$("#activity_stream_profile_content").after('<a href="#!/listCheckinsArea" class="yellow_btn small">See More Activity</a>');
				}

				refreshScroll.go();
			}
		}

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();

	},
	profile: function(location, data, f) {


		if (f) {
			var template = Handlebars.templates['profile-template.tmpl'];
			var html = template(data);

			$("#"+location).html(html);

			refreshScroll.go();
		}
		else {
			var template = Handlebars.templates['profile-final-template.tmpl'];
			var html = template(data);

			$("div.profile_start_loader").remove();

			$("#profileDetailsArea").html(html);

			refreshScroll.go();
		}
		
		if (data.user.is_supporter) {
			$(".supporter_flag").show();
		}
		else {
			$(".supporter_flag").hide();
		}

		if (data.user.checkins) {
			if (data.user.checkins.count == 0 ) {

				var obj = {};

				if (data.user.is_private == 1 && data.user.relationship == "none") {
					obj["h2_message"] = "This user's account is private.";
					obj["h3_message"] = "Request to be their friend today!";
					$(".profile_stats").hide();
				}
				else if (data.user.relationship == "self") {
					obj["h2_message"] = "You don't have any public activity.";
					obj["h3_message"] = "What's up with that?";
				}
				else {
					obj["h2_message"] = "This user doesn't have any public activity.";
					obj["h3_message"] = "What's up with that?";
				}

				/*var source   = $("#empty-list-box").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['empty-list-box.tmpl'];
				var html = template(obj);

				$("#listCheckinsAreaContentArea").html(html);
				$("#activity_stream_profile_content").html(html);

				refreshScroll.go();
			}
			else {
				/*var source   = $("#activity-template").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['activity-template.tmpl']
				var html = template(data.user);

				$("#listCheckinsAreaContentArea").html(html);
				$("#activity_stream_profile_content").html(html);

				var template = Handlebars.templates['activity-template.tmpl'];

				var html = template(data.user);

				$("#listCheckinsAreaContentArea").html(html);

				if (data.user.checkins.count >= 12) {
					$("#checkinButtons").html('<div id="activity_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_activity" href="javascript:void(0);" onclick="Feed.more_activity(\''+data.user.user_name+'\');" class="yellow_btn small">See More Activity</a>');
				}

				if (data.user.checkins.count >= 3) {
					more = true;
					len = 3;
				}
				else {
					more = false;
					len = data.user.checkins.count;
				}

				var template = Handlebars.templates['single-activity-template.tmpl'];

				var html = template(data.user);

				$("#activity_stream_profile_content").html(html);


				if (more) {
					$("#activity_stream_profile_content").after('<a href="#!/listCheckinsArea" class="yellow_btn small">See More Activity</a>');
				}

				refreshScroll.go();
			}
		}

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();
	},
	your_full_profile: function(location, data) {
		
		var template = Handlebars.templates['your-profile-full-template.tmpl']
		
		var html = template(data);

		$("#"+location).html(html);

		if (data.user.checkins) {

			if (data.user.checkins.count == 0) {
				var obj = {};
				obj["h2_message"] = "You have no activity.";
				obj["h3_message"] = "Go grab a beer and check-in to get started!";

				/*var source   = $("#empty-list-box").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['empty-list-box.tmpl'];
				var html = template(obj);

				$("#your_activity_stream_profile_content").html(html);
				$("#listCheckinsAreaContentArea").html(html);
			}
			else {
				/*var source   = $("#activity-template").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['activity-template.tmpl'];

				var html = template(data.user);

				$("#listCheckinsAreaContentArea").html(html);

				if (data.user.checkins.count >= 12) {
					$("#checkinButtons").html('<div id="activity_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_activity" href="javascript:void(0);" onclick="Feed.more_activity(\''+data.user.user_name+'\');" class="yellow_btn small">See More Activity</a>');
				}

				if (data.user.checkins.count >= 3) {
					more = true;
					len = 3;
				}
				else {
					more = false;
					len = data.user.checkins.count;
				}

				var template = Handlebars.templates['single-activity-template.tmpl'];

				var html = template(data.user);

				$("#your_activity_stream_profile_content").html(html);


				if (more) {
					$("#your_activity_stream_profile_content").after('<a href="#!/listCheckinsArea" class="yellow_btn small">See More Activity</a>');
				}
				
			}
		}

		$(".timeago").cuteTime({ refresh: 50000 });
			
		refreshScroll.go();
	},
	your_profile: function(location, data, f) {

		if (f) {
			var template = Handlebars.templates['your-profile-template.tmpl']
			var html = template(data);
			$("#"+location).html(html);

			refreshScroll.go();
		}
		else {
			var template = Handlebars.templates['your-profile-final-template.tmpl']
			var html = template(data);

			$("#yourArea div.your_profile_start_loader").remove();

			$("#"+location).html(html);
		}

		if (data.user.checkins) {
			if (data.user.checkins.count == 0) {
				var obj = {};
				obj["h2_message"] = "You have no activity.";
				obj["h3_message"] = "Go grab a beer and check-in to get started!";

				/*var source   = $("#empty-list-box").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['empty-list-box.tmpl'];
				var html = template(obj);

				$("#your_activity_stream_profile_content").html(html);
				$("#listCheckinsAreaContentArea").html(html);
			}
			else {
				/*var source   = $("#activity-template").html();
				var template = Handlebars.compile(source);*/

				try {			
					var template = Handlebars.templates['activity-template.tmpl'];

					var html = template(data.user);

					$("#listCheckinsAreaContentArea").html(html);

					if (data.user.checkins.count >= 12) {
						$("#checkinButtons").html('<div id="activity_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_activity" href="javascript:void(0);" onclick="Feed.more_activity(\''+data.user.user_name+'\');" class="yellow_btn small">See More Activity</a>');
					}

					if (data.user.checkins.count >= 3) {
						more = true;
						len = 3;
					}
					else {
						more = false;
						len = data.user.checkins.count;
					}

					var template = Handlebars.templates['single-activity-template.tmpl'];

					var html = template(data.user);

					$("#your_activity_stream_profile_content").html(html);


					if (more) {
						$("#your_activity_stream_profile_content").after('<a href="#!/listCheckinsArea" class="yellow_btn small">See More Activity</a>');
					}
				}
				catch (err) {
			    	Garbage.clean("currentUser");
			    	console.log("error with feed");
			    }
			}
		}

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();
	},
	venue_full: function(location, data) {

		var template = Handlebars.templates['venue-full-template.tmpl']
		var html = template(data);

		$("#"+location).html(html);


		if (data.venue.top_beers) {

			/*var source   = $("#beer-popular").html();
			var template = Handlebars.compile(source);*/
			var template = Handlebars.templates['beer-popular.tmpl'];
			var html = template(data.venue.top_beers);

			$("#top_beers_stream_profile").html(html);
		}

		if (data.venue.checkins) {
			if (data.venue.checkins.count == 0) {
				var obj = {};
				obj["h2_message"] = "This venue doesn't have any public activity.";
				obj["h3_message"] = "Maybe you should try to visit!";

				/*var source   = $("#empty-list-box").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['empty-list-box.tmpl'];
				var html = template(obj);

				$("#venue_stream_profile_content").html(html);
			}
			else {

				/*var source   = $("#activity-template").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['activity-template.tmpl'];
				var html = template(data.venue);

				$("#venue_stream_profile_content").html(html);

				if (data.venue.checkins.count >= 12) {
					
					if ($("#venue_activity_loader").length == 0) {
						$("#venue_stream_profile_content").after('<div id="venue_activity_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_venue_activity" href="javascript:void(0);" onclick="Feed.venue_activity('+data.venue.venue_id+');" class="yellow_btn small">See More Activity</a>');
					}
					else {
						$("#see_more_venue_activity").show();
					}
					
				}

			}
		}

		$(".timeago").cuteTime({ refresh: 50000 });
		refreshScroll.go();

	},
	venue: function(location, data, f) {

		if (f) {
			var template = Handlebars.templates['venue-template.tmpl']
			var html = template(data);

			$("#"+location).html(html);
		}
		else {
			var template = Handlebars.templates['venue-final-template.tmpl']
			var html = template(data);

			$("#venueArea div.venue_template_loader").remove();

			$("#"+location).html(html);
		}

		if (data.venue.top_beers) {

			/*var source   = $("#beer-popular").html();
			var template = Handlebars.compile(source);*/
			var template = Handlebars.templates['beer-popular.tmpl'];
			var html = template(data.venue.top_beers);

			$("#top_beers_stream_profile").html(html);
		}

		if (data.venue.checkins) {
			if (data.venue.checkins.count == 0) {
				var obj = {};
				obj["h2_message"] = "This venue doesn't have any public activity.";
				obj["h3_message"] = "Maybe you should try to visit!";

				/*var source   = $("#empty-list-box").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['empty-list-box.tmpl'];
				var html = template(obj);

				$("#venue_stream_profile_content").html(html);
			}
			else {

				/*var source   = $("#activity-template").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['activity-template.tmpl'];
				var html = template(data.venue);

				$("#venue_stream_profile_content").html(html);

				if (data.venue.checkins.count >= 12) {
					
					if ($("#venue_activity_loader").length == 0) {
						$("#venue_stream_profile_content").after('<div id="venue_activity_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_venue_activity" href="javascript:void(0);" onclick="Feed.venue_activity('+data.venue.venue_id+');" class="yellow_btn small">See More Activity</a>');
					}
					else {
						$("#see_more_venue_activity").show();
					}
					
				}

			}
		}

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();
	},
	find_beer: function(location, info) {

		if (info.count == 0) {

			var obj = {};
			obj["h2_message"] = "This beer cannot be found around you.";
			obj["h3_message"] = "Hopefully it will show up soon!";

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);

			$("#"+location).html(html);

		}
		else {
			var template = Handlebars.templates['findBeer-template.tmpl'];
			var html = template(info);

			$("#"+location).html(html);

			$(".timeago").cuteTime({ refresh: 50000 });

		}

		refreshScroll.go();
	},
	brewery_activity: function(info) {

		/*var source   = $("#activity-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['activity-template.tmpl'];
		var html = template(info);

		$("#brewery_stream_profile_content").append(html);

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();

	},
	profile_activity: function(location, info, append) {

		/*var source   = $("#activity-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['activity-template.tmpl'];
		var html = template(info);


		if (append == "append") {
			$("#"+location).append(html);
		}
		else {
			$("#"+location).html(html);
		}
		
		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();

	},
	your_activity: function(info) {

		/*var source   = $("#activity-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['activity-template.tmpl'];
		var html = template(info);

		$("#your_activity_stream_profile_content").append(html);

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();

	},
	beer_activity: function(info) {

		/*var source   = $("#activity-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['activity-template.tmpl'];
		var html = template(info);

		$("#beer_stream_profile_content").append(html);

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();

	},
	venue_activity: function(info) {

		/*var source   = $("#activity-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['activity-template.tmpl'];
		var html = template(info);

		$("#venue_stream_profile_content").append(html);

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();
	},
	brewery_full: function(location, info) {

		var template = Handlebars.templates['brewery-full-template.tmpl'];
		var html = template(info);

		$("#breweryArea div.brewery_template_loader").remove();

		$("#"+location).html(html);

		if (info.brewery.checkins) {
			var template = Handlebars.templates['activity-template.tmpl'];
			var html = template(info.brewery);

			$("#brewery_stream_profile_content").html(html);

			if (info.brewery.checkins.count >= 12) {
				
				if ($("#brewery_activity_loader").length == 0) {
					$("#brewery_stream_profile_content").after('<div id="brewery_activity_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_brewery_activity" href="javascript:void(0);" onclick="Feed.brewery_activity('+info.brewery.brewery_id+');" class="yellow_btn small">See More Activity</a>');
				}
				else {
					$("#see_more_brewery_activity").show();
				}
			}

		}

		if (info.brewery.beer_list) {
			/*var source   = $("#beer-popular").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['brewery-beer-list-template.tmpl'];
			var html = template(info.brewery.beer_list);

			$("#beerList").html(html);

			$("#beerList").after('<div id="brewery_beer_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_brewery_beer" href="javascript:void(0);" onclick="Feed.more_beer('+info.brewery.brewery_id+');" class="yellow_btn small">See More Beers</a>');
		}

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();

	},
	brewery: function(location, info, f) {

		/*var source   = $("#brewery-template").html();
		var template = Handlebars.compile(source);*/

		if (f) {
			var template = Handlebars.templates['brewery-template.tmpl'];
			var html = template(info);

			$("#"+location).html(html);
		}
		else {
			var template = Handlebars.templates['brewery-final-template.tmpl'];
			var html = template(info);

			$("#breweryArea div.brewery_template_loader").remove();

			$("#"+location).html(html);
		}

		if (info.brewery.checkins) {
			var template = Handlebars.templates['activity-template.tmpl'];
			var html = template(info.brewery);

			$("#brewery_stream_profile_content").html(html);

			if (info.brewery.checkins.count >= 12 && $("#brewery_activity_loader").length == 0) {
				$("#brewery_stream_profile_content").after('<div id="brewery_activity_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_brewery_activity" href="javascript:void(0);" onclick="Feed.brewery_activity('+info.brewery.brewery_id+');" class="yellow_btn small">See More Activity</a>');
			}

		}

		if (info.brewery.beer_list) {
			/*var source   = $("#beer-popular").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['brewery-beer-list-template.tmpl'];
			var html = template(info.brewery.beer_list);

			$("#beerList").html(html);

			$("#beerList").after('<div id="brewery_beer_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_brewery_beer" href="javascript:void(0);" onclick="Feed.more_beer('+info.brewery.brewery_id+');" class="yellow_btn small">See More Beers</a>');
		}

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();

	},
	brewery_list: function(info) {

		var template = Handlebars.templates['brewery-beer-list-template.tmpl'];
		var html = template(info);

		$("#beerList").append(html);

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();

	},
	beer_full: function(location, info, q) {

		var template = Handlebars.templates['beer-full-template.tmpl'];
		var html = template(info);

		$("#"+location).html(html);

		if (q) {
			$("#isRecommend").val("true");
		}
		else {
			$("#isRecommend").val("false");
		}

		if (info.beer.similar) {

			/*var source   = $("#beer-popular").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['beer-popular.tmpl'];
			var html = template(info.beer.similar);

			$("#similar_stream_profile").html(html);

		}

		if (info.beer.checkins) {

			if (info.beer.checkins.count == 0) {

				var obj = {};
				obj["h2_message"] = "This beer doesn't have any public activity.";
				obj["h3_message"] = "Maybe you should try this beer or add it your wishlist for later!";

				/*var source   = $("#empty-list-box").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['empty-list-box.tmpl'];
				var html = template(obj);

				$("#beer_stream_profile_content").html(html);

			}
			else {
				/*var source   = $("#activity-template").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['activity-template.tmpl'];
				var html = template(info.beer);

				$("#beer_stream_profile_content").html(html);

				if (info.beer.checkins.count >= 12) {
					
					if ($("#beer_activity_loader").length == 0) {
						$("#beer_stream_profile_content").after('<div id="beer_activity_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_beer_activity" href="javascript:void(0);" onclick="Feed.beer_activity('+info.beer.bid+');" class="yellow_btn small">See More Activity</a>');
					}
					else {
						$("#see_more_beer_activity").show();
					}
				}
			}
		}
		
		$(".timeago").cuteTime({ refresh: 50000 });
		refreshScroll.go();
	},
	beer: function(location, info, f, q) {

		if (f) {

			var template = Handlebars.templates['beer-template.tmpl'];
			var html = template(info);

			$("#"+location).html(html);

			if (q) {
				$("#isRecommend").val("true");
			}
			else {
				$("#isRecommend").val("false");
			}

		}
		else {
			var template = Handlebars.templates['beer-final-template.tmpl'];
			var html = template(info);

			$("#beerArea div.loading_inner").remove();

			$("#"+location).html(html);
		}


		if (info.beer.stats) {
			if (parseInt(info.beer.stats.user_count) >= 1) {
				$("#beer_template div.profile_top").prepend('<div class="drank"></div>');
			}

		}

		if (info.beer.rating_score) {

			if (parseInt(info.beer.rating_score) == 0) {
				$("#beerRatings").html("<span>Rating Unavailable</span>")
			}
			else {

				var raw_rating_score = info.beer.rating_score;

				var fixed = Math.round( info.beer.rating_score * 10 ) / 10;

				var rating_score = fixed.toFixed(1);
				var display_score = fixed.toFixed(2);
				var code = "";

				var num = parseFloat(rating_score);
				
				var a = Math.floor(num);

				var q = Math.round((Math.abs(parseFloat(num) - parseFloat(a))) * 100, 0);

				if (parseInt(q) >= 0 && parseInt(q) <= 24) {
					firstNumber = a;
					lastNumber = 0;
				}
				else if (parseInt(q) >= 25 && parseInt(q) <= 74) {
					firstNumber = a;
					lastNumber = 5;
				}
				else {
					firstNumber = a+1;
					lastNumber = 0;
				}

				var ratingCSS = firstNumber.toString()+""+lastNumber.toString();

				code += '<span class="rating small r'+ratingCSS+'" style="height: 17px;"></span>';

				//code += ' <span>('+display_score+' avg, '+info.beer.rating_count.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",") +' ratings)</span>';

				code += ' <span>('+display_score+' avg)</span>';
				
				$("#beerRatings").html(code);
			}
		}
		else {
			//$("#beerRatings").html("<span>Rating Unavailable</span>")
		}


		if (info.beer.similar) {

			/*var source   = $("#beer-popular").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['beer-popular.tmpl'];
			var html = template(info.beer.similar);

			$("#similar_stream_profile").html(html);

		}

		if (info.beer.checkins) {

			if (info.beer.checkins.count == 0) {

				var obj = {};
				obj["h2_message"] = "This beer doesn't have any public activity.";
				obj["h3_message"] = "Maybe you should try this beer or add it your wishlist for later!";

				/*var source   = $("#empty-list-box").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['empty-list-box.tmpl'];
				var html = template(obj);

				$("#beer_stream_profile_content").html(html);

			}
			else {
				/*var source   = $("#activity-template").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['activity-template.tmpl'];
				var html = template(info.beer);

				$("#beer_stream_profile_content").html(html);

				if (info.beer.checkins.count >= 12) {
					
					if ($("#beer_activity_loader").length == 0) {
						$("#beer_stream_profile_content").after('<div id="beer_activity_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="see_more_beer_activity" href="javascript:void(0);" onclick="Feed.beer_activity('+info.beer.bid+');" class="yellow_btn small">See More Activity</a>');
					}
					else {
						$("#see_more_beer_activity").show();
					}
				}
			}
		}
		else {
			var obj = {};
			obj["h2_message"] = "This beer doesn't have any public activity.";
			obj["h3_message"] = "Maybe you should try this beer or add it your wishlist for later!";

			/*var source   = $("#empty-list-box").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);

			$("#beer_stream_profile_content").html(html);
		}


		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();
	},
	your_checkins: function(location, data) {

		if (data.checkins.count == 0) {

			var obj = {};
			obj["h2_message"] = "You have never had this beer before!";
			obj["h3_message"] = "Maybe you should try this beer or add it your wishlist for later!";

			var template = Handlebars.templates['empty-list-box.tmpl'];
			var html = template(obj);

			$("#"+location).html(html);

		}
		else {
			var template = Handlebars.templates['activity-template.tmpl'];
			var html = template(data);

			$("#"+location).html(html);
		}

		$(".timeago").cuteTime({ refresh: 50000 });

		refreshScroll.go();
	},
	propose_edit: function(location, data) {

		var template = Handlebars.templates['beer-edit-template.tmpl'];
		var html = template(data);

		$("#"+location).html(html);

		Add.beer_types("beer_types_edit", data.beer.beer_style);

		refreshScroll.go();

	},
	propose_rate: function(location, data) {

		var template = Handlebars.templates['beer-rerate-template.tmpl'];
		var html = template(data);

		$("#"+location).html(html);

	    var values = new Array();

	    values[0] = 0;
	    values[1] = 0.5;
	    values[2] = 1;
	    values[3] = 1.5;
	    values[4] = 2;
	    values[5] = 2.5;
	    values[6] = 3;
	    values[7] = 3.5;
	    values[8] = 4;
	    values[9] = 4.5;
	    values[10] = 5;
	 
	   var options = {
	        "allowedValues": values,
	        "snap": true,
	    };

	    $("#ratingreSlider").simpleSlider(options);

	    $("#ratingreSlider").simpleSlider("setValue", data.beer.auth_rating);

	    if (parseFloat(data.beer.auth_rating) == 0) {
	    	$(".output").html("NO<span>RATING</span>");
	    }
	    else {
	    	$(".output").html(data.beer.auth_rating+ "<span>STARS</span>");
	    }

	    $("#ratingreSlider").val(data.beer.auth_rating);

	    $("#ratingreSlider").on("slider:ready slider:changed", function (event, data) {
	      	
	      	if (parseFloat(data.value.toFixed(1)) == 0) {
	      		$(".output").html("NO<span>RATING</span>").show();
	      	}
	      	else {
	      		$(".output").html(data.value.toFixed(1)+ "<span>STARS</span>").show();
	      	}
			
			$("#rerating_score").val(data.value.toFixed(1));
	    });

		refreshScroll.go();

	},
	confirm: function(location, data) {

		var template = Handlebars.templates['confirm-template.tmpl'];
		var code = template(data);

		$("#"+location).html(code);

		Social.automate();
		//activateStar(data.beer.auth_rating);

		$(".timeago").cuteTime({ refresh: 50000 });

	    var values = new Array();

	    values[0] = 0;
	    values[1] = 0.5;
	    values[2] = 1;
	    values[3] = 1.5;
	    values[4] = 2;
	    values[5] = 2.5;
	    values[6] = 3;
	    values[7] = 3.5;
	    values[8] = 4;
	    values[9] = 4.5;
	    values[10] = 5;
	 
	   var options = {
	        "allowedValues": values,
	        "snap": true,
	    };

	    $(".rate_beer").show();

	    $("#ratingSlider").simpleSlider(options);

	    $("#ratingSlider").simpleSlider("setValue", data.beer.auth_rating);

	    if (parseFloat(data.beer.auth_rating) == 0) {
	    	$(".output").html("NO<span>RATING</span>");
	    }
	    else {
	    	$(".output").html(data.beer.auth_rating+ "<span>STARS</span>");
	    }

	    $("#rating_score").val(data.beer.auth_rating);

	    $("#ratingSlider").on("slider:ready slider:changed", function (event, data) {
			if (parseFloat(data.value.toFixed(1)) == 0) {
				$(".output").html("NO<span>RATING</span>").show();
			}
			else {
				$(".output").html(data.value.toFixed(1)+ "<span>STARS</span>").show();
			}
			$("#rating_score").val(data.value.toFixed(1));
	    });

		refreshScroll.go();
	}
}
