var Toast = {
	clean_up: function(checkin_id, a, b) {

		var yourProfile = myStorage.view("yourProfile");

		var uid = yourProfile.user.uid;

		if ($(a).hasClass("active")) {
			$(a).removeClass("active");

			var v = $("#checkinid_"+checkin_id + " .comment_list").attr("data-toast-count");

			$("#checkinid_"+checkin_id + " .comment_list").attr("data-toast-count", (parseInt(v)-1));

			$("#checkintoast_"+checkin_id + " div.toasts a").each(function() {
				if ($(this).attr("data-user-toast-id") == uid) {
					$(this).remove();
				}
			});

			$("#checkintoast_"+checkin_id + " div.toasts span").each(function() {
				if ($(this).attr("data-user-toast-id") == uid) {
					$(this).remove();
				}
			});

			if ($("#checkinid_"+checkin_id + " .comment_list").attr("data-toast-count") == 0) {
				$("#checkintoast_"+checkin_id).html('');
			}
			else {
				
			}
			
			$("#checkinid_"+checkin_id+" a.toast").removeClass("active");
			console.log("removing active");
		}
		else {
			
			$(a).addClass("active");

			var yourName = yourProfile.user.first_name + " " + yourProfile.user.last_name;

			var v = $("#checkinid_"+checkin_id + " .comment_list").attr("data-toast-count");

			$("#checkinid_"+checkin_id + " .comment_list").attr("data-toast-count", (parseInt(v)+1));

			if ($("#checkinid_"+checkin_id + " .comment_list").attr("data-toast-count") != 1) {

				if ($("#checkinid_"+checkin_id + " .comment_list").attr("data-toast-count") == 2) {
					var html = " <span data-user-toast-id='"+yourProfile.user.uid+"'><a href='#!/yourArea'>"+yourName+"</a> and </span>";
				}
				else {
					var html = " <span data-user-toast-id='"+yourProfile.user.uid+"'><a data-user-toast-id='"+yourProfile.user.uid+"' href='#!/yourArea'>"+yourName+"</a>, </span>";
				}					

				$("#checkintoast_"+checkin_id + " div.toasts a:first").before(html);
			}
			else {
				var html = '<span class="toast"></span><div class="toasts"><a data-user-toast-id="'+yourProfile.user.uid+'" href="#!/yourArea">'+yourName+'</a> toasted this.</div>';
						
				$("#checkintoast_"+checkin_id).html(html);
			}

			$("#checkinid_"+checkin_id+" a.toast").addClass("active");
			console.log("adding active");
		}

		if ($("#checkintoast_"+checkin_id+ " div.toasts").hasClass("toastsAnimation")) {
			$("#checkintoast_"+checkin_id+ " div.toasts").removeClass("toastsAnimation");
			$("#checkintoast_"+checkin_id+ " span.toast").removeClass("toastsAnimation");
		}
		else {
			$("#checkintoast_"+checkin_id+ " div.toasts").addClass("toastsAnimation");
			$("#checkintoast_"+checkin_id+ " span.toast").addClass("toastsAnimation");
		}
	
	},
	feed: function(checkin_id, a) {

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			Toast.clean_up(checkin_id, a);

			$.ajax({
				url: host + "/checkin/toast/"+checkin_id+"?access_token="+token,
				type: "POST",
				dataType: "json",
			    error: function(html)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(html)
				{					
					if (html.meta.code == 200 ) {

						Garbage.clean("friendFeed");

						console.log(html.response.toasts);

						refreshScroll.go();						
					}
					else {

						if ($(a).hasClass("active")) {
							$(a).addClass('active');
						}
						else {
							$(a).removeClass('active');
						}

						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}

	},
	add: function(a, checkin_id, type) {
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			Toast.clean_up(checkin_id, a, true);

			$(".interactions_header").show(); 

			$.ajax({
				url: host + "/checkin/toast/"+checkin_id+"?access_token="+token,
				type: "POST",
				dataType: "json",
			    error: function(html)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(html)
				{					
					if (html.meta.code == 200 ) {
						
						if (html.response.like_type == "untoast") {
								
							ajaxStatement = $.ajax({
								url: host + "/checkin/view/"+checkin_id+"?access_token="+token,
								type: "GET",
								dataType: "json",
							     error: function(html)
								{
									// error goes here
								},
								success: function(data)
								{
									if (data.meta.code == 200)
									{
										Template.checkin_interaction("", data.response.checkin);
									}
									else
									{
										Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
									}
								}
							});
							
							//$("#checkinid_"+checkin_id+ " .toast").removeClass("active");

						}
						else {
							
							if (html.response.result == "success")
							{
							
								var template = Handlebars.templates['toast-checkin-template.tmpl'];

								var obj = {};

								obj["toasts"] = html.response.toasts;
								
								var contentHtml = template(obj);

								$("#check_view .toast_list").html(contentHtml);

								/*var template = Handlebars.templates['toast-feed-template.tmpl'];

								var obj = {};

								obj["toasts"] = html.response.toasts;
								
								var contentHtml = template(obj);

								$("#dashboardAreaContent_content #checkintoast_"+checkin_id).html(contentHtml);

								$("#checkinid_"+checkin_id+ " .toast").addClass("active");*/

								refreshScroll.go();		
							}
							else
							{
								if ($(a).hasClass("active"))
								{
									$(a).removeClass("active")
								}
								else
								{
									$(a).addClass("active");
								}
							}
							
						}	
					}
				
					refreshScroll.go();
				}
			});
		}
		
	}
}

