var handleSettings = {
	settings: function() {

		var token = Validate.token();

		if (!token)
		{
			toastPlugin.shortshow("You are not logged in!", function() {
				// toast correctly displayed
				}, function() {
				// an error occured
			});

			Page.change("#!/loginArea", "start");
		}
		else
		{
			Page.change("#!/profileSettingsArea", "push")
		}
	},
	logout: function() {
		var token = Validate.token();

		if (token)
		{	
			Garbage.erase();
			Page.change("#!/startArea", "start");
		}
		else {
			toastPlugin.shortshow("You are not logged in!", function() {
				// toast correctly displayed
				}, function() {
				// an error occured
			});
		}
	},
	exitApp: function() {
		Page.exit();
	}
}
var Replace = {
	/*urlWithLink: function(text) {
		var exp = /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig;
		console.log(exp);
      	if(Replace.checkURL("$1")==true){
      		return text.replace(exp,"<a href='$1' rel='link-out'>$1</a>"); 
		}else{
			return text.replace(exp,"$1"); 
		}
	},*/
	urlWithLink: function(text) {
		var exp = /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig;
		var links=text.match(exp);
		if(links!=null){
			var myStr = text;
			var myArr = myStr.split(" ");
		
			var i;
			for(i=0;i<links.length;i++){
				if(Replace.checkURL(links[i])!=true){
					if(myArr.indexOf(links[i])!=-1){
						myArr[myArr.indexOf(links[i])]="<a href='"+links[i]+"' rel='link-out'>"+links[i]+"</a>";
					}
				}
			}
			text=myArr.join(" ");
		}
		return text; 
	},
	checkURL: function(url) {
	    return(url.match(/\.(jpeg|jpg|gif|png)$/) != null);
	},
	capitalise: function(string) {
    return string.charAt(0).toUpperCase() + string.slice(1).toLowerCase();
	},
	textAreaAdjust:function(text){
		text.style.height = "1px";
    	text.style.height = (80+text.scrollHeight)+"px";
	}
}
var handleGPS = function(args) {
	if (args.indexOf(":") >= 0) {

		var s = args.split(":");
		currentLat = s[0];
		currentLng = s[1];
	}
	else {
		console.log(args);
	}
}

var Cheers = {
	toggle: function(a) {
		$(".stage").hide();

		if (a == 1) {

			if ($("#promo-results").length == 0) {
				Cheers.toggle(2);
			}
			else {
				$(".stage").hide();
				$("#promo-results").show();
				window.scroll(0,0);
			}
		}
		else {

			$(".stage").hide();
			$("#cheers-results").show();
			window.scroll(0,0);
		}

		refreshScroll.go();	
	}

	
}

var Pending = {
	friends: function() {

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			ajaxStatement = $.ajax({
				url: host + "/user/pending?access_token="+token,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						pending = data.response;

						if (pending.count == 0) {
							$("#request_number").html("");
							$("#request_number").addClass("hide");
						}
						else {
							$("#request_number").html("("+pending.count+")");
							$("#request_number").removeClass("hide");
						}

						if (pending.count >= 1) {
							$(".yourarea-header a.friends").prepend('<span class="pending">!</span>');
						}
						else {
							$("a.friends span.pending").remove();
						}

						//Template.pending_friends("friendlistAreaContent", d, pending);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	}

}

var Share = {
	withFriends: function(a) {

		console.log("ShARING WITH FRIENDS: " + a);
		if (a == "facebook") {

			  var dialogOptions = {
		        link: "https://neuros.org",
		        picture: 'https://neuros.s3.amazonaws.com/widgets/ut_icon_64x64.png',
		        name: 'Neuros',
		        caption: 'Join me on Neuros to discover new beers and places!',
		        description: "Neuros is a new mobile web app that allows you to socially share the brew you're currently enjoying, as well as where you're enjoying it, with your friends"
		    };

		    facebookConnect.dialog('feed', dialogOptions, function(response) {
		        console.log("FacebookConnect.dialog:" + JSON.stringify(response));
		    });
		}
		else if (a == "twitter") {
			console.log("twitter here");
			console.log(window.plugins.twitter);
			window.plugins.twitter.isTwitterAvailable(
				function(bool){
					console.log("Twitter is " + bool);
					if(bool){
						window.plugins.twitter.composeTweet(
							 function(){
							 	console.log('success');
							 },
							 function(){
								alert("We have a problem with the plugin");
							 },
							 "Join me on @neuros to discover new beers and places! https://neuros.org"
						);
						
					} else {
						alert("Twitter is not available");
					}
				},
				function(){
					alert("We have a problem with the plugin");
				}
			);
		}	

	},
	post: function(a, b) {
		
		if (a == "twitter") {

			if (phonegap) {
				progressHud.show("Posting to Twitter...");
			}
			
			var token = Validate.token();
			
			if (!token)
			{
				progressHud.hide();
				Error.token();
			}
			else
			{
				var args = $("#shareForm").serialize();

				if ($("#shareText").val().length > 140) {
					Error.show("Your message is over 140 characters. Please try again.");
				}	
				else {
					console.log("START");
					ajaxStatement = $.ajax({
						url: host + "/share/twitter?access_token="+token,
						type: "POST",
						data: args,
						dataType: "json",
						error: function(xhr,ajaxOptions, thrownError)
						{
							progressHud.hide();					
							Error.ajax_error(xhr, ajaxOptions, thrownError);
						},
						success: function(data)
						{
							Nav.goBack();

							if (phonegap) {
								progressHud.hide();
							}
							

							toastPlugin.shortshow("Posted Check-in to Twitter!", function() {
								// toast correctly displayed
								}, function() {
								// an error occured
							});
						}
					});
				}			
			}
		}
		else if (a == "facebook") {
			Util.closePop();

			progressHud.show("Posting to Facebook...");

			var token = Validate.token();
			
			if (!token)
			{
				progressHud.hide();
				Error.token();
			}
			else
			{
				console.log("FB TOKENS:");
				console.log(b);

				ajaxStatement = $.ajax({
					url: host + "/share/facebook?access_token="+token,
					type: "POST",
					data: b,
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						progressHud.hide();					
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{
						Nav.goBack();
						progressHud.hide();

						toastPlugin.shortshow("Posted Check-in to Facebook!", function() {
							// toast correctly displayed
							}, function() {
							// an error occured
						});

					}
				});			
			}	
		}
		else {
			console.log(a + " is invalid share");
		}
	},
	checkin: function(a,b) {

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			var bid = $("#check_view").attr('data-beer-id');

			var j = $("#beercheckin_"+bid).html();

			if (j != "") {

				var fix = JSON.parse(j);

				var shout = false;

				if (fix.checkin_comment) {
					shout = fix.checkin_comment;
				}

				var postURL = "https://neuros.org/c/"+b;

				if (a == "twitter") {

					progressHud.show("Please Wait....");

					if (fix.venue.venue_id) {
						var phrase = "Drinking " + Share.handleVowel(fix.beer.beer_name) + " by " + Share.handleTwitter("brewery", fix) + " " + Share.handleTwitter("venue", fix) + " on @neuros - " + postURL;
					}
					else {
						var phrase = "Drinking " + Share.handleVowel(fix.beer.beer_name) + " by " + Share.handleTwitter("brewery", fix) + " on @neuros - " + postURL;
					}
					
					var c =  parseInt(Math.random()*99999999);

					var h  = host + "/account/usersettings?access_token="+token+"&_"+c;

					$.ajax({
						url: h,
						type: "GET",
						data: "",
						dataType: "json",
					    error: function(html)
						{
							progressHud.hide();

							var link_out = "http://twitter.com/intent/tweet?text="+encodeURI(phrase);

							window.plugins.childBrowser.showWebPage(link_out);
						},
						success: function(html)
						{
							progressHud.hide();

							myStorage.save("socialSettings", html.response);

							Settings.init(html.response);

							if (html.response.user.contact.twitter) {
								$("#shareText").html(phrase);
								$("#checkin_id").val(b);
								Page.change("#!/shareCheckin", "push");

								setTimeout(function() {
									$("#shareText").focus();
									Limiter.limit('shareText', 'shareCounter', 140);
								}, 100);
							}
							else {
								var link_out = "http://twitter.com/intent/tweet?text="+encodeURI(phrase);

								window.plugins.childBrowser.showWebPage(link_out);
							}
						}
					});
				}
				else if (a == "facebook") {

					progressHud.show("Please Wait....");

					if (fix.venue.venue_id) {
						var phrase = "Drinking " + Share.handleVowel(fix.beer.beer_name) + " by " + fix.brewery.brewery_name + " " + fix.venue.venue_name + " on Neuros";
					}
					else {
						var phrase = "Drinking " + Share.handleVowel(fix.beer.beer_name) + " by " + fix.brewery.brewery_name + " on Neuros";
					}

					if (fix.venue.venue_id) {
						var args = {
							"venue_id": fix.venue.venue_id,
							"checkin_id": b,
							"shout": shout
						};
					}
					else {
						var args = {
							"checkin_id": b,
							"shout": shout
						};
					}

					console.log("WE HAVE ARGS");

					console.log(args);
					
					var c =  parseInt(Math.random()*99999999);

					var h  = host + "/account/usersettings?access_token="+token+"&_"+c;

					$.ajax({
						url: h,
						type: "GET",
						data: "",
						dataType: "json",
					    error: function(html)
						{
							progressHud.hide();

							var link_out = "http://www.facebook.com/sharer.php?u="+postURL+"&t="+encodeURI(phrase);

							window.plugins.childBrowser.showWebPage(link_out);
						},
						success: function(html)
						{
							progressHud.hide();

							myStorage.save("socialSettings", html.response);

							Settings.init(html.response);

							if (html.response.user.contact.facebook) {
									
								Util.closePop();

								progressHud.show("Posting to Facebook...");

								console.log("FB TOKENS:");
								console.log(args);

								ajaxStatement = $.ajax({
									url: host + "/share/facebook?access_token="+token,
									type: "POST",
									data: args,
									dataType: "json",
									error: function(xhr,ajaxOptions, thrownError)
									{
										progressHud.hide();					
										Error.ajax_error(xhr, ajaxOptions, thrownError);
									},
									success: function(data)
									{
										Nav.goBack();
										progressHud.hide();

										toastPlugin.shortshow("Posted Check-in to Facebook!", function() {
											// toast correctly displayed
											}, function() {
											// an error occured
										});

									}
								});	
							}
							else {
								var link_out = "http://www.facebook.com/sharer.php?u="+postURL+"&t="+encodeURI(pharse);

								window.plugins.childBrowser.showWebPage(link_out);
							}
						}
					});
				}

			}
			else {
				console.log("Invalid Share");
			}
		}
	},
	checkVowel: function(c) {
    	return ['a', 'e', 'i', 'o', 'u'].indexOf(c) !== -1
	},
	handleVowel: function(a) {

		if (Share.checkVowel(a.charAt(0))) {
			return "an " + a;
		}
		else {
			return "a " + a;
		}

	},
	handleTwitter: function(a,b) {
		if (a == "brewery") {
			if (b.brewery.contact.twitter && b.brewery.contact.twitter != "") {
				return "@"+b.brewery.contact.twitter;
			}
			else {
				return b.brewery.brewery_name;
			}
		}
		else if (a == "venue") {
			if (b.venue.contact.twitter && b.venue.contact.twitter != "") {
				return "at "+b.venue.contact.twitter;
			}
			else {
				return "@ " + b.venue.venue_name;
			}
		}
	}
}

var Beer = {
	rate: function(a) {
		clearAjax();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$("#rate-edit-btns").hide();
			$("#rate-loading").show();
			
			var d = $("#rate-beer-form").serialize();
			
			ajaxStatement = $.ajax({
				url: host + "/beer/rate/"+a+"?access_token="+token,
				type: "POST",
				data: d,
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#rate-edit-btns").show();
					$("#rate-loading").hide();
					
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					$("#rate-edit-btns").show();
					$("#rate-loading").hide();
					
					if (data.meta.code == 200)
					{
						if (data.response.result == "success") {
							
							var phrase = "";

							if (parseFloat(data.response.new_score) < parseFloat(data.response.old_score)) {
								phrase = "We hope your next beer is better!";
							}
							else {
								phrase = "We hoped you liked it!";
							}

							var s = data.response.new_score.toString();

							if (s.length == 1) {
								s += "0";
							}

							var ratingCSS = s.replace(".", "");


							$("#yourRatingBeer").attr("class", "");

							$("#yourRatingBeer").attr("class", "rating large r"+ratingCSS);

							Nav.goBack();
							
							var obj = {};
							obj["message"] = "Your rating has been updated!";
							obj["action_btn"] = phrase;

							/*var source   = $("#warning-template").html();
							var template = Handlebars.compile(source);*/

							var template = Handlebars.templates['notice-template.tmpl']
							var html = template(obj);

							$("#notice-error").html(html);

							Util.openPop();

							Util.closePopTimeout(3000);
						}
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	},
	go_to_rate: function(a) {
		
		clearAjax();
		
		Loading.on();
		
		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			$.ajax({
				url: host + "/beer/simple/"+a+"?access_token="+token,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Loading.off();
					Nav.goBack();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					Loading.off();
					
					if (data.meta.code == 200)
					{
						Template.propose_rate("proposeRateArea", data.response);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}
	},
}

var handleSound = function() {

	 var disNA = myStorage.view("notificationAlert");

	if (!disNA) {
		disNA = "1";
	}

	console.log("WE HERE ARE: " + disNA);

	switch (disNA) {
		 case '1':
		 	kt.audioPlay(function good() { console.log("played")}, function bad(args) { console.log(args); });
		 break;
		 case '2':
		 	kt.makeBuzz(function good() { console.log("buzzed")}, function bad(args) { console.log(args); });
		 break;
		 case '3':
		 	kt.audioPlay(function good() { console.log("played")}, function bad(args) { console.log(args); });
		 	kt.makeBuzz(function good() { console.log("buzzed")}, function bad(args) { console.log(args); });
		 break;
		 default: 

		 break;

	}
}

var StorePush = {
	launch: function(a) {

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			if (a.payload.push_id) {
				var args = "push_id="+a.payload.push_id;

				$.ajax({
					url: host + "/helpers/store_push?access_token="+token,
					type: "POST",
					data: args,
					dataType: "json",
					error: function(xhr,ajaxOptions, thrownError)
					{
						console.log(xhr.responseText);
					},
					success: function(data)
					{
						console.log("error");
					}
				});
			}
		}
	}
}

var catchUp = {
	go: function(only_close) {
		init.setUpGeo();
		init.setupUser();
		init.Social();
	}
}
var slideMenu = {
	slidemenu: function(only_close) {
		//$('#slidemenu').css('top', slideMenu.getPageScroll()[1] + 'px');
		$('#slidemenu').height(slideMenu.viewport().height);
		
		if ($('.slidemenu_btn').attr('data-slideopen') == "false" && !only_close) {
			
			var owner = myStorage.view("currentUser");
			if(owner.imageURL.medium){
			var bg_img=owner.imageURL.medium.url;
			}else{
				bg_img="assets/images/icon-profile.png";
			}
							//$('#slidemenu').show();
			$("#slide_overlay").anim({ display:'block'}, 1.0, 'swing');
			//$('#slidemenu h3').css('background-image', 'url(' + bg_img + ')');
			$('#slidemenu h3').html('<img src="'+bg_img+'" class="slide-img">'+owner.name);
			$('#slidemenu').anim({ opacity: 0.95,translateX: '200px',translateY: '48px'}, 1.0, 'swing');

			//$('#top').anim({ translateX: '160px'}, 0.1, 'ease-out');
			//$("#top").addClass("slide-anim");
			$("#container").addClass("slide-anim");
			$('.slidemenu_btn').attr('data-slideopen', "true");
			
	
		} else {
			
			$('#slidemenu').anim({ translateX: '-200px',translateY: '48px'}, 1.0, 'swing');
			$("#slide_overlay").hide();
			//$('#top').anim({ translateX: '0px'}, 0.1, 'ease-out');
			//$("#top").removeClass("slide-anim");
			$("#container").removeClass("slide-anim");
			$("#top").css('margin', '0px');
			$("body").css('left', '0px');
			$('.slidemenu_btn').attr('data-slideopen', "false");
			
		}
		return false;
	},
	getPageScroll: function() {
		var xScroll, yScroll;
	    if (self.pageYOffset) {
	      yScroll = self.pageYOffset;
	      xScroll = self.pageXOffset;
	    } else if (document.documentElement && document.documentElement.scrollTop) {
	      yScroll = document.documentElement.scrollTop;
	      xScroll = document.documentElement.scrollLeft;
	    } else if (document.body) {// all other Explorers
	      yScroll = document.body.scrollTop;
	      xScroll = document.body.scrollLeft;
	    }
    
    	return new Array(xScroll,yScroll)
	},
	viewport: function (){
		var e = window;
		var a = 'inner';
		if (!('innerWidth' in window)) {
			a = 'client';
			e = document.documentElement || document.body;
		}
		
		return { width : e[ a+'Width' ] , height : e[ a+'Height' ] }
	}
	
}
var PushReg = {
	checkPrimaryPush: function(pushID, a) {
		if (!localStorage.getItem('primaryPushChecked')) {

			var token = Validate.token();

			if (!token)
			{
				Error.token();
			}
			else
			{
				var args = "push_platform=GCM&push_id="+pushID;

				$.ajax({
					url: host + "/helpers/check_push?access_token="+token,
					type: "POST",
					data: args,
					dataType: "json",
				    error: function(xhr, ajaxOptions, thrownError)
					{	
						//$("#push_enabled").removeClass('loading');
						//Error.ajax_error(xhr, ajaxOptions, thrownError);
					},
					success: function(data)
					{
						if (data.response.count >= 1) {

							navigator.notification.confirm(
						        'Do you want to make this device your primary for Push Notifications for this account?',  // message
						        function(button) {
						        	PushReg.makePrimary(button, pushID, token, a)
						        },              // callback to invoke with index of button pressed
						        'Primary Device',            // title
						        'Yes,No'          // buttonLabels
						    );
						}	
						else {

							if (a) {
								console.log("done!");
								$("#li_push_toasts").addClass("active");
								$("#li_push_comments").addClass("active");

								if ($(".push_options").length != 0) {
									$(".push_options").show();
								}

								localStorage.setItem('pushReg', true);
								localStorage.setItem("GCMToken", pushID);
								
								$("#push_enabled").removeClass("loading").addClass("active");	
							}
							else {
								PushReg.finalizeDevice(pushID);	
							}
						}
					}
				});
			}
		}
		else {

			if (a) {
				console.log("done!");
	
				$("#li_push_toasts").addClass("active");
				$("#li_push_comments").addClass("active");

				if ($(".push_options").length != 0) {
					$(".push_options").show();
				}

				localStorage.setItem('pushReg', true);
				localStorage.setItem("GCMToken", pushID);
			}

			console.log("this device has already been checked");
		}
	},
	makePrimary: function(button, pushID, token, a) {

		if (button == 1) {
			var args = "push_platform=GCM&push_id="+pushID;

			console.log("ARGS => " + args);

			$.ajax({
				url: host + "/helpers/primary_push?access_token="+token,
				type: "POST",
				data: args,
				dataType: "json",
			    error: function(xhr, ajaxOptions, thrownError)
				{	
					//$("#push_enabled").removeClass('loading');
					//Error.ajax_error(xhr, ajaxOptions, thrownError);
					console.log("--- ERROR WITH PUSH REG ---");
					console.log(xhr.responseText);
				},
				success: function(data)
				{
					console.log("----- DONE -----");

					localStorage.setItem("primaryPushChecked", true);

					if (a) {
						console.log("done!");
						$("#li_push_toasts").addClass("active");
						$("#li_push_comments").addClass("active");

						if ($(".push_options").length != 0) {
							$(".push_options").show();
						}

						localStorage.setItem('pushReg', true);
						localStorage.setItem("GCMToken", pushID);
						
						$("#push_enabled").removeClass("loading").addClass("active");	
					}
					else {
						PushReg.finalizeDevice(pushID);	
					}
				}
			});
		}
		else {
			console.log("user didn't want to make this device their primary");
		}
	},
	registerDevice: function(pushID) {

		if (localStorage.getItem("GCMToken")) {

			if (localStorage.getItem("GCMToken") == pushID) {
				PushReg.checkPrimaryPush(pushID, true);
			}
			else {
				PushReg.checkPrimaryPush(pushID, false);
				//PushReg.finalizeDevice(pushID);
			}
		}
		else {
			PushReg.checkPrimaryPush(pushID, false);
			//PushReg.finalizeDevice(pushID);
		}
	},
	finalizeDevice: function(pushID) {

		console.log("PUSHID: " + pushID);

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var d = "Android " + $.os.version;

			var args = "push_token="+encodeURIComponent(pushID)+"&push_device="+encodeURIComponent(d)+"&device_udid="+udid+"&push_platform=GCM";

			console.log(args);

			$("#push_enabled").addClass('loading');

			$.ajax({
				url: host + "/helpers/register?access_token="+token,
				type: "POST",
				data: args,
				dataType: "json",
			    error: function(xhr, ajaxOptions, thrownError)
				{	
					$("#push_enabled").removeClass('loading');
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log("done!");
					$("#li_push_toasts").addClass("active");
					$("#li_push_comments").addClass("active");

					if ($(".push_options").length != 0) {
						$(".push_options").show();
					}

					localStorage.setItem('pushReg', true);
					localStorage.setItem("GCMToken", pushID);
					
					$("#push_enabled").removeClass("loading").addClass("active");	
				}
			});
		}

	},
	checkReg: function() {
		if (phonegap) {
			if (!localStorage.getItem("utnopush")) {
				var token = Validate.token();

				if (!token)
				{
					
				}
				else
				{
					pushNotification.register(pushFunctions.tokenHandler, pushFunctions.errorHandler,{"senderID":"760784898343","ecb":"onNotificationGCM"});
				}
			}
		}
		
	}
}

var Notifications = {
	gather: function() {

		var token = Validate.token();

		if (!token)
		{
			
		}
		else
		{	
		 	ajaxStatement = $.ajax({
				url: host + "/account/refreshnotifications?access_token="+token,
				type: "POST",
				dataType: "json",
			     error: function(html)
				{

				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						Notifications.set(data.notifications);	
					}
				}
			});
		}		
	},
	friends: function() {

		var token = Validate.token();

		if (!token)
		{
			
		}
		else
		{	

			ajaxStatement = $.ajax({
				url: host + "/user/pending?access_token="+token,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (data.meta.code == 200)
					{
						pending = data.response;

						if (pending.count == 0) {
							$("#pendingFriendsNotice span.pending").remove();
						}
						else {
							if ($("#pendingFriendsNotice span.pending").length == 0) {
								$("#pendingFriendsNotice").prepend('<span class="pending">!</span>');
							}
							
						}
					}
					else
					{
					
					}
				}
			});
		}
	},
	set: function(data) {

		$("#notifications-area li.toasts").html("<span>"+data.unread_count.toasts+"</span>");
		$("#notifications-area li.news").html("<span>"+data.unread_count.news+"</span>");
		$("#notifications-area li.comments").html("<span>"+data.unread_count.comments+"</span>");

		if (data.unread_count.comments != 0 || data.unread_count.news != 0 || data.unread_count.toasts != 0) {

			/*if ($("#pendingNotice span.pending").length == 0) {
				$("#pendingNotice").prepend('<span class="pending">!</span>');
			}*/

			var version = $.os.version;

			if (parseFloat(version) >= 4.0 && parseFloat(version) < 4.1) {
				$("#notify-popup").show();
			}
			else {
				$("#notify-popup").show();
				setTimeout('$("#notify-popup").hide();', 3000);
			}
		}
		else {
			$("#pendingNotice span.pending").remove();
		}
	}
}

var Checkin = {
	flag: function(checkin_id, type_id) {

		Util.closePop();

		var token = Validate.token();
		
		if (!token)
		{
			Error.token();
		}
		else
		{
			Loading.on();

			var args = "flag_type="+type_id;

			$.ajax({
				url: host + "/checkin/report/"+checkin_id+"?access_token="+token,
				type: "POST",
				data: args,
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					Loading.off();

					window.scroll(0,0);
					
					if (data.meta.code == 200)
					{
						var obj = {};
						obj["message"] = "This checkin has been flagged.";
						obj["action_btn"] = "Our moderator team will investigate this and take the action to get it cleaned up. Thanks for submitting!";
						obj["custom_text"] = "OK";

						/*var source   = $("#warning-template").html();
						var template = Handlebars.compile(source);*/

						var template = Handlebars.templates['warning-template.tmpl']
						var html = template(obj);

						$("#notice-error").html(html);

						Util.openPop();

						Util.closePopTimeout(3000);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		}

	},
	start: function(a) {

		$("#notice-error").html('');

		var obj = {};
		obj["message"] = "Are you sure you want remove this checkin?";
		obj["action_btn"] = "<a href='javascript:void(0);' onclick='Checkin.delete_checkin("+a+");' rel='action-btn' class='yellow_btn'>Confirm</a>";
		obj["badges"] = "yes";

		/*var source   = $("#warning-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['warning-template.tmpl'];
		var html = template(obj);

		$("#notice-error").html(html);

		Util.openPop();
	},
	delete_checkin: function(a) {

		Util.closePop();

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			if (phonegap) {
				progressHud.show("Deleting....");
			}
			
			Nav.goBack();
			$("."+a).hide();

		 	$.ajax({
				url: host + "/checkin/delete/"+a+"?access_token="+token,
				type: "POST",
				dataType: "json",
			     error: function(html)
				{
					if (phonepap) {
						progressHud.hide();
					}
					
					$("."+a).show();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					if (phonegap) {
						progressHud.hide();
					}
					

					if (data.meta.code == 200)
					{
						$("."+a).remove();
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});

		}
	}
}

var Sort = {
	go: function(current_tab, parent_tab, a, b) {

		$("."+parent_tab+ " li a").removeClass("active");
		$(current_tab).addClass('active');

		$($('.'+a).get().reverse()).each(function(outer) {

	 		var sorting = this;

			var parent_sort = $(sorting).attr(b);

	        $($('.'+a).get().reverse()).each(function(inner) {

				var sort_option = $(this).attr(b);

				if (b == "data-sort-style" || b == "data-sort-category")
				{
					if(sort_option.localeCompare(parent_sort) > 0) {
						 this.parentNode.insertBefore(sorting.parentNode.removeChild(sorting), this);
					}
				}
				else if (b == "data-sort-distance") {
					if(parseFloat(sort_option) > parseFloat(parent_sort)) {
						 this.parentNode.insertBefore(sorting.parentNode.removeChild(sorting), this);
					}
				}
				else
				{
					if(parseInt(sort_option) < parseInt(parent_sort)) {
						 this.parentNode.insertBefore(sorting.parentNode.removeChild(sorting), this);
					}
				}
	        });
	    });
	}

}

function clearAjax()
{
	if (ajaxStatement)
	{
		ajaxStatement.abort();
	}

}

function checkHash(newHash) {

	var newHash = newHash.replace("#", "");

	newHashArray = newHash.split("/");

	if (newHashArray.length != 0) {
		newHash = newHashArray[0];
	}

	if (newHash == "beerArea" || newHash == "distinctArea" || newHash == "indCheckin") {

		if (newHash == "indCheckin") {
			$(".menu-btn-option img").attr('src', "assets/images/refresh_btn_android.png");
		}
		else {
			$(".menu-btn-option img").attr('src', "assets/images/overflow_btn.png");
		}

		Menu.overflow_on();
	}
	else {
		Menu.overflow_off();
	}

	var token = Validate.token();

	if (token)
	{
		if (_disablePushOpen) {
			_disablePushOpen = false;
			if (_firstLoad) {
				_firstLoad = false;
			}
			else {
				catchUp.go();
			}
		}
	}

	console.log("Check hash: " + newHash);

	$(".header-buttons").removeClass("show");

	switch (newHash) {
		case "discoverArea":
			//window.scroll(0,0);
			break;
		case "discoverBeers":
			Sort.go($(".discover_beers_tab li a:first"), 'discover_beers_tab', 'discover_beers', 'data-sort-popular');
			$(".discover-beers-header").addClass("show");
			//window.scroll(0,0);
			break;
		case "discoverBars":
			$(".discover-bars-header").addClass("show");
			Sort.go($(".discover_bars_tab li a:first"), 'discover_bars_tab', 'discover_bars', 'data-sort-popular');
			//window.scroll(0,0);
			break;
		case "discoverFriends":
			$(".location_bar").show();
			$(".discover-friends-header").addClass("show");
			break;
		case "discoverBreweries":
			$(".location_bar").show();
			$(".discover-breweries-header").addClass("show");
			$("header").removeClass("hide");
			break;
		case "friendlistArea":
			$(".friends-list-header").addClass("show");
			//window.scroll(0,0);
			break;
		case "locationArea":
			$(".location-header").addClass("show");
			//window.scroll(0,0);
			break;
		case "findBeer":
			$(".location_bar").show();
			Geolocate.find_beer(page_fragments[1]);
			break;
		case "cheersArea":
			$(".cheers-header").addClass("show");
			//window.scroll(0,0);
			break;
		case "startArea":
			$("header").removeClass("show").addClass("hide");
			//window.scroll(0,0);
			break;
		case "loginArea":
			$("header").removeClass("show").addClass("hide");
			//window.scroll(0,0);
			break;
		case "resetPasswordArea":
			$("header").removeClass("show").addClass("hide");
			//window.scroll(0,0);
			break;
		case "search":
			$("header").removeClass("show").addClass("hide");
			$("#search").removeClass("hide").addClass("show");
			
			break;
		case "dashboardArea":
	      	$("header").removeClass("hide").addClass("show");
	     	 $("header div.activity-header").addClass("show");
	      break;
	    case "topicArea":
	      	$("header").removeClass("hide").addClass("show");
	     	 $(".activity-header").addClass("show");
	      break;
	    case "photoArea":
	      	$("header").removeClass("hide").addClass("show");
	      	$(".activity-header").addClass("show");
	      break;
	    case "pageArea":
	      	$("header").removeClass("hide").addClass("show");
	      	$(".activity-header").addClass("show");
	      break;
	    case "storyArea":
	      	$("header").removeClass("hide").addClass("show");
	      	$(".activity-header").addClass("show");
	      break;
		case "yourArea":
			$("header .yourarea-header").addClass("show");
			$(".userSettings").removeClass("hide");
			//window.scroll(0,0);
			break;
		case "indCheckin":
			$(".checkinind-header").addClass("show");
			//window.scroll(0,0);
			break;
		case "beerArea":
			$(".beer-header").addClass("show");
			break;
		case "breweryArea":
			$(".generic-back").addClass("show");
			break;
		case "profileArea":
			$(".generic-back").addClass("show");
			//window.scroll(0,0);
			break;
		case "notificationsArea":
			Toggle.tabs($("#note-start"), 'note-panel', 'note-areas', 'notifiication-tab');
			$(".notifications-header").addClass("show");
			//window.scroll(0,0);
			break;
		case "drinkArea":
			$("header").addClass("show");
			$(".beerSearchTermSearch").val('');
			Toggle.tabs($("#drink-up-first"), 'drink-up-tab', 'drinkAreaContent', 'search-tab-results');
			$(".drink-up-header").addClass("show");
			break;
		case "profileSettingsArea":
			Toggle.tabs($('#profile-first'), 'settings-tab', 'profile-settings', 'profile-settings-tab');
			$(".settings-top-header").addClass("show");
			break;
		case "registerArea":
			//$("header").removeClass("hide").addClass("show");
			//List.user_country();
			break;
		case "userBadgeArea":
			$(".generic-back").addClass("show");
			break;
		default:
			$("header").removeClass("hide").addClass("show");
			$(".generic-back").addClass("show");
			//window.scroll(0,0);
			break;
	}
	if ($("header").hasClass("hide") && newHash!='search') {
			$("body").addClass('neuros-bg');
		}else{
			$("body").removeClass('neuros-bg');
		}
	if ($("header").hasClass("hide")){
		$("#refresh-btn-top").hide();
	}else{
		$("#refresh-btn-top").show();
	}
}

var Track = {
	page: function() {
		//window.plugins.analytics.trackPageView(window.location.hash, function(){  }, function(){ console.log("TRACKING FAIL"); });
		gaPlugin.trackPage( function(){  }, function(){ console.log("TRACKING FAIL"); }, window.location.hash);
	},
	start_tracking: function(a) {
		//window.plugins.analytics.startTrack(a, function(){ }, function(){console.log("TRACKING OFF")});
		gaPlugin.init(function(){ }, function(){console.log("TRACKING OFF")}, a, 10);
	},
	eventType: function(cat, action, label, value) {
		//window.plugins.analytics.trackEvent(cat, action, label, value, function() {}, function() {console.log("Event Fail")})
		gaPlugin.trackEvent( function() {}, function() {console.log("Event Fail")}, cat, action, label, value);
	}
}

var Timezone = {
	get: function(){

		var myDate = new Date();

		var t = parseInt(myDate.format('Z'));

		var timezone = myDate.format('T');

		if (parseInt(t) < 0)
		{
			var new_t = Math.abs(t);
			var hours = parseInt(new_t) / 3600;
			var gmt_string = "-"+hours;
		}
		else
		{
			var hours = parseInt(t) / 3600;
			var gmt_string = hours;
		}

		var timezoneObj = {};

		timezoneObj["offset"] = gmt_string;
		timezoneObj["zone"] = timezone;

		return timezoneObj;

	}
}

var actionSheet = {
	create: function(items) {

		var template = Handlebars.templates['default-popup-template.tmpl'];
		var html = template(items);

		$("#notice-error").html(html);

		Util.openPop();
	}
}


var MenuToggle = {
	beer: function() {

		var youC = $("#beer_template div.profile_stats a.youCounter p").html();

		if (parseInt(youC) >= 1) {

			var blob = {
				message: "What would you like to do?",
				items: [
					{
						title: "Propose an Edit",
						button: false,
						href: "#!/proposeEditArea"
					},
					{
						title: "Flag Duplicate",
						button: true,
						onclick: "propose.flag();"
					},
					{
						title: "Change Rating",
						button: false,
						href: "#!/proposeRateArea"
					},
					{
						title: "Refresh",
						button: true,
						onclick: "Refresh.pull()"
					}
				]
			}

			actionSheet.create(blob);

		}
		else {

			var blob = {
				message: "What would you like to do?",
				items: [
					{
						title: "Propose an Edit",
						button: false,
						href: "#!/proposeEditArea"
					},
					{
						title: "Flag Duplicate",
						button: true,
						onclick: "propose.flag();"
					},
					{
						title: "Refresh",
						button: true,
						onclick: "Refresh.pull();"
					}
				]
			}

			actionSheet.create(blob);

		}

		
	},
	stats: function() {

		var blob = {
			message: "Please select the range of the stats:",
			items: [
				{
					title: "Last 7 Days",
					button: false,
					href: "#!/statsArea/7"
				},
				{
					title: "Last 30 Days",
					button: false,
					href: "#!/statsArea/30"
				},
				{
					title: "Last 60 Days",
					button: false,
					href: "#!/statsArea/60"
				},
				{
					title: "Last 90 Days",
					button: false,
					href: "#!/statsArea/90"
				}
			]
		}

		actionSheet.create(blob);
	},
	profile_picture_callback: function(buttonIndex) {

		Util.closePop();

		var pictureSource = navigator.camera.PictureSourceType;
        var destinationType = navigator.camera.DestinationType;
		var encoding = navigator.camera.EncodingType;
        
		if (buttonIndex == 0) {
			
			console.log('entry 0');
			$(".change_avatar").addClass("loading");
			navigator.camera.getPicture(Photo.getSuccessProfile, Photo.getFail, {quality: 45, destinationType: destinationType.FILE_URI, sourceType: pictureSource.PHOTOLIBRARY, correctOrientation: true, encodingType: encoding.JPEG, targetWidth: 910, targetHeight: 910, allowEdit: true});
		}
		else if (buttonIndex == 1) {
			$(".change_avatar").addClass("loading");
			navigator.camera.getPicture(Photo.getSuccessProfile, Photo.getFail, {quality: 45, destinationType: destinationType.FILE_URI, sourceType: pictureSource.CAMERA, correctOrientation: true, encodingType: encoding.JPEG, saveToPhotoAlbum: true, targetWidth: 910, targetHeight: 910, allowEdit: true});

		}
	 	else {

		}

	},
	profile_picture: function() {
		var owner = myStorage.view("currentUser");
		console.log('entry get_picture'+owner.id);
		if ($(".change_avatar").hasClass("loading")) {

		}
		else {
			var blob = {
			message: "Where would you like to take the picture from?",
			items: [
					{
						title: "Photo Library",
						button: true,
						onclick: "MenuToggle.profile_picture_callback(0);"
					},
					{
						title: "Camera",
						button: true,
						onclick: "MenuToggle.profile_picture_callback(1);"
					},
				]
			}

			actionSheet.create(blob);
		}
	},
	get_picture_callback: function(buttonIndex) {

		Util.closePop();

		var pictureSource = navigator.camera.PictureSourceType;
        var destinationType = navigator.camera.DestinationType;
		var encoding = navigator.camera.EncodingType;
        
		if (buttonIndex == 0) {
			$(".change_avatar").addClass("loading");
			navigator.camera.getPicture(Photo.getSuccessPhoto, Photo.getFail, {quality: 45, destinationType: destinationType.FILE_URI, sourceType: pictureSource.PHOTOLIBRARY, correctOrientation: true, encodingType: encoding.JPEG, targetWidth: 910, targetHeight: 910, allowEdit: true});
		}
		else if (buttonIndex == 1) {
			$(".change_avatar").addClass("loading");
			navigator.camera.getPicture(Photo.getSuccessPhoto, Photo.getFail, {quality: 45, destinationType: destinationType.FILE_URI, sourceType: pictureSource.CAMERA, correctOrientation: true, encodingType: encoding.JPEG, saveToPhotoAlbum: true, targetWidth: 910, targetHeight: 910, allowEdit: true});

		}
	 	else {

		}

	},
	get_picture: function() {
		if ($(".change_avatar").hasClass("loading")) {

		}
		else {
			var blob = {
			message: "Where would you like to take the picture from?",
			items: [
					{
						title: "Photo Library",
						button: true,
						onclick: "MenuToggle.get_picture_callback(0);"
					},
					{
						title: "Camera",
						button: true,
						onclick: "MenuToggle.get_picture_callback(1);"
					},
				]
			}

			actionSheet.create(blob);
		}
	},
	photo: function() {
		if (session_time == "") {
			Error.show("Something went wrong. Please try to refresh the content and try again.");
		}
		else {
			Photo.toggleAfter();	
		}		
	},
	share: function() {

		var checkin_id = $("#check_view").attr('data-checkin');

		if ($("#deleteCheckin_"+checkin_id).length != 0) {

			var blob = {
				message: "Where would you like to share?",
				items: [
					{
						title: "Facebook",
						button: true,
						onclick: "Share.checkin('facebook', "+checkin_id+");"
					},
					{
						title: "Twitter",
						button: true,
						onclick: "Share.checkin('twitter', "+checkin_id+");"
					},
				]
			}

			actionSheet.create(blob);
		}
	},
	checkin: function() {

		var checkin_id = $("#check_view").attr('data-checkin');

		if ($("#deleteCheckin_"+checkin_id).length != 0) {

			$("#checkin-settings").show();

			if ($("#check_view div.photo_current").length != 0) {

				var photo_id = $("#check_view div.photo_current").attr("data-photo");

				var blob = {
					message: "What would you like to do?",
					items: [
						{
							title: "Share on Facebook",
							button: true,
							onclick: "Share.checkin('facebook', "+checkin_id+");"
						},
						{
							title: "Share on Twitter",
							button: true,
							onclick: "Share.checkin('twitter', "+checkin_id+");"
						},
						{
							title: "Refresh",
							button: true,
							onclick: "Refresh.pull();"
						},
						{
							title: "Delete this Checkin",
							button: true,
							btnClass: "red_btn",
							onclick: "Checkin.start("+checkin_id+");"
						},
						{
							title: "Delete this Photo",
							button: true,
							btnClass: "red_btn",
							onclick: "Photo.start_delete_photo("+photo_id+");"
						}
						
					]
				}

				actionSheet.create(blob);
			}
 			else {

 				var blob = {
					message: "What would you like to do?",
					items: [
						{
							title: "Share on Facebook",
							button: true,
							onclick: "Share.checkin('facebook', "+checkin_id+");"
						},
						{
							title: "Share on Twitter",
							button: true,
							onclick: "Share.checkin('twitter', "+checkin_id+");"
						},
						{
							title: "Refresh",
							button: true,
							onclick: "Refresh.pull();"
						},
						{
							title: "Delete this Checkin",
							button: true,
							btnClass: "red_btn",
							onclick: "Checkin.start("+checkin_id+");"
						}
						
					]
				}

				actionSheet.create(blob);
 			}
		}
		else {
			MenuToggle.photo_flag();
		}
	},
	photo_flag: function() {

		var photo_id = $("#check_view div.photo_current").length;

		var checkin_id = $("#check_view").attr("data-checkin");

		if (photo_id != 0) {
			var blob = {
				message: "What's wrong with this checkin?",
				items: [
					{
						title: "Offensive Material",
						button: true,
						onclick: "Checkin.flag("+checkin_id+", 'vulgar');"
					},
					{
						title: "Offensive Photo",
						button: true,
						onclick: "Checkin.flag("+checkin_id+", 'vulgar-photo');"
					},
					{
						title: "Blatant Spam",
						button: true,
						onclick: "Checkin.flag("+checkin_id+", 'spam');"
					}
				]
			}
		}
		else {
			var blob = {
				message: "What's wrong with this checkin?",
				items: [
					{
						title: "Offensive Material",
						button: true,
						onclick: "Checkin.flag("+checkin_id+", 'vulgar');"
					},
					{
						title: "Blatant Spam",
						button: true,
						onclick: "Checkin.flag("+checkin_id+", 'vulgar');"
					}

				]
			}
		}

		

		actionSheet.create(blob);

	},
	bars_callback: function(buttonIndex) {

		Util.closePop();

		if (buttonIndex == 0) {

			Loading.on();

			myStorage.save("distanceBars", 1);

			Discover.bars_geolocate();
		}
		else if (buttonIndex == 1) {

			Loading.on();

			myStorage.save("distanceBars", 5);

			Discover.bars_geolocate();
		}
		else if (buttonIndex == 2) {

			Loading.on();
			
			myStorage.save("distanceBars", 15);

			Discover.bars_geolocate();

		}
	 	else if (buttonIndex == 3) {

	 		Loading.on();

	 		myStorage.save("distanceBars", 30);

			Discover.bars_geolocate();

		}
		else if (buttonIndex == 4) {

	 		Loading.on();

	 		myStorage.save("distanceBars", 50);

			Discover.bars_geolocate();
		}

	},
	bars: function() {

		var blob = {
			message: "Select a Radius to search for Bars",
			items: [
				{
					title: "1 Mile",
					button: true,
					onclick: "MenuToggle.bars_callback(0);"
				},
				{
					title: "5 Miles",
					button: true,
					onclick: "MenuToggle.bars_callback(1);"
				},
				{
					title: "10 Miles",
					button: true,
					onclick: "MenuToggle.bars_callback(2);"
				},
				{
					title: "15 Miles",
					button: true,
					onclick: "MenuToggle.bars_callback(3);"
				},
				{
					title: "30 Miles",
					button: true,
					onclick: "MenuToggle.bars_callback(4);"
				},
				{
					title: "50 Miles",
					button: true,
					onclick: "MenuToggle.bars_callback(5);"
				},
				{
					title: "Refresh",
					button: true,
					onclick: "Refresh.pull();"
				}
			]
		}

		actionSheet.create(blob);

	},
	breweries_callback: function() {

		Util.closePop();

		if (buttonIndex == 0) {

			myStorage.save("distanceBreweries", 5);

			Discover.breweries_geolocate();
		}
		else if (buttonIndex == 1) {
			
			myStorage.save("distanceBreweries", 15);

			Discover.breweries_geolocate();

		}
	 	else if (buttonIndex == 2) {

	 		myStorage.save("distanceBreweries", 30);

			Discover.breweries_geolocate();

		}
		else if (buttonIndex == 3) {

			myStorage.save("distanceBreweries", 50);

			Discover.breweries_geolocate();

		}


	},
	breweries: function() {

		var blob = {
			message: "Select a Radius to search for Breweries",
			items: [
				{
					title: "5 Miles",
					button: true,
					onclick: "MenuToggle.breweries_callback(0);"
				},
				{
					title: "10 Miles",
					button: true,
					onclick: "MenuToggle.breweries_callback(1);"
				},
				{
					title: "15 Miles",
					button: true,
					onclick: "MenuToggle.breweries_callback(2);"
				},
				{
					title: "30 Miles",
					button: true,
					onclick: "MenuToggle.breweries_callback(3);"
				},
				{
					title: "50 Miles",
					button: true,
					onclick: "MenuToggle.breweries_callback(4);"
				},
				{
					title: "Refresh",
					button: true,
					onclick: "Refresh.pull();"
				}
			]
		}

		actionSheet.create(blob);


	},
	beers_callback: function() {

		Util.closePop();

		if (buttonIndex == 0) {

			Loading.on();

			myStorage.save("distanceBeers", 1);

			Discover.beers_geolocate();
		}
		else if (buttonIndex == 1) {

			Loading.on();

			myStorage.save("distanceBeers", 5);

			Discover.beers_geolocate();
		}
		else if (buttonIndex == 2) {

			Loading.on();
			
			myStorage.save("distanceBeers", 15);

			Discover.beers_geolocate();

		}
	 	else if (buttonIndex == 3) {

	 		Loading.on();

	 		myStorage.save("distanceBeers", 30);

			Discover.beers_geolocate();

		}
		else if (buttonIndex == 4) {

			Loading.on();

	 		myStorage.save("distanceBeers", 50);

			Discover.beers_geolocate();

		}

	},
	beers: function() {

		var blob = {
			message: "Select a Radius to search for Beers",
			items: [
				{
					title: "1 Mile",
					button: true,
					onclick: "MenuToggle.beers_callback(0);"
				},
				{
					title: "5 Miles",
					button: true,
					onclick: "MenuToggle.beers_callback(1);"
				},
				{
					title: "10 Miles",
					button: true,
					onclick: "MenuToggle.beers_callback(2);"
				},
				{
					title: "15 Miles",
					button: true,
					onclick: "MenuToggle.beers_callback(3);"
				},
				{
					title: "30 Miles",
					button: true,
					onclick: "MenuToggle.beers_callback(4);"
				},
				{
					title: "50 Miles",
					button: true,
					onclick: "MenuToggle.beers_callback(5);"
				},
				{
					title: "Refresh",
					button: true,
					onclick: "Refresh.pull();"
				}
			]
		}

		actionSheet.create(blob);
	},
	distinct_callback: function(buttonIndex) {

		Util.closePop();

		var a = $("#badgeUserName").val();

		if (buttonIndex == 0) {
			$("#currentFilter").val("date");
			Feed.distinct_beer(a, false, "date", false);
			
		}
		else if (buttonIndex == 1) {
			$("#currentFilter").val("beer_name");
			Feed.distinct_beer(a, false, "beer_name", false);
			
		}
		else if (buttonIndex == 2) {
			$("#currentFilter").val("checkin");
			Feed.distinct_beer(a, false, "checkin", false);
			
		}
		else if (buttonIndex == 3) {
			$("#currentFilter").val("highest_rated_you");
			Feed.distinct_beer(a, false, "highest_rated_you", false);
			
		}
		else if (buttonIndex == 4) {
			$("#currentFilter").val("lowest_rated_you");
			Feed.distinct_beer(a, false, "lowest_rated_you", false);
		}

	},
	distinct: function() {

		var blob = {
			message: "Please select sort type:",
			items: [
				{
					title: "Date (Descending)",
					button: true,
					onclick: "MenuToggle.distinct_callback(0);"
				},
				{
					title: "Beer Name",
					button: true,
					onclick: "MenuToggle.distinct_callback(1);"
				},
				{
					title: "Checkin",
					button: true,
					onclick: "MenuToggle.distinct_callback(2);"
				},
				{
					title: "Highest Rated",
					button: true,
					onclick: "MenuToggle.distinct_callback(3);"
				},
				{
					title: "Lowest Rated",
					button: true,
					onclick: "MenuToggle.distinct_callback(4);"
				},
				{
					title: "Refresh",
					button: true,
					onclick: "Refresh.pull();"
				}
			]
		}

		actionSheet.create(blob);
	}
}

var Garbage = {
	clean: function(index) {
		localStorage.setItem(index, "");
	},
	erase: function() {
		
		/*added by vissu*/
		
		var owner = myStorage.view("currentUser");
		var id=owner.id;
		var key=myStorage.view('reg_id');
		$.post("http:///neuros.org/neuros_mobile/update.php", {user_id:id,key:key,logged:0});
		
		Menu.off();
		$(".tab_btn").removeClass("active");
		Register.clear_form_login();
		Register.clean_form();
		localStorage.clear();
		$.post(host+"/index.php?option=com_people&view=session&action=delete", {action:'delete'});
		myStorage.save("reg_id",  key);
		$("#see_more_friends").remove();
		$("#dashboardAreaContent_content").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');
		$("#drinkAreaContent").html('<div id="drinkAreaContentArea" class="list drink_up"><div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div></div>');
		//List.user_country();
		$("#login-form input").val('');
		$("#login-spinner").hide();
		$("#login-btn").show();
		myHistory = [];
	},
	freshStart: function() {
		Garbage.clean("currentUser");
		Garbage.clean("pushReg");
		Garbage.clean("GCMToken");
		Feed.setupUser();
		$("#see_more_friends").remove();
		$("#dashboardAreaContent_content").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');
		$("#drinkAreaContent").html('<div id="drinkAreaContentArea" class="list drink_up"><div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div></div>');
		$("#login-form input").val('');
		$("#login-spinner").hide();
		$("#login-btn").show();
		//init.setUpGeo();
		myHistory = [];
	},
	remove_extra: function(top, index) {
		var l = $("#"+top+" div.activity_stream").length;

		if (parseInt(l) > 25)
		{
			var diff = parseInt(l) - 25;

			for(i = 0; i < parseInt(diff); i++)
			{
				$("#"+top+" div.activity_stream").last().remove();
			}
		}
		else
		{
			var diff = 25 - parseInt(l);

			for(i = 0; i < parseInt(diff); i++)
			{
				$("#"+top+" div.activity_stream").last().remove();
			}
		}
	}
};

var myStorage = {
	save: function(index, data) {
		var sData = JSON.stringify(data);
		localStorage.setItem(index, sData);
	},
	token: function(access_token){
		localStorage.setItem("access_token", access_token);
	},
	view: function(d) {
		if (localStorage.getItem(d)) {
			var sData = localStorage.getItem(d);
			return JSON.parse(sData);
		}
		else
		{
			return false;
		}
	}
};

var Validate = {
	web: function(){
		if (navigator.onLine)
		{
			return true;
		}
		else
		{
			Error.offline();
		}
	},
	token: function(){

		if (localStorage.getItem("access_token"))
		{
			return localStorage.getItem("access_token");
		}
		else
		{
			return false;
		}

	}
}

var Error = {
	offline: function() {
		//alert("offline");
	},
	ajax_error: function(xhr, ajaxOptions, errorThrown) {

		if(phonegap) {
			networkState = navigator.connection.type;
			states[Connection.UNKNOWN]  = 'Unknown connection';
		    states[Connection.ETHERNET] = 'Ethernet connection';
		    states[Connection.WIFI]     = 'WiFi connection';
		    states[Connection.CELL_2G]  = 'Cell 2G connection';
		    states[Connection.CELL_3G]  = 'Cell 3G connection';
		    states[Connection.CELL_4G]  = 'Cell 4G connection';
		    states[Connection.NONE]     = 'No network connection';
		}
		else {
			networkState = "Unknown";
			states[networkState]  = 'Unknown connection';
		}

		console.log(xhr.status + " " + ajaxOptions + " " + errorThrown + " " + navigator.onLine + " " + states[networkState] + " " + !navigator.onLine);

		Spinner.off();

		var responseText = xhr.responseText;

		var status = xhr.status;

		if (xhr.status == 0 && ajaxOptions == "timeout") {

			$("#notice-error").html('');

			var object = {};

			object["message"] = "Your request has appeared to timeout. Please try your request again.";

			/*var source   = $("#error-template").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['error-template.tmpl'];
			var html = template(object);

			$("#notice-error").html(html);

			Util.openPop();

			Util.closePopTimeout(3000);

		}
		else if ((xhr.status == 0 && (ajaxOptions != "error" && ajaxOptions != "abort")) || (states[networkState] == "No network connection" || !navigator.onLine)) {

			$("#notice-error").html('');

			var object = {};

			object["message"] = "You don't appear to have network connection. Please check your connection and try again.";

			/*var source   = $("#error-template").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['error-template.tmpl'];
			var html = template(object);

			$("body").css("overflow","hidden");

			$("#notice-error").html(html);

			Util.openPop();

			Util.closePopTimeout(3000);
          
        } else if (xhr.status == 404 || xhr.status === 502 || xhr.status === 500 || xhr.status === 402) {
            
            if (responseText == "") {

            	$("#notice-error").html('');

				var object = {};

				object["message"] = "There has been an unknown error with your request. Please try again.";

				/*var source   = $("#error-template").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['error-template.tmpl'];
				var html = template(object);

				$("#notice-error").html(html);

				Util.openPop();

				Util.closePopTimeout(3000);

            }
            else {
        		var json = JSON.parse(responseText);
				var object = {};

				if (json.meta) {
					object["message"] = json.meta.error_detail;
				}
				else {
					object["message"] = json.error;
				}

				/*var source   = $("#error-template").html();
				var template = Handlebars.compile(source);*/

				var template = Handlebars.templates['error-template.tmpl'];
				var html = template(object);

				$("#notice-error").html(html);

				Util.openPop();

				Util.closePopTimeout(3000);
            }

        } else if (ajaxOptions === 'timeout' || ajaxOptions === 'parsererror') {
            
        	$("#notice-error").html('');

			var object = {};

			object["message"] = "Your connection request has appeared to timeout. Please check your connnection and try again.";

			/*var source   = $("#error-template").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['error-template.tmpl'];
			var html = template(object);

			$("#notice-error").html(html);
			
			Util.openPop();

			Util.closePopTimeout(3000);


        } else if (xhr.status === 0 && navigator.onLine) {
            
        	console.log("aborted");

        } 
        else {
           
        	$("#notice-error").html('');

			var object = {};

			object["message"] = "There has been an unknown error with your request. Please try again.";

			/*var source   = $("#error-template").html();
			var template = Handlebars.compile(source);*/

			var template = Handlebars.templates['error-template.tmpl'];
			var html = template(object);

			$("#notice-error").html(html);

			Util.openPop();

			Util.closePopTimeout(3000);

        }

		/*navigator.notificationEx.activityStop();

		console.log(xhr + " " + ajaxOptions + " " + errorThrown);

		Spinner.off();

		var responseText = xhr.responseText;

		if (phonegap) {
			networkState = navigator.network.connection.type;

			states[Connection.UNKNOWN]  = 'Unknown connection';
		    states[Connection.ETHERNET] = 'Ethernet connection';
		    states[Connection.WIFI]     = 'WiFi connection';
		    states[Connection.CELL_2G]  = 'Cell 2G connection';
		    states[Connection.CELL_3G]  = 'Cell 3G connection';
		    states[Connection.CELL_4G]  = 'Cell 4G connection';
		    states[Connection.NONE]     = 'No network connection';

			if (states[networkState] == "No network connection")
			{
				$("#notice-error").html('');

				var object = {};

				object["message"] = "You don't appear to have network connection. Please check your connection and try again.";
				var template = Handlebars.templates['error-template.tmpl'];
				var html = template(object);

				$("#notice-error").html(html);

				$("#notice_overlay").show();

				setTimeout('$("#notice_overlay").hide();', 3000);
			}
			else
			{
				if (responseText == "") {

					if (ajaxOptions == "timeout" || ajaxOptions == "parsererror") {
						$("#notice-error").html('');

						var object = {};

						object["message"] = "Something appeared to go very wrong. Please try again or contact support.";
						var template = Handlebars.templates['error-template.tmpl'];
						var html = template(object);

						$("#notice-error").html(html);

						$("#notice_overlay").show();

						setTimeout('$("#notice_overlay").hide();', 3000);
					}
				}
				else {
					var json = JSON.parse(responseText);

					console.log(json);

					var object = {};

					if (json.meta) {
						object["message"] = json.meta.error_detail;
					}
					else {
						object["message"] = json.error;
					}


					var template = Handlebars.templates['error-template.tmpl'];
					var html = template(object);

					$("#notice-error").html(html);

					$("#notice_overlay").show();

					setTimeout('$("#notice_overlay").hide();', 3000);
				}
			}
		}
		else {
			if (responseText == "") {

				if (ajaxOptions == "timeout" || ajaxOptions == "parsererror") {

					$("#notice-error").html('');

					var object = {};

					object["message"] = "Something appeared to go very wrong. Please try again.";

				
					var template = Handlebars.templates['error-template.tmpl'];
					var html = template(object);

					$("#notice-error").html(html);

					$("#notice_overlay").show();

					setTimeout('$("#notice_overlay").hide();', 3000);
				}
			}
			else {
				var json = JSON.parse(responseText);

				console.log(json);

				var object = {};

				if (json.meta) {
					object["message"] = json.meta.error_detail;
				}
				else {
					object["message"] = json.error;
				}


				var template = Handlebars.templates['error-template.tmpl'];
				var html = template(object);

				$("#notice-error").html(html);

				$("#notice_overlay").show();

				setTimeout('$("#notice_overlay").hide();', 3000);
			}
		}*/


	},
	handle: function(message, type, httpcode) {

		Spinner.off();

		$("#notice-error").html('');

		var object = {};

		object["message"] = message;

		/*var source   = $("#error-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['error-template.tmpl'];
		var html = template(object);

		$("#notice-error").html(html);

		Util.openPop();

		Util.closePopTimeout(3000);
	},
	token: function() {
		Garbage.erase();
		Page.show("#!/loginArea");
		Error.handle("Please login again.", "", "");
	},
	show: function(message) {
		Error.handle(message, "", "");
		//alert(message);

	}

}

var pBar = {
	increase: function() {

		var progress = $(".progress").attr('data-progress');

	    if (parseInt(progress) <= 100)
	    {
			var randomnumber=Math.floor(Math.random()*15)

	        var newProgress = parseInt(progress) + parseInt(randomnumber);

			if (parseInt(newProgress) >= 98)
			{
				newProgress = 98;
				$(".progress_bar").hide();
				$("#progress_status").html("Please Wait...");
			}

			$(".progress").attr('data-progress', newProgress);

			$(".progress_bar_inner").html(newProgress+"%");

	        $(".progress").attr("style", "width: "+newProgress+"%");
	    }
	    else
	    {
			$(".progress").attr('data-progress', '0');
	    }

	},
	halt: function() {

	}
}

var Stats = {
	toggleChange: function() {

		var obj = {};
		obj["message"] = "Please select the range of the states from the items below:";

		/*var source   = $("#warning-template").html();
		var template = Handlebars.compile(source);*/

		var template = Handlebars.templates['stats-select-template.tmpl']
		var html = template(obj);

		$("#notice-error").html(html);

		Util.openPop();
	},
	charts: function(a) {

		var string = "['','Check-ins'],";
		console.log(a.checkins_history);

		chartData = [];

		

		
	},
	build: function(a) {

		var low = 0;
		var high = 0;
		var med = 0;

		var xD = "";
		var yD = "";

		$(a.checkins_history).each(function(key, value) {
			$.each(value, function(key, value){

				if (parseInt(value) >= parseInt(high)) {
					high = value;
				}

				xD = xD + value + ",";
 			});
		});

		med = Math.round(parseInt(med) / 2);

		xD = xD.substring(0, (xD.length -1));

		higher = parseInt(high) + 2;


		var googleChart = "http://chart.googleapis.com/chart?chxr=0,0,"+higher+"&chxt=y&chs=600x200&cht=lc&chco=1a5a95&chds=0,"+higher+"&chd=t:"+xD+"&chg=14.3,-1,1,1&chls=2,4,0&chm=B,C5D4B5BB,0,0,0"

		//console.log(googleChart);
		//var imageURL = "<img src='"+googleChart+"' height='175' width='320' />";
		//$("#lineGraphArea").css("background", "url("+googleChart+") no-repeat center center;"); 
		//$("#lineGraphArea").css("background-color", "#FFF");

		$('<img src="'+googleChart+'" height="100" width="300" />').insertAfter('#lineGraphArea p');

	}
}

var Page = {
	exit: function() {
		navigator.app.exitApp();
	},
	change: function(page, type) {

		//alert("page called");

		Tabs.magic(page);

		if (page != "#") {

			window.location.href = page;

			//console.log("New Page: " + page);

			var new_page = page.replace("!/", "");

			var pos = window.pageYOffset;

			//console.log("POS: " + pos);

			if (!reverse)
			{
				if (parseInt(pos) != 0) {
					myStorage.save("lastScroll", pos);
					myStorage.save("lastScrollArea", new_page);
				}
			}

			if (new_page != "") {

				if (phonegap) {
					Track.page();
				}
		
				Page.transitions(page, type);
			}
		}
		else {

			if (!firstLoad) {
				Page.exit();
			}

			firstLoad = false;
		}
	},
	transitions: function(page, type) {
		if(page!='#!/dashboardArea')
		slideMenu.slidemenu(1);
		page = page.replace("!/", "");

		page_fragments = page.split("/");

		page = page_fragments[0];

		checkHash(page);

		var toPage = $(page);

		var fromPage = $("#container div.active_page");
		
		var fromID = $(fromPage).attr("id");
		if (fromID || type != "push") {

			if (type == "push") {
				myHistory.push(fromID);

				var prevPage = "#"+fromPage.attr("id");

				scrollPosition[prevPage] = window.pageYOffset;

			}
			else if (type == "back") {

				var prevPage = "#"+fromPage.attr("id");

				scrollPosition[prevPage] = window.pageYOffset;

			}
			else {
				myHistory = [];
				console.log("history empty");
			}

			if (page == "#startArea" || page == "#loginArea" || page == "#registerArea" || page == "#resetPasswordArea" || page == "#search") {

				$("#tab_bar").removeClass('show').addClass("hide");
				$(".drinkup").hide();
			}
			else {

				$("#tab_bar").removeClass('hide').addClass("show");
				$(".drinkup").show();
			}

			var token = Validate.token();

			if (token)
			{
				Menu.off();

				//console.log("PAGE - " + page);

				if ((page == "#startArea" || page == "#loginArea" || page == "#registerArea" || page == "#resetPasswordArea" || page == "") && !firstLoad)
				{
					Page.exit();
					//navigator.app.exitApp();
				}
				else
				{
					if (!reverse)
					{
						if (page == "#statsArea") {
							$("#statsAreaContent").html('<div class="loading_inner"><img src="assets/images/spinner.gif" width="24" height="24" /><br /><br /><p>Loading...</p></div>');
						}

						fromPage.removeClass("show").removeClass("active_page");
						toPage.addClass("show").addClass("active_page");

						//console.log(previousPage + " = " + fromID);

						if (previousPage == fromID) {
							callFastClick = false;
						}
						else {
							callFastClick = true;
						}	

						previousPage = fromID;

						//alert("Page Area: " + page);

						switch (page) {
							case "#photoArea":
								Feed.get_photos(page_fragments[1], page_fragments[2]);
								Feed.get_actor(page_fragments[1],page_fragments[2]);
								break;
							case "#pageArea":
								Feed.get_pages(page_fragments[1]);
								Feed.get_actor(page_fragments[1],page_fragments[2]);
								break;
							case "#topicArea":
								Feed.get_topics(page_fragments[1],page_fragments[2]);
								Feed.get_actor(page_fragments[1],page_fragments[2]);
								break;
							case "#addAction":
								Feed.add_item(page_fragments[1], page_fragments[2]);
								break;
							case "#actorlistArea":
								Feed.actor_list();
								break;
							case "#actorArea":
								Feed.actor_profile(page_fragments[1], page_fragments[2]);
								Feed.actor_profile_content(page_fragments[1], page_fragments[2]);
								break;
							case "#yourArea":
								Feed.your_profile();
								break;
							case "#profileArea":
								Feed.profile(page_fragments[1], page_fragments[2], page_fragments[3]);
								break;
							case "#storyArea":
								Feed.single_story(page_fragments[1], page_fragments[2]);
								Feed.get_comments(page_fragments[1], page_fragments[2]);
								break;
							case "#dashboardArea":
								//Feed.friends(true);
								Feed.get_stories(page_fragments[1], page_fragments[2]);
								//Feed.get_addJson();
								break;	
							case "#search":
								$("#searchArea").addClass("show active_page");
								break;	
							case "#toastList":
								var checkin_id = $("#check_view").attr("data-checkin");	
								Feed.toastList(checkin_id);
								break;
							case "#pushNotificationsSettingsGroup":
								Settings.check_status();
								break;
							case "#profileSettingsGroup":
								Settings.get_user_details();
								break;
							case "#profileInfo":
								Settings.get_user_info();
								break;
							case "#profileInfoArea":
								Feed.actor_profile_info(page_fragments[1]);
								break;
							case "#statsArea":

								if (page_fragments[1]) {
									Feed.stats(page_fragments[1]);
								}
								else {

									var dis = myStorage.view("statsRangeSettings");
									var rad = 30;

									if (!dis) {
										Feed.stats(30);
									}
									else {
										Feed.stats(dis);
									}
								}
 
								break;
							case "#statsAreaNewBeers":
								Feed.stats_new_beers();
								break;
							case "#statsAreaBeerStyle":
								Feed.stats_beer_styles(page_fragments[1]);
								break;
							case "#statsAreaNewVenues":
								Feed.stats_new_venues();
								break;
							case "#garbageOut":
								Garbage.freshStart();
								Page.change("#!/startArea");
							case "#venueArea":
								Feed.venue(page_fragments[1], page_fragments[2], page_fragments[3]);
								break;
							case "#indCheckin":
								Feed.checkin(page_fragments[1], page_fragments[2], page_fragments[3]);
								break;
							case "#wishListArea":
								Feed.wishlist(page_fragments[1], page_fragments[2], page_fragments[3]);
								break;
							case "#userFriendList":
								Feed.user_friends(page_fragments[1], page_fragments[2]);
								break;
							case "#locationArea":
								$("#venue-search-term-pre").val('');
								$("#venue-search-term-post").val('');
								Geolocate.venues(page_fragments[1]);
								break;
							case "#beerArea":
								$("#beerEditToggle").hide();
								Feed.beer(page_fragments[1], page_fragments[2], page_fragments[3]);
								break;
							case "#proposeEditArea":
								var bid = $("#beer_template").attr("data-beer");
								propose.go_to_edit(bid);
								$(".edit-beer-header").addClass("show");
								break;
							case "#proposeRateArea":
								Util.closePop();
								var bid = $("#beer_template").attr("data-beer");
								Beer.go_to_rate(bid);
								break;
							case "#proposeBarCodeArea":
								var bid = $("#beer_template").attr("data-beer");
								$("#barcode_bid").val(bid);
								break;
							case "#drinkArea":
								Geolocate.saveForCheckin();
								break;
							case "#breweryArea":
								Feed.brewery(page_fragments[1], page_fragments[2]);
								break;
							case "#discoverArea":
								Geolocate.store();
								break;
							case "#photoGallery":
								Feed.media(page_fragments[1], page_fragments[2]);
								break;
							case "#photoSingle":
								Feed.media_single(page_fragments[1], page_fragments[2]);
								break;
							case "#friendlistArea":
								Feed.friend_requests();
								break;
							case "#notificationsArea":
								Feed.notifications(page_fragments[1], page_fragments[2]);
								break;
							case "#confirmArea":
								if (page_fragments[2] && page_fragments[2] == "loc") {
									Feed.resubmit(page_fragments[1], page_fragments[2], page_fragments[3]);
								}
								else {
									Feed.confirm(page_fragments[1], page_fragments[2], page_fragments[3]);
								}
								break;
							default:
								break;
						}

						window.scroll(0,0);
						refreshScroll.go();	

						console.log("going forward");
					}
					else {

						callFastClick = false;

						reverse = false;

						console.log("backwards reverse: " + reverse);
						
						fromPage.removeClass("show").removeClass("active_page");
						toPage.addClass("show").addClass("active_page");

						if (page == "#beerArea" || page == "#venueArea" || page == "#dashboardArea" || page == "#breweryArea" || page == "#profileArea" || page == "#yourArea" || page == "#listCheckinsArea" || page == "#wishlistArea" || page == "#statsArea" || page == "#discoverBars") {
							Page.scrollMe(page, false);
						}
						else {
							Page.scrollMe(page, true);
						}

					}
				}
			}
			else {

				if (page == "#startArea" || page == "#loginArea" || page == "#registerArea" || page == "#resetPasswordArea" || page == "") {

					reverse = false;

					Page.scrollMe(page, true);

					fromPage.removeClass("show").removeClass("active_page");
					toPage.addClass("show").addClass("active_page");

				}
				else {
					Page.exit();
				}
			}

			$(".timeago").cuteTime({ refresh: 50000 });

		}
	},
	endtrans: function(toPage, fromPage, type, reverse) {

		fromPage.removeClass("show " + type + " out " + reverse);
		fromPage.addClass("hide");
		toPage.removeClass(type + " in " + reverse);
	},
	scrollMe: function(page, a) {

		console.log("PAGE IN SCROLL ME: " + page + " ("+window.pageYOffset+")");

		if (a) {
			console.log("scroll to top");
			//$.scroll(0);
			window.scrollTo(0,0);
			refreshScroll.go();	
		}
		else {

			console.log("A IS FASLE");

			if (scrollPosition[page]) {
				console.log(scrollPosition[page] + " scrolling");

				var ia = parseInt(scrollPosition[page]);

				//console.log("I want to scroll to: " + ia);

				window.scrollTo(0,ia);

				//$.scroll(ia);

				//myScroll.scrollTo(0,ia,0);

				//console.log("AFTER SCROLL: " + window.pageYOffset + "");
			}
			else {
				//console.log("There is nothing in SCROLL for " + page);
				//window.scroll(0,0);

				window.scrollTo(0,0);
				//$.scroll(0);
				//myScroll.scrollTo(0,0,0);
			}
		}
	}
}

var Location = {
	remove_location: function(a) {
		$(a).parent().parent().remove();
		$(".addLocationBtn").show();
		$("#foursquare_id").val('');
		$("#4sq").val("off");
		$("#foursquare_social").hide();
	}

}


var Nav = {
	removeA: function(arr) {
	    var what, a = arguments, L = a.length, ax;
	    while (L > 1 && arr.length) {
	        what = a[--L];
	        while ((ax= arr.indexOf(what)) !== -1) {
	            arr.splice(ax, 1);
	        }
	    }
	    return arr;
	},
	goBack:function() {
 
		if ($("#android_menu").hasClass("show")) {
			$("#android_menu").removeClass("show").addClass('hide');
		}
		else {
			console.log("back button fired");
		
			reverse = true;

			console.log(reverse);

			clearAjax();
			
			/*window.history.back();

			console.log("HASH: " + window.location.hash);

			var hash = window.location.hash;*/

			console.log("LENGTH: " + myHistory.length);

			if (myHistory.length == 0) {

				Page.exit();
			}
			else {
				console.log("BEFORE POP: " + history);

				var fromPage = $("#container div.active_page");

				var fromID = $(fromPage).attr("id");

				console.log("fromID: " + fromID);

				if (fromID == "cheersArea") {

					console.log("BEFORE: " + myHistory);

					Nav.removeA(myHistory, 'confirmArea');
					Nav.removeA(myHistory, 'locationArea');
					Nav.removeA(myHistory, 'searchlocationArea');
					Nav.removeA(myHistory, 'cheersArea');

					console.log("AFTER: " + myHistory);

					hash = myHistory.pop();

					Page.change("#!/"+hash, "back");

					checkHash("#"+hash);

				}
				else {
					hash = myHistory.pop();

					Page.change("#!/"+hash, "back");

					checkHash("#"+hash);
				}
			}
		}
		
		
	},
	threeBar: function(a, b, c, d) {
		$(a).parent().parent().find("li a").removeClass("active");

		$(a).addClass("active");

		$("."+c).hide();
		$("#"+d).show();

		if (b == "friends") {
			$("#nearby_bar").hide();
			Feed.friends(null, null);
		}
		else if (b == "pub")
		{
			$("#nearby_bar").hide();
			Feed.pub();
		}
		else {
			$("#nearby_bar").show();
			Geolocate.around_pub();
		}
	}
}

var Spinner = {
	off: function() {
		$(".apploader").hide();
	},
	on: function() {
		$(".apploader").show();
	}
}



var Menu = {
	overflow: function() {
		var currentPage = $("#container div.active_page").attr('id');

		console.log("currentP: " + currentPage);

		if (currentPage == "beerArea") {
			MenuToggle.beer();
		}
		else if (currentPage == "distinctArea") {
			MenuToggle.distinct();
		}
		else if (currentPage == "indCheckin") {
			Refresh.pull(true);
		}
	},
	overflow_on: function() {
		$(".menu-btn-option").show();
	},
	overflow_off: function() {
		$(".menu-btn-option").hide();
	},
	off: function() {
		Util.closePop();
		$("#android_menu").removeClass("show").addClass("hide");
	},
	on: function() {

		var currentPage = $("#container div.active_page").attr('id');

		console.log("currentP: " + currentPage);

		if (currentPage == "beerArea" || currentPage == "distinctArea") {
			Menu.overflow();
		}
		else {
			$("#android_menu").removeClass("hide").addClass("show");
		}
	}
}

var Directions =  {
	start: function(a,b) {

		venuePH_Lat = a;
		venuePH_Lng	= b;

		$("#directions").hide();
		$("#directionsLoader").show();

		if (navigator.geolocation) {
				navigator.geolocation.getCurrentPosition(Directions.finish, Geolocate.error, opts);
		}
		else
		{
			Error.handle("You browser doesn't support Geolcation");
		}
	},
	finish: function(pos) {

		$("#directions").show();
		$("#directionsLoader").hide();

		window.plugins.webintent.startActivity({
		    action: WebIntent.ACTION_VIEW,
		    url: "http://maps.google.com/maps?saddr="+pos.coords.latitude+","+pos.coords.longitude+"&daddr="+venuePH_Lat+","+venuePH_Lng,
		  }, function () {}, function () {
		    alert('Failed to open URL via Android Intent');
		});

		//window.location.href = "http://maps.google.com?saddr="+pos.coords.latitude+","+pos.coords.longitude+"&daddr="+venuePH_Lat+","+venuePH_Lng;
	}
}

var Refresh = {
	pull: function(a) {

		Util.closePop();

		if (phonegap) {
			Track.page();
		}

		var currentPage = $("#container div.active_page").attr('id');

		console.log(currentPage + " IS ACTIVE " +page);

		if (currentPage == "dashboardArea") {
			Feed.get_stories(true);
		}
		else if (currentPage == "topicArea") {
			Feed.get_topics();
		}
		else if (currentPage == "photoArea") {
			Feed.get_photos();
		}
		else if (currentPage == "storyArea") {
				Feed.single_story(page_fragments[1], page_fragments[2]);
				Feed.get_comments(page_fragments[1], page_fragments[2]);
		}
		else if (currentPage == "dashboardArea") {
			Feed.get_stories(true);
		}
		else if (currentPage == "discoverBreweries") {
			Discover.breweries_geolocate();
		}
		else if (currentPage == "userBadgeArea") {
			Feed.user_badges(null, 'beer', 'tab');
		}
		else if (currentPage == "findBeer") {
			Geolocate.find_beer(findBeer, true);
		}
		else if (currentPage == "venueArea") {
			var venue_id = $("#venue_tempalte").attr('data-venue');
			Feed.venue_full(venue_id);
		}
		else if (currentPage == "beerArea") {
			var bid = $("#beer_template").attr("data-beer");
			Feed.beer_full(bid);
		}
		else if (currentPage == "breweryArea") {
			var brewery_id = $("#brewery_template").attr("data-brewery");
			Feed.brewery(brewery_id, "full");
		}
		else if (currentPage == "yourArea") {
			Feed.your_profile(true);
		}
		else if (currentPage == "indCheckin") {
			Loading.on();
			var checkin_id = $("#check_view").attr("data-checkin");
			Feed.checkin(checkin_id, "full");
		}
		else if (currentPage == "locationArea") {
			Geolocate.venues(globalBID, true);
		}
		else if (currentPage == "drinkArea") {
			var drinkArea = $(".drink-up-tab:visible").attr('id');

			if (drinkArea == "drinkAreaContent") {
				init.Recent();
			}
			else {
				Feed.recommend();
			}
		}
		else if (currentPage == "profileSettingsArea") {
			init.Social();
		}
		else if (currentPage == "profileArea") {
			var user_name = $("#user_profile").attr("data-username");
			Feed.profile(user_name);
		}
		else if (currentPage == "discoverBeers") {

			Discover.beers_geolocate();
		}
		else if (currentPage == "distinctArea") {
			var user_name = $("#badgeUserName").val();
			Feed.distinct_beer(user_name);
		}
		else if (currentPage == "discoverBars") {
			$("#discoverBarsSearch").val('');
			Discover.bars_geolocate();	
		}
		else if (currentPage == "toastList") {
			var checkin_id = $("#check_view").attr("data-checkin");	
			Feed.toastList(checkin_id);
		}
		else if (currentPage == "notificationsArea") {

			var aw = $(".note-panel:visible").attr('id');

			if (aw == "note-areas") {
				Feed.notifications(true);
			}
			else {
				Feed.notifications(true, true);
			}
		}
		else if (currentPage.indexOf("Group") >= 0) {
			init.Social(true);
		}
		else {

			refreshScroll.go();
		}

	},
	active: function() {

		Menu.off();

		window.scroll(0,0);
		Spinner.on();

		var id = $("#container div.active_page").attr("id");

		Refresh.page(id);
	},
	page: function(a) {

		window.scroll(0,0);
		Spinner.on();
		var pagePath=window.location.hash;
		pagePath = pagePath.replace("!/", "");
		
		page_slices = pagePath.split("/");
		console.log(page_slices);
		var currentPage = $("#container div.active_page").attr('id');

		console.log(currentPage + " IS ACTIVE");

		if (currentPage == "dashboardArea") {
			
			var activeArea = $(".activity-tab:visible").attr('id');

			if (activeArea == "dashboardAreaContent") {
				Feed.get_stories();
			}
			else if (activeArea == "topicAreaContent") {
				Feed.get_topics();
			}
			else {
				Feed.get_photos();
			}
		
		}
		else if (currentPage == "topicArea") {
				Feed.get_topics(page_fragments[1],page_fragments[2]);
				Feed.get_actor(page_slices[1],page_slices[2]);
		}
		else if (currentPage == "photoArea") {
				Feed.get_photos(page_fragments[1],page_fragments[2]);
				Feed.get_actor(page_slices[1],page_slices[2]);
		}
		else if (currentPage == "pageArea") {
				Feed.get_pages(page_fragments[1],page_fragments[2]);
				Feed.get_actor(page_slices[1],page_slices[2]);
		}
		else if (currentPage == "userBadgeArea") {
			Feed.user_badges(null, 'beer', 'tab');
		}
		else if (currentPage == "storyArea") {
			if(page_slices[1]=='note'){
				Feed.single_story('note',page_slices[2]);
				Feed.get_comments('note',91745);
			}else if(page_slices[1]=='topic'){
				Feed.single_story('topic',page_slices[2]);
				Feed.get_comments('topic',page_slices[2]);
			}else if(page_slices[1]=='page'){
				Feed.single_story('page',page_slices[2]);
				Feed.get_comments('page',page_slices[2]);
			}else if(page_slices[1]=='photo'){
				Feed.single_story('photo',page_slices[2]);
				Feed.get_comments('photo',page_slices[2]);
			}
		}
		else if (currentPage == "actorArea") {
			Feed.actor_profile(page_slices[1], page_slices[2]);
			Feed.actor_profile_content(page_slices[1], page_slices[2]);
		}
		else if (currentPage == "findBeer") {
			Geolocate.find_beer(findBeer, true);
		}
		else if (currentPage == "venueArea") {
			var venue_id = $("#venue_tempalte").attr('data-venue');
			Feed.venue_full(venue_id);
		}
		else if (currentPage == "beerArea") {
			var bid = $("#beer_template").attr("data-beer");
			Feed.beer_full(bid);
		}
		else if (currentPage == "breweryArea") {
			var brewery_id = $("#brewery_template").attr("data-brewery");
			Feed.brewery(brewery_id, "full");
		}
		else if (currentPage == "yourArea") {
			Feed.your_profile();
		}
		else if (currentPage == "indCheckin") {
			var checkin_id = $("#check_view").attr("data-checkin");
			Feed.checkin(checkin_id, true);
		}
		else if (currentPage == "statsArea") {
			
			var a = $("#ageParam").val();

			if (a != "") {
				var dis = myStorage.view("statsRangeSettings");
				var rad = 30;

				if (!dis) {
					Feed.stats(30);
				}
				else {
					Feed.stats(dis);
				}
			}
			else {
				Feed.stats(a);
			}
		}
		else if (currentPage == "userFriendList") {
			var user_name = $("#user_profile").attr("data-username");
			Feed.user_friends(user_name, "full");
		}
		else if (currentPage == "wishListArea") {
			var user_name =  $("#activeUser").val();
			var is_your = $("#activeUserYou").val()
			Feed.wishlist(user_name, "full", user_name);
		}
		else if (currentPage == "listCheckinsArea") {
			var user_name =  $("#activeUser").val();
			Feed.full_activity(user_name);
		}
		else if (currentPage == "locationArea") {
			Geolocate.venues(globalBID, true);
		}
		else if (currentPage == "drinkArea") {
			var drinkArea = $(".drink-up-tab:visible").attr('id');

			if (drinkArea == "drinkAreaContent") {
				init.Recent();
			}
			else {
				Feed.recommend();
			}
		}
		else if (currentPage == "profileSettingsArea") {
			init.Social();
		}
		else if (currentPage == "friendlistArea") {
			console.log('log called');
			Feed.friend_requests(false, true);
		}
		else if (currentPage == "profileArea") {
			var user_name = $("#user_profile").attr("data-username");
			Feed.profile_full(user_name);
		}
		else if (currentPage == "profileInfoArea") {
			Feed.actor_profile_info(page_slices[1]);
		}
		else if (currentPage == "profileSettingsGroup") {
			Settings.get_user_details();
		}
		else if (currentPage == "profileInfo") {
			Settings.get_user_info();
		}
		else if (currentPage == "discoverBeers") {
			Discover.beers_geolocate();
		}
		else if (currentPage == "distinctArea") {
			var user_name = $("#badgeUserName").val();
			Feed.distinct_beer(user_name);
		}
		else if (currentPage == "discoverBars") {
			$("#discoverBarsSearch").val('');
			Discover.bars_geolocate();	
		}
		else if (currentPage == "notificationsArea") {

			var aw = $(".note-panel:visible").attr('id');

			if (aw == "note-areas") {
				Feed.notifications(true);
			}
			else {
				Feed.notifications(true, true);
			}
		}
		else {

			refreshScroll.go();
		}
	}
}

var Limiter = {
	limit: function(field, counter, max) {

		if ($("#"+field).val() == "") {
			$("#"+counter).html("140");
		}
		else {
			var charLen = $("#"+field).val().length;

			var diff = 140 - parseInt(charLen);

			if (diff < 0) {
				$("#"+counter).html("0");
				$("#"+field).val($("#"+field).val().substring(0, max));
			}
			else {
				$("#"+counter).html(diff);
			}
		}

	}
}


var Toggle = {
	tabs: function(a,b,c,d) {
		$("."+d+ " li a").removeClass("active");
		$(".top-tab").removeClass('active');
		$(a).addClass('active');

		$("."+b).hide();
		$("#"+c).show();
	}
}


var Tabs = {
	magic: function(hash) {

		$("#tab_bar_nav a").removeClass("active");

		switch (hash) {
			case "#!/yourArea":
				$(".tab_yourtab").addClass("active");
				break;
			case "#!/notificationsArea":
				$(".tab_notices").addClass("active");
				break;
			case "#!/dashboardArea":
				$(".tab_pub").addClass("active");
				break;
			case "#!/drinkArea":
				$(".tab_drinkup").addClass("active");
				break;
			case "#!/friendlistArea":
				$(".tab_friends").addClass("active");
				break;
			case "#!/discoverArea":
			 	$(".tab_discover").addClass("active");
				break;
			case "#!/discoverBeers":
				$(".tab_discover").addClass("active");
				break;
			default:
				break;
		}
	},
	venue: function(a,b,c) {
		$("#venue_tabs ul li a").removeClass("active");
		$(a).addClass("active");
		$("."+b).removeClass('show').addClass('hide');
		$("#"+c).removeClass('hide').addClass('show');
	}
}

function activateStar(i)
{
	$('.checkin_rating_bar li a').removeClass('on');

	$("#rating_score").val(i);

	for(a = 1; a <= 5; a++)
	{
		if (a <= i)
		{
			$("#rating_"+a).addClass('on');
		}
	}
}

var Profile = {
	your_tabs: function(a,b,c,d) {
		$("#your_profile_tabs ul li a").removeClass("active");
		$(a).addClass('active');

		$(".your_profile_three_tab").hide();

		if (b == "activity") {

			if ($("#your_activity_stream_profile").html() != "") {
				$("#your_activity_stream_profile").show();
			}
			else {
				Feed.your_profile();
			}
		}
		else if (b == "wish_list") {
			if ($("#your_wishlist_stream_profile div.list_box").length != 0) {
				$("#your_wishlist_stream_profile").show();
			}
			else
			{
				Feed.wishlist(c, true, false);
			}
		}
		else {
			if ($("#your_friends_stream_profile div.list_box").length != 0) {
				$("#your_friends_stream_profile").show();
			}
			else
			{
				Feed.user_friends(c, true, false);
			}
		}
	},
	tabs: function(a, b, c) {

		$("#profile_tabs ul li a").removeClass("active");
		$(a).addClass('active');

		$(".profile_three_tab").hide();

		if (b == "activity") {

			if ($("#activity_stream_profile").html() != "") {
				$("#activity_stream_profile").show();
			}
			else {
				Feed.profile(c);
			}


		}
		else if (b == "wish_list") {
			if ($("#wishlist_stream_profile div.list_box").length != 0) {
				$("#wishlist_stream_profile").show();
			}
			else
			{
				Feed.wishlist(c, false, false);
			}
		}
		else {
			if ($("#friends_stream_profile div.list_box").length != 0) {
				$("#friends_stream_profile").show();
			}
			else
			{
				Feed.user_friends(c, false, false);
			}
		}
	}
}

var Filter = {
	toggle: function(a) {

		if ($("#"+a).hasClass('vis')) {
			$("#"+a).show();
			$("#"+a).removeClass("vis");
		}
		else {
			$("#"+a).addClass("vis");
			$("#"+a).hide();
		}

	}
}

var Loading = {
	on: function(a){
		$("#loading-overlay").addClass("loading");
	},
	off: function(a) {
		$("#loading-overlay").removeClass("loading");
	}
}

var init = {
	setUpGeo: function() {
		Geolocate.store();
	},
	Social: function(a) {

		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var c =  parseInt(Math.random()*99999999);

			var h  = host + "/account/usersettings?access_token="+token+"&_"+c;

			$.ajax({
				url: h,
				type: "GET",
				data: "",
				dataType: "json",
			    error: function(html)
				{
					// error goes here
				},
				success: function(html)
				{
					myStorage.save("socialSettings", html.response);

					Settings.init(html.response);

					refreshScroll.go();
				}
			});
		}
	},
	Recent: function(a) {
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var url_post;

			if (a) {
				
				$("#recent_beer_loader").show();
				$("#recent_beer_more").hide();

				var offset = $(".beer_recent").length;
				url_post = host + "/helpers/refresh_recent?access_token="+token+"&offset="+offset;
			}
			else {
				url_post = host + "/helpers/refresh_recent?access_token="+token;
			}

			$.ajax({
				url: url_post,
				type: "GET",
				data: "",
				dataType: "json",
			    error: function(html)
				{
					Spinner.off();

					if (a) {

						$("#recent_beer_loader").hide();
						$("#recent_beer_more").show();
						Error.ajax_error(xhr, ajaxOptions, thrownError);
					}

					// error goes here
				},
				success: function(html)
				{
					if (html.meta.code == 200)
					{
						/*if (html.notifications.unread_count.friends >= 1) {
							$("#pendingFriendsNotice").prepend('<span class="pending">!</span>');
						}
						else {
							$("#pendingFriendsNotice span.pending").remove();
						}*/

						var source   = $("#drink-up-template").html();

						Spinner.off();

						if (a) {

							if (html.response.count == 0) {
								$("#recent_beer_loader").hide();
								$("#recent_beer_more").hide();
							}
							else {
								$("#recent_beer_loader").hide();
								$("#recent_beer_more").show();
							}

							var template = Handlebars.templates['drink-up-template.tmpl'];
							var drinkUp = template(html.response);

							$("#drinkAreaContentArea").append(drinkUp);
						}
						else {

							if (html.response.count == 0) {

								var obj = {};
								obj["h2_message"] = "You haven't checked in any beers yet!";
								obj["h3_message"] = "Starting searching today!";

								var template = Handlebars.templates['empty-list-box.tmpl']

								var drinkUp = template(obj);

								$("#drinkAreaContentArea").html(drinkUp);
							}
							else {
								/*var template = Handlebars.compile(source);
								var drinkUp = template(html.response);*/

								var template = Handlebars.templates['drink-up-template.tmpl'];
								var drinkUp = template(html.response);

								$("#drinkAreaContentArea").html(drinkUp);

								if ($(".beer_recent").length >= 5 && $("#recent_beer_more").length == 0) {
									$("#drinkAreaContentArea").after('<div id="recent_beer_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="recent_beer_more" href="javascript:void(0);" onclick="init.Recent(true);" class="yellow_btn small">See More Recent Beers</a>');

								}
							}


						}	

						
						refreshScroll.go();
					}
				}
			});
		}
	},
	setupUser: function(a){
		var token = Validate.token();

		if (!token)
		{
			Error.token();
		}
		else
		{
			var yourProfile = myStorage.view("yourProfile");

			if (!yourProfile) {

			}
			else {

				console.log("full template now");
				
				Template.your_full_profile("yourAreaContent", yourProfile);
			}

			_isAlreadySet = true;

			$.ajax({
				url: host + "/user/info?access_token="+token,
				type: "GET",
				data: "",
				dataType: "json",
			    error: function(html)
				{
					// error goes here
				},
				success: function(html)
				{
					if (html.meta.code == 200)
					{
						Notifications.set(html.notifications);

						/*if (html.notifications.unread_count.friends >= 1) {
							if ($("#pendingFriendsNotice span.pending").length == 0) {
								$("#pendingFriendsNotice").prepend('<span class="pending">!</span>');	
							}
						}
						else {
							$("#pendingFriendsNotice span.pending").remove();
						}*/

						myStorage.save("yourProfile", html.response);

						if (a) {

							if (a == "twitter") {
								if (html.response.user.contact.twitter) {
									console.log("linked");
								}
								else {
									console.log("unlinked");
								}
							}
							else if (a == "facebook") {

								if (html.response.user.contact.facebook) {
									console.log("linked");
								}
								else {
									console.log("unlinked");
								}
							}
							else if (a == "foursquare") {

								if (html.response.user.contact.foursquare) {
									console.log("linked");
								}
								else {
									console.log("unlinked");
								}
							}
							else {
								console.log("unlinked");
							}
						}
						else {
							/*var source   = $("#drink-up-template").html();
							var template = Handlebars.compile(source);*/

							if (html.response.user.recent_brews.count == 0) {
								var obj = {};
								obj["h2_message"] = "You haven't checked in any beers yet!";
								obj["h3_message"] = "Starting searching today!";

								var template = Handlebars.templates['empty-list-box.tmpl']

								var drinkUp = template(obj);

								$("#drinkAreaContentArea").html(drinkUp);
							}
							else {
								var template = Handlebars.templates['drink-up-template.tmpl'];

								var drinkUp = template(html.response.user.recent_brews);

								$("#drinkAreaContentArea").html(drinkUp);

								if ($(".beer_recent").length >= 5 && $("#recent_beer_more").length == 0) {
									$("#drinkAreaContentArea").after('<div id="recent_beer_loader" class="loading_inner" style="display: none;"><img src="assets/images/spinner.gif" width="24" height="24" /></div><a rel="action-btn" id="recent_beer_more" href="javascript:void(0);" onclick="init.Recent(true);" class="yellow_btn small">See More Recent Beers</a>');

								}

							}

							var template = Handlebars.templates['your-profile-template.tmpl'];
							var yourProfile = template(html.response);

							$("#yourAreaContent").html(yourProfile);

			
							if (html.response.user.checkins.count == 0) {

								var obj = {};
								obj["h2_message"] = "You haven't checked in any beers yet!";
								obj["h3_message"] = "";

								var template = Handlebars.templates['empty-list-box.tmpl']

								var yourCheckins = template(obj);

								$("#your_activity_stream_profile_content").html(yourCheckins);
							}
							else {
								var template = Handlebars.templates['activity-template.tmpl'];

								var yourCheckins = template(html.response.user);

								$("#your_activity_stream_profile_content").html(yourCheckins);
							}
						}

						refreshScroll.go();

					}
				}
			});

		}
	},
	legacy: function() {
		var token = Validate.token();
		if (token && myStorage.view("currentUser"))
		{
			clearAjax();

			var endURL = host+"/index.php?option=com_stories&view=stories&filter=leaders&format=json";

			ajaxStatement = $.ajax({
				url: endURL,
				type: "GET",
				dataType: "json",
				error: function(xhr,ajaxOptions, thrownError)
				{
					$("#see_more_user_friends").show();
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					Error.ajax_error(xhr, ajaxOptions, thrownError);
				},
				success: function(data)
				{
					console.log(data);
					$("#see_more_user_friends_loader").hide();
					Spinner.off();
					if (data)
					{
						//Notifications.set(data.notifications);

						friends = data;

						if (friends.data.length == 0) {
							$("#see_more_user_friends").show();
						}

						var path = "userFriendListContentArea";

						Template.get_stories(path, friends, a, b);
					}
					else
					{
						Error.handle(data.meta.error_detail, data.meta.error_type, data.meta.code)
					}
				}
			});
		
		}
		else
		{
			//List.user_country();
			//window.location.href = "#!/startArea";
			Page.change("#!/startArea", "start");

		}


	}
}

var fasterClick = function() {
	//var fastClickButton = document.body;
	//new FastClick(fastClickButton);
	//FastClick.attach(document.body);
}

var Util = {
	closePop: function() {
		//$("body").removeClass("overlayOpen");
		$("#notice_overlay").hide();
		$("#notice-error").hide();
	},
	openPop: function() {
		$("#notice-error").show();
		$("#notice_overlay").show();
		//$("body").addClass("overlayOpen");
	},
	closePopTimeout: function(time) {
		setTimeout('$("#notice_overlay").hide(); $("#notice-error").hide(); $("#main-content").removeClass("noScroll");', time);
	}
}

var refreshScroll = {
	go: function(a) {
		
		setTimeout(function () {
			
			$(".lazy").unveil();

			if (a == "comment") {
				Comment.focus();
			}	

		}, 0);
		Spinner.off();
	}
}


